
#define NV04_DMA_METHOD_OFFSET  12:2
#define NV04_DMA_SUBCH          15:13
#define NV04_DMA_METHOD_COUNT   24:18

#define NV04_DMA_SET_OBJECT     0x00000000 




void DmaTest3dOld( _Nv04Device * nv ,  _MemInstance * dmaInst )
{
  
  unsigned long i , status , Put , Get , *CmdRingBuffer , RingBufferAddress , RingBufferMask , demoBuffer[16 << 2] , SubCh , Obj , TlvertexBase ;
  int   memFile ;
  int   demoFile ;
  char *memFileName  = "/dev/mem" ; 
  char *demoFileName = "/rsys/amber/lsys/a3/3DBufferq3.bin" ;
  
  RingBufferAddress = 0x02000000 ; RingBufferMask = 0x007fffff >> 2 ; /* 8 MB Command ring buffer */ 
  
  Put = 0x00000000 ; Get = 0x00000000 ;
  
  memFile = open( memFileName , O_RDWR ) ;
  if ( memFile == -1 ) { printf("error open mem %s %d %s\n", memFileName , errno , strerror(errno)) ; return ; }
  
  CmdRingBuffer = (void *) mmap( NULL , RingBufferMask + 1 , PROT_READ | PROT_WRITE , MAP_SHARED , memFile , RingBufferAddress ) ;
  if ( CmdRingBuffer == (void *) -1 ) { printf("error maping mem physAdd = 0x%8.8lX mask = 0x%8.8lX  %d %s\n",RingBufferAddress,RingBufferMask,errno,strerror(errno)) ; return ; }
  
  demoFile = open( demoFileName , O_RDONLY ) ;
  if ( memFile == -1 ) { printf("error open demofile  %s %d %s\n", memFileName , errno , strerror(errno)) ; return ; }
  
  
  SubCh = 5 ; Obj = 0x80000014 ;
  
  CmdRingBuffer[Put++] = ( (( NV04_DMA_SET_OBJECT >> 2 ) << (0 ?  NV04_DMA_METHOD_OFFSET)) | ( SubCh << ( 0 ? NV04_DMA_SUBCH )) | ( 0x0001 << ( 0 ? NV04_DMA_METHOD_COUNT))) ; Put &= RingBufferMask ;
  CmdRingBuffer[Put++] = Obj ;  Put &= RingBufferMask ;
  
 loop1:
  status = read( demoFile , &demoBuffer , sizeof(demoBuffer)) ; 
 
  if (status == sizeof(demoBuffer))
    {  
      switch (demoBuffer[0])
	{
	case 0x80000001:
	  CmdRingBuffer[Put++] = ( (( 0x0300 >> 2 ) << (0 ?  NV04_DMA_METHOD_OFFSET)) | ( SubCh << ( 0 ? NV04_DMA_SUBCH )) | ( 0x0007 << ( 0 ? NV04_DMA_METHOD_COUNT))) ; Put &= RingBufferMask ;
	  CmdRingBuffer[Put++] = demoBuffer[1] ;  Put &= RingBufferMask ;
	  CmdRingBuffer[Put++] = demoBuffer[2] + 0x02000000 ;  Put &= RingBufferMask ;
	  CmdRingBuffer[Put++] = demoBuffer[3] ;  Put &= RingBufferMask ;
	  CmdRingBuffer[Put++] = demoBuffer[4] ;  Put &= RingBufferMask ;
	  CmdRingBuffer[Put++] = demoBuffer[5] ;  Put &= RingBufferMask ;
	  CmdRingBuffer[Put++] = demoBuffer[6] ;  Put &= RingBufferMask ;
	  CmdRingBuffer[Put++] = demoBuffer[7] ;  Put &= RingBufferMask ;
	  
	  for( i = Get ; i < Put ; i = (i + 1)  & RingBufferMask ) printf("DmaBuffer[0x%8.8lX] =0x%8.8lX\n", i << 2 , CmdRingBuffer[i] ) ;
	  
	  Nv04_fifoSetupNv04ChannelDma( nv , 0 , dmaInst->base , RingBufferAddress , Put << 2 , Get << 2 ) ;
	  
	  getchar() ;
	  
	  Get = Put ;

	  break ;
	  
	case 0x80000002:
	  TlvertexBase = 0x0400 + ( demoBuffer[1] * 0x0020 ) ; 
	  CmdRingBuffer[Put++] = ( (( TlvertexBase >> 2 ) << (0 ?  NV04_DMA_METHOD_OFFSET)) | ( SubCh << ( 0 ? NV04_DMA_SUBCH )) | ( 0x0008 << ( 0 ? NV04_DMA_METHOD_COUNT))) ; Put &= RingBufferMask ;
	  CmdRingBuffer[Put++] = demoBuffer[2] ;  Put &= RingBufferMask ;
	  CmdRingBuffer[Put++] = demoBuffer[3] ;  Put &= RingBufferMask ;
	  CmdRingBuffer[Put++] = demoBuffer[4] ;  Put &= RingBufferMask ;
	  CmdRingBuffer[Put++] = demoBuffer[5] ;  Put &= RingBufferMask ;
	  CmdRingBuffer[Put++] = demoBuffer[6] ;  Put &= RingBufferMask ;
	  CmdRingBuffer[Put++] = demoBuffer[7] ;  Put &= RingBufferMask ;
	  CmdRingBuffer[Put++] = demoBuffer[8] ;  Put &= RingBufferMask ;
	  CmdRingBuffer[Put++] = demoBuffer[9] ;  Put &= RingBufferMask ;
	  break ;
      
	case 0x80000003:
	  CmdRingBuffer[Put++] = ( (( 0x0600 >> 2 ) << (0 ?  NV04_DMA_METHOD_OFFSET)) | ( SubCh << ( 0 ? NV04_DMA_SUBCH )) | ( 0x0001 << ( 0 ? NV04_DMA_METHOD_COUNT))) ; Put &= RingBufferMask ;
	  CmdRingBuffer[Put++] = demoBuffer[1] ;  Put &= RingBufferMask ;
	  break ;
	}
      goto loop1 ;
    }     
  close(memFile) ; close(demoFile) ;
}

    
