
#define Nv04_FB_RAM_SIZE              0x02000000 /* 32 MB on card mem              */ 

#define Nv04_DMA_TYPE_AGP             0x00000001 /* 0 = PCI  1 = AGP               */
#define Nv04_DMA_AGP_RATE             0x00000002 /* 1 = X1 , 2 = X2 , 4 = X4       */
#define Nv04_DMA_AGP_SBA              0x00000001 /* can use side band addressing   */ 
#define Nv04_DMA_BASE                 0x02000000 /* base address of dma ram        */
#define Nv04_DMA_LIMIT                0x01ffffff /* offset limit of dma ram 32 MB  */ 

#define Nv04_DMA_COMMAND_RING_BASE    0x02000000
#define Nv04_DMA_COMMAND_RING_SIZE    0x00010000 /* 64K for commands  */
#define Nv04_DMA_COMMAND_RING_TEST    0x00000001 /* 1 = test buffer    */

#define Nv04_DMA_TEXTURE_BUFFER_BASE  0x02200000  
#define Nv04_DMA_TEXTURE_BUFFER_SIZE  0x01e00000 /* 30 Mb for textures */

#define Nv04_TEST_VIDEO_RES                    3 /* 1024x768 71Hz . the screen's are defined in Timeing.dat */  
#define Nv04_TEST_VIDEO_DEPTH                 24 /* not BPP */ /* not used */
 
_pcidev devs[] =               /* list of nv's cards for autofind */
{
  { 0x10de , 0x0028 , 0x0000 },
  { 0x10de , 0x0029 , 0x0000 }, 	
  { 0x0000 , 0x0000 , 0x0000 }
} ;

#define Nv04_PCI_AUTOFIND_DoNotUseIoEnabledCard  0x00000000 /* 1 = skip nv cards that have io enable NOT WORKING */
