#include "nv04regdebug.h"

void Nv04_PrintReg( unsigned long reg , unsigned long data , unsigned long flag , char * leadtext )
{

  /* THIS HAS TO BE COMPLETLY REDONE !!!!!!!!!!!!!!!!! */

  unsigned long i , size ,d ,n , vf = 0 , mask = 0x00  ,nf , br , rp  ;
  size = sizeof( Nv04RegsDebug ) / sizeof( _Nv04RegDebug ) ;
  
  for ( i = 0 ; i < size ; i++ ) if ( reg == Nv04RegsDebug[i].reg ) break  ;

  if (0) printf("found reg = %8.8lX i = %8.8lX\n",reg,i) ;

  if ( i < size )
    {
      rp = i ;
    loop1:
      if ( i < (size - 1)) 
	{
	  n  =     ((Nv04RegsDebug[i].reg  == Nv04RegsDebug[i+1].reg)) ; 
	  nf = n & ((Nv04RegsDebug[i].bith == Nv04RegsDebug[i+1].bith) & (Nv04RegsDebug[i].bitl == Nv04RegsDebug[i+1].bitl)) ;
	}
      else 
	{
	n = 0 ; nf = 0 ;
	}
      
      br = (Nv04RegsDebug[i].bith - Nv04RegsDebug[i].bitl) + 1 ;

      if ((br < 32) & (br > 1)) mask = (( 1 << br ) - 1) << Nv04RegsDebug[i].bitl ;
      else 
	{
	  if ( br == 32 ) mask = 0xffffffff ;
	  if ( br ==  1 ) mask = 0x00000001 << Nv04RegsDebug[i].bitl ;
	}
     

      d = ( data & mask) >> Nv04RegsDebug[i].bitl ;

      if (0) printf("data = %8.8lX mask = %8.8lX d = %8.8lX\n",data,mask,d) ;
      
      if (Nv04RegsDebug[i].flag == 1) 
	{ 	  
	  if (flag & 2) 
	    { 
	      if ((d == Nv04RegsDebug[i].val) & (d != 0x00)) 
		{  
		  printf("%s%s\n",leadtext,Nv04RegsDebug[i].name) ;
		  vf = 1 ;
		}
	    }
	  else
	    {
	    if (d == Nv04RegsDebug[i].val) 
	      {
		printf("%s%s\n",leadtext,Nv04RegsDebug[i].name) ;
		vf = 1 ;
	      }
	    }
	}
      else
	{
	  if ( flag & 1 ) d = d * Nv04RegsDebug[i].adjust ;	  
	  if (!nf) { printf("%s%s = %8.8lX\n",leadtext,Nv04RegsDebug[i].name,d) ; vf = 1 ; }
	}
      if (n) { i++ ; goto loop1 ; }
      if (vf) printf("%s%s = %8.8lX\n",leadtext,Nv04RegsDebug[rp].name,d) ;
    }
}


void PrintCtx(_Nv04Device *nv) 
{
  unsigned long i , ctx1 ,ctx2,ctx3,ctx4 ,fifo ;

  fifo = getreg( NV_PGRAPH_FIFO ) ; setreg ( NV_PGRAPH_FIFO , NV_PGRAPH_FIFO_ACCESS_DISABLED << ( 0 ? NV_PGRAPH_FIFO_ACCESS )) ;

  i = 0 ;
  ctx1 = getreg( NV_PGRAPH_CTX_SWITCH1 ) ;
  ctx2 = getreg( NV_PGRAPH_CTX_SWITCH2 ) ;
  ctx3 = getreg( NV_PGRAPH_CTX_SWITCH3 ) ;
  ctx4 = getreg( NV_PGRAPH_CTX_SWITCH4 ) ;
  
      printf("ctx switch    ctx1 = %8.8lX ctx2 = %8.8lX ctx3 = %8.8lX ctx4 = %8.8lX\n",ctx1,ctx2,ctx3,ctx4) ;


  for ( i = 0 ; i < 8 ; i++)
    {
      ctx1 = getreg( NV_PGRAPH_CTX_CACHE1(i) ) ;
      ctx2 = getreg( NV_PGRAPH_CTX_CACHE2(i) ) ;
      ctx3 = getreg( NV_PGRAPH_CTX_CACHE3(i) ) ;
      ctx4 = getreg( NV_PGRAPH_CTX_CACHE4(i) ) ;
     
      printf("ctx cache(%lX)  ctx1 = %8.8lX ctx2 = %8.8lX ctx3 = %8.8lX ctx4 = %8.8lX\n",i,ctx1,ctx2,ctx3,ctx4) ;
    }
  
  setreg ( NV_PGRAPH_FIFO , fifo ) ;

}
void PrintHash(_Nv04Device *nv)
{
  unsigned long i , objid , context , ctxadd , ctx1,ctx2,ctx3,ctx4 ;


  printf("dumping hash table\n") ;
  
  for (i = 0 ; i < 512 ; i++) 
    {
      objid   = getreg( ( 0 ? NV04_PRAMIN ) + nv->info.HashMem->base + (((i * 2) + 0) << 2) ) ;
      context = getreg( ( 0 ? NV04_PRAMIN ) + nv->info.HashMem->base + (((i * 2) + 1) << 2) ) ;
      
      ctxadd = (context & 0xfffff) << 2 ; 
      
      ctx1 = getreg( ((0 ? NV04_PRAMIN) ) + ((ctxadd + 0) << 2) ) ; 
      ctx2 = getreg( ((0 ? NV04_PRAMIN) ) + ((ctxadd + 1) << 2) ) ; 
      ctx3 = getreg( ((0 ? NV04_PRAMIN) ) + ((ctxadd + 2) << 2) ) ; 
      ctx4 = getreg( ((0 ? NV04_PRAMIN) ) + ((ctxadd + 3) << 2) ) ; 
  

      if (objid) printf("Obj id = %8.8lX    context = %8.8lX  ctxadd = %8.8lX  ctx1:%8.8lX ctx2:%8.8lX ctx3:%8.8lX ctx4:%8.8lX \n",objid,context,(ctxadd << 2),ctx1,ctx2,ctx3,ctx4) ;
    }
  /*
  for ( i = 0x200 ; i < 0x1000 ; i++ )
    {
      data = getreg( ((0 ? NV_PRAMIN) ) + i].D32 ;
      if (data) printf("i = %8.8lX data = %8.8lX \n",i,data) ;
    }
  */
}

unsigned long dmaregs[] = 
{
  NV_PGRAPH_DMA_START_0      ,
  NV_PGRAPH_DMA_START_1      ,
  NV_PGRAPH_DMA_LENGTH       ,
  NV_PGRAPH_DMA_MISC         ,
  NV_PGRAPH_DMA_DATA_0       ,
  NV_PGRAPH_DMA_DATA_1       ,
  NV_PGRAPH_DMA_RM           ,
  NV_PGRAPH_DMA_A_XLATE_INST ,
  NV_PGRAPH_DMA_A_CONTROL    ,
  NV_PGRAPH_DMA_A_LIMIT      ,
  NV_PGRAPH_DMA_A_TLB_PTE    ,
  NV_PGRAPH_DMA_A_TLB_TAG    ,
  NV_PGRAPH_DMA_A_ADJ_OFFSET ,
  NV_PGRAPH_DMA_A_OFFSET     ,
  NV_PGRAPH_DMA_A_SIZE       ,
  NV_PGRAPH_DMA_A_Y_SIZE     ,

  NV_PGRAPH_DMA_B_XLATE_INST  ,
  NV_PGRAPH_DMA_B_CONTROL     ,
  NV_PGRAPH_DMA_B_LIMIT       ,
  NV_PGRAPH_DMA_B_TLB_PTE     ,
  NV_PGRAPH_DMA_B_TLB_TAG     ,
  NV_PGRAPH_DMA_B_ADJ_OFFSET  ,
  NV_PGRAPH_DMA_B_OFFSET      ,
  NV_PGRAPH_DMA_B_SIZE        ,
  NV_PGRAPH_DMA_B_Y_SIZE      ,
  0xffffffff 
} ;


void dumpdma(_Nv04Device * nv)
{
  unsigned long fifo , i ;
  fifo = getreg( NV_PGRAPH_FIFO ) ; setreg ( NV_PGRAPH_FIFO , NV_PGRAPH_FIFO_ACCESS_DISABLED << ( 0 ? NV_PGRAPH_FIFO_ACCESS )) ;
  
  for ( i = 0 ; dmaregs[i] != 0xffffffff ; i++ ) Nv04_PrintReg(dmaregs[i] , getreg( dmaregs[i] ) , 1 , "Nv04: ") ; 
  
  setreg( NV_PGRAPH_FIFO , fifo ) ;
  
}

unsigned long fifoSetupRegsTable[] =
{

  NV_PFIFO_INTR_EN_0             ,
  NV_PFIFO_RAMHT                 ,
  NV_PFIFO_RAMFC                 ,
  NV_PFIFO_RAMRO                 ,
  0xffffffff 
} ;

unsigned long fifoDmaRegsTable[] =
{
  NV_PFIFO_INTR_0                ,
  NV_PFIFO_CACHE1_PUSH1          ,
  NV_PFIFO_CACHE1_GET            ,
  NV_PFIFO_CACHE1_PUT            ,
  NV_PFIFO_CACHE1_DMA_PUSH       ,
  NV_PFIFO_CACHE1_DMA_FETCH      ,
  NV_PFIFO_CACHE1_DMA_GET        ,
  NV_PFIFO_CACHE1_DMA_PUT        ,
  NV_PFIFO_CACHE1_DMA_STATE      ,
  NV_PFIFO_CACHE1_DMA_INSTANCE   ,
  NV_PFIFO_CACHE1_DMA_CTL        ,
  NV_PFIFO_CACHE1_DMA_LIMIT      ,
  NV_PFIFO_CACHE1_DMA_TLB_TAG    ,
  NV_PFIFO_CACHE1_DMA_TLB_PTE    ,
 
  0xffffffff 
} ;
unsigned long fifoDmaRegsTableA[] =
{
  NV_PFIFO_CACHE1_GET            ,
  NV_PFIFO_CACHE1_PUT            ,

  0xffffffff 
} ;

unsigned long fifoSetup1RegTable[] =
{
  NV_PFIFO_DELAY_0               ,
  NV_PFIFO_PIO_TIMESLICE         ,
  NV_PFIFO_PIO_TIMESLICE         ,
  NV_PFIFO_TIMESLICE             ,
  NV_PFIFO_NEXT_CHANNEL          ,
  NV_PFIFO_DEBUG_0               ,
  NV_PFIFO_INTR_0                ,
  NV_PFIFO_CACHES                ,
  NV_PFIFO_MODE                  ,
  NV_PFIFO_DMA                   ,
  NV_PFIFO_SIZE                  ,
  0xffffffff
} ;

unsigned long fifoCache0[] =
{
  NV_PFIFO_CACHE0_PUSH0          ,
  NV_PFIFO_CACHE0_PUSH1          , 
  NV_PFIFO_CACHE0_PULL0          ,  
  NV_PFIFO_CACHE0_PULL1          ,
  NV_PFIFO_CACHE0_HASH           ,
  NV_PFIFO_CACHE0_STATUS         ,
  NV_PFIFO_CACHE0_PUT            ,
  NV_PFIFO_CACHE0_GET            ,
  NV_PFIFO_CACHE0_ENGINE         ,
  0xffffffff 
} ;

unsigned long fifoCache1RegTable[] =
{
  NV_PFIFO_CACHE1_PUSH0          ,
  NV_PFIFO_CACHE1_PUSH1          ,
  NV_PFIFO_CACHE1_PULL0          ,
  NV_PFIFO_CACHE1_PULL1          ,
  NV_PFIFO_CACHE1_HASH           ,
  NV_PFIFO_CACHE1_STATUS         ,
  NV_PFIFO_CACHE1_PUT            ,
  NV_PFIFO_CACHE1_GET            ,
  NV_PFIFO_CACHE1_ENGINE         ,
  0xffffffff
} ;

unsigned long fifo_runout[] =
{
  NV_PFIFO_RUNOUT_STATUS ,
  NV_PFIFO_RUNOUT_PUT    ,
  NV_PFIFO_RUNOUT_GET    ,
  0xffffffff 
}  ;

unsigned long fifoRunOutRegTable[] =
{
  NV_PFIFO_RUNOUT_PUT            ,
  NV_PFIFO_RUNOUT_GET            ,           
  0xffffffff          
} ;

unsigned long dmastatus[] =
{
  NV_PFIFO_CACHE1_DMA_PUSH       ,
  NV_PFIFO_CACHE1_DMA_STATE      ,
  NV_PFIFO_CACHE1_DMA_GET        ,
  NV_PFIFO_CACHE1_DMA_PUT        ,
  NV_PFIFO_CACHE1_DMA_LIMIT      ,
  NV_PFIFO_CACHE1_STATUS         ,
  NV_PFIFO_CACHE1_HASH           ,
  0xffffffff 
} ;

void dumpRegs(_Nv04Device * nv , unsigned long *list) 
{
  unsigned long i ;
   
  for ( i = 0 ; list[i] != 0xffffffff ; i++ ) Nv04_PrintReg(list[i] , getreg( list[i] ) , 1 , "Nv04: ") ; 
 
} 


void clrdma(_Nv04Device * nv)
{
  unsigned long fifo , i ;

  fifo = getreg( NV_PGRAPH_FIFO ) ; setreg ( NV_PGRAPH_FIFO , NV_PGRAPH_FIFO_ACCESS_DISABLED << ( 0 ? NV_PGRAPH_FIFO_ACCESS )) ;
  
  for ( i = 0 ; dmaregs[i] != 0xffffffff ; i++ ) setreg( dmaregs[i] , 0x00000000 ) ; 
  
  
  setreg ( NV_PGRAPH_FIFO , fifo ) ;
  
} 
