
int Nv04_DmaPio(_Nv04Device *nv , _Nv04_VideoUser * user)
{
  unsigned long i , count , mc ,bc , SubCh , MOffset ,MCount , a ,d  ;
  
  if ( user->DmaCmd.Get == user->DmaCmd.Put ) return(0) ;

  if ( user->DmaCmd.Get >  user->DmaCmd.Put ) count =  (user->DmaCmd.BufferMask + 1 + user->DmaCmd.Put) -  user->DmaCmd.Get ;
  else
    count =  user->DmaCmd.Put - user->DmaCmd.Get ;

  printf("\nNv04: START\n") ;
  Nv04_PrintReg( NV_PGRAPH_FIFO , getreg(NV_PGRAPH_FIFO) , 0 , "Nv04: " ) ;
  dumpRegs(nv,fifoCache1RegTable) ; 
  PrintCtx( nv ) ;
  Nv04_PrintPGRAPH( nv ) ;

  if(1)
    for ( i = 0 ; i < 256 ; i++ ) 
      {
	a =  getreg( NV_PFIFO_CACHE1_METHOD(i)) ; d = getreg( NV_PFIFO_CACHE1_DATA(i)) ; 
		    printf("Nv04: PFIFO_CACHE1 [0x%4.4lX] = SubCh %1.1lX Method 0x%8.8lX Data 0x%8.8lX\n",i << 3 , ((a >> 13) & 0x07) , ( a & 0xffff1ffc ) , d) ;
      }
  
  
  i = user->DmaCmd.Get ;
  for ( bc = 0 ; bc < count ; bc++ )
    {
      if ( (user->DmaCmd.Buffer[i] & 0xe0000000) == 0x00000000 )
	{
	  
	  SubCh   = (  user->DmaCmd.Buffer[i] & 0x0000e000 ) >> 13 ;
	  MOffset = (  user->DmaCmd.Buffer[i] & 0x00001ffc ) >>  0 ;
	  MCount  = (  user->DmaCmd.Buffer[i] & 0x1ffc0000 ) >> 18 ;
	  
	  i = ( i + 1 ) & user->DmaCmd.BufferMask ;

	  Nv04_TestFifoFree( nv , SubCh , 0x08 ) ;
	  
	  for ( mc = 0 ; mc < MCount ; mc++ , bc++ , i = ( i + 1 ) & user->DmaCmd.BufferMask )
	    {
	      if(0) printf("i = 0x%8.8lX  SubCh = %ld  M = [0x%4.4lX] = 0x%8.8lX\n",i,SubCh,MOffset + ( mc << 2) ,user->DmaCmd.Buffer[i] ) ;
	      setreg( 0x00800000 + (SubCh << 13) + MOffset + (mc << 2) , user->DmaCmd.Buffer[i]) ; 
	    } 
	}
      else
	if ( ( user->DmaCmd.Buffer[i] & 0xe0000000) == 0x00 ) i = ( i + 1 ) & user->DmaCmd.BufferMask ;
      printf("i = 0x%8.8lX\n",i) ;
    }
  return(0) ;
}
  




