
void Nv04_grSetSurface(_Nv04Device * nv , _Nv04_VideoUser * user)
{

  unsigned long cv , t ;
 
  setreg( NV_PGRAPH_BBASE(0)   , 0x00000000 ) ;
  setreg( NV_PGRAPH_BLIMIT(0)  , 0x01ffffff ) ;
  setreg( NV_PGRAPH_BOFFSET(0) , user->Screen->base  ) ;
  setreg( NV_PGRAPH_BPITCH(0)  , user->BytesPerLine ) ;

  setreg( NV_PGRAPH_BBASE(1)   , 0x00000000 ) ;
  setreg( NV_PGRAPH_BLIMIT(1)  , 0x01ffffff ) ;
  setreg( NV_PGRAPH_BOFFSET(1) , user->Screen->base  ) ;
  setreg( NV_PGRAPH_BPITCH(1)  , user->BytesPerLine ) ;
 
  switch( user->ColourDepth )
    {
    case  4: cv = NV_PGRAPH_BPIXEL_DEPTH0_INVALID   ; break ;
    case  8: cv = NV_PGRAPH_BPIXEL_DEPTH0_Y8        ; break ;
    case 15: cv = NV_PGRAPH_BPIXEL_DEPTH0_A1R5G5B5  ; break ;
    case 16: cv = NV_PGRAPH_BPIXEL_DEPTH0_R5G6B5    ; break ;
    case 24: cv = NV_PGRAPH_BPIXEL_DEPTH0_X8R8G8B8_Z8R8G8B8  ; break ;
    case 32: cv = NV_PGRAPH_BPIXEL_DEPTH0_X8R8G8B8_Z8R8G8B8  ; break ;
    default: cv = 0 ;
    }

  t = getreg( NV_PGRAPH_BPIXEL ) ;
  t = modbits( t , NV_PGRAPH_BPIXEL_DEPTH0 , cv ) ;
  t = modbits( t , NV_PGRAPH_BPIXEL_DEPTH1 , cv ) ;
  setreg( NV_PGRAPH_BPIXEL , t ) ;

 
}
