
	BITS 32

	GLOBAL SetupNv04
	GLOBAL i386_getreg
	GLOBAL i386_setreg
	GLOBAL i386_getreg8
	GLOBAL i386_setreg8

i386_setreg:
	push  ebp
	mov   ebp , esp
	push  esi

	mov   esi , [ ebp + 0x08 ]
	add   esi , [ ebp + 0x0c ]
	mov   eax , [ ebp + 0x10 ]
	mov   [ esi ] , eax
	pop   esi
	pop   ebp
	ret

i386_getreg:
	push  ebp
	mov   ebp , esp
	push  esi

	mov   esi , [ ebp + 0x08 ]
	add   esi , [ ebp + 0x0c ]
	mov   eax , [ esi ] 
	pop   esi
	pop   ebp
	ret

i386_setreg8:
	push  ebp
	mov   ebp , esp
	push  esi

	mov   esi , [ ebp + 0x08 ]
	add   esi , [ ebp + 0x0c ]
	mov    al , [ ebp + 0x10 ]
	mov   [ esi ] , al
	pop   esi
	pop   ebp
	ret

i386_getreg8:
	push  ebp
	mov   ebp , esp
	push  esi

	mov   esi , [ ebp + 0x08 ]
	add   esi , [ ebp + 0x0c ]
	mov    al , [ esi ]
	and   eax , 0x000000ff   
	pop   esi
	pop   ebp
	ret

	

SetupNv04:
	push  ebp
	mov   ebp , esp
	mov   esi , [ ebp + 8 ]


	mov   eax , 0x00000000
	mov [ esi + 0x00000140 ] , eax
	mov   eax , 0xFFFF00FF
	mov [ esi + 0x00000200 ] , eax
	mov   eax , 0xFFFFFFFF
	mov [ esi + 0x00000200 ] , eax

	mov   eax , 0x00000008
	mov [ esi + 0x00009200 ] , eax
	mov   eax , 0x00000003
	mov [ esi + 0x00009210 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x00009140 ] , eax
	mov   eax , 0xFFFFFFFF
	mov [ esi + 0x00009100 ] , eax

	mov   eax , 0x00000000
	mov [ esi + 0x00002500 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x00003200 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x00003250 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x00003204 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x0000322C ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x00003000 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x00003050 ] , eax
	mov   eax , 0x03000100
	mov [ esi + 0x00002210 ] , eax
	mov   eax , 0x00000110
	mov [ esi + 0x00002214 ] , eax
	mov   eax , 0x00000112
	mov [ esi + 0x00002218 ] , eax
	mov   eax , 0x0000FFFF
	mov [ esi + 0x0000250C ] , eax
	mov   eax , 0x0000FFFF
	mov [ esi + 0x00003258 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x00002140 ] , eax
	mov   eax , 0xFFFFFFFF
	mov [ esi + 0x00002100 ] , eax
	mov   eax , 0x00000001
	mov [ esi + 0x00003054 ] , eax
	mov   eax , 0x00000001
	mov [ esi + 0x00003200 ] , eax
	mov   eax , 0x00000001
	mov [ esi + 0x00003250 ] , eax
	mov   eax , 0x00000001
	mov [ esi + 0x00003254 ] , eax
	mov   eax , 0x00000001
	mov [ esi + 0x00002500 ] , eax

	mov   eax , 0x80000010
	mov [ esi + 0x00710000 ] , eax
	mov   eax , 0x80011145
	mov [ esi + 0x00710004 ] , eax
	mov   eax , 0x80000011
	mov [ esi + 0x00710008 ] , eax
	mov   eax , 0x80011146
	mov [ esi + 0x0071000C ] , eax
	mov   eax , 0x80000012
	mov [ esi + 0x00710010 ] , eax
	mov   eax , 0x80011147
	mov [ esi + 0x00710014 ] , eax
	mov   eax , 0x80000013
	mov [ esi + 0x00710018 ] , eax
	mov   eax , 0x80011148
	mov [ esi + 0x0071001C ] , eax
	mov   eax , 0x80000014
	mov [ esi + 0x00710020 ] , eax
	mov   eax , 0x80011149
	mov [ esi + 0x00710024 ] , eax
	mov   eax , 0x80000015
	mov [ esi + 0x00710028 ] , eax
	mov   eax , 0x8001114A
	mov [ esi + 0x0071002C ] , eax
	mov   eax , 0x80000000
	mov [ esi + 0x00710080 ] , eax
	mov   eax , 0x80011142
	mov [ esi + 0x00710084 ] , eax
	mov   eax , 0x80000001
	mov [ esi + 0x00710088 ] , eax
	mov   eax , 0x80011143
	mov [ esi + 0x0071008C ] , eax
	mov   eax , 0x80000002
	mov [ esi + 0x00710090 ] , eax
	mov   eax , 0x80011144
	mov [ esi + 0x00710094 ] , eax
	mov   eax , 0x80000003
	mov [ esi + 0x00710098 ] , eax
	mov   eax , 0x8001114B
	mov [ esi + 0x0071009C ] , eax
	mov   eax , 0x80000004
	mov [ esi + 0x007100A0 ] , eax
	mov   eax , 0x8001114C
	mov [ esi + 0x007100A4 ] , eax
	mov   eax , 0x80000005
	mov [ esi + 0x007100A8 ] , eax
	mov   eax , 0x8001114D
	mov [ esi + 0x007100AC ] , eax
	mov   eax , 0x80000006
	mov [ esi + 0x007100B0 ] , eax
	mov   eax , 0x8001114E
	mov [ esi + 0x007100B4 ] , eax
	mov   eax , 0x80000020
	mov [ esi + 0x007100B8 ] , eax
	mov   eax , 0x8001114E
	mov [ esi + 0x007100BC ] , eax
	mov   eax , 0x00003000
	mov [ esi + 0x00711400 ] , eax
	mov   eax , 0x01FFFFFF
	mov [ esi + 0x00711404 ] , eax
	mov   eax , 0x00000002
	mov [ esi + 0x00711408 ] , eax
	mov   eax , 0x00000002
	mov [ esi + 0x0071140C ] , eax
	mov   eax , 0x01008043
	mov [ esi + 0x00711420 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x00711428 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x0071142C ] , eax
	mov   eax , 0x01008019
	mov [ esi + 0x00711430 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x00711438 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x0071143C ] , eax
	mov   eax , 0x01008018
	mov [ esi + 0x00711440 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x00711448 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x0071144C ] , eax
	mov   eax , 0x01008021
	mov [ esi + 0x00711450 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x00711458 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x0071145C ] , eax
	mov   eax , 0x0100805F
	mov [ esi + 0x00711460 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x00711468 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x0071146C ] , eax
	mov   eax , 0x0100801E
	mov [ esi + 0x00711470 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x00711478 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x0071147C ] , eax
	mov   eax , 0x0100A048
	mov [ esi + 0x00711480 ] , eax
	mov   eax , 0x00000D01
	mov [ esi + 0x00711484 ] , eax
	mov   eax , 0x11401140
	mov [ esi + 0x00711488 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x0071148C ] , eax
	mov   eax , 0x0300A054
	mov [ esi + 0x00711490 ] , eax
	mov   eax , 0x00000D01
	mov [ esi + 0x00711494 ] , eax
	mov   eax , 0x11401140
	mov [ esi + 0x00711498 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x0071149C ] , eax
	mov   eax , 0x0300A055
	mov [ esi + 0x007114A0 ] , eax
	mov   eax , 0x00000D01
	mov [ esi + 0x007114A4 ] , eax
	mov   eax , 0x11401140
	mov [ esi + 0x007114A8 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x007114AC ] , eax
	mov   eax , 0x00000058
	mov [ esi + 0x007114B0 ] , eax
	mov   eax , 0x11401140
	mov [ esi + 0x007114B8 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x007114BC ] , eax
	mov   eax , 0x00000059
	mov [ esi + 0x007114C0 ] , eax
	mov   eax , 0x11401140
	mov [ esi + 0x007114C8 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x007114CC ] , eax
	mov   eax , 0x0000005A
	mov [ esi + 0x007114D0 ] , eax
	mov   eax , 0x11401140
	mov [ esi + 0x007114D8 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x007114DC ] , eax
	mov   eax , 0x0000005B
	mov [ esi + 0x007114E0 ] , eax
	mov   eax , 0x11401140
	mov [ esi + 0x007114E8 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x007114EC ] , eax

	mov   eax , 0x1231C001
	mov [ esi + 0x00400080 ] , eax
	mov   eax , 0x72111101
	mov [ esi + 0x00400084 ] , eax
	mov   eax , 0x11D5F071
	mov [ esi + 0x00400088 ] , eax
	mov   eax , 0x10D4FF31
	mov [ esi + 0x0040008C ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x00400180 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x004001A0 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x004001C0 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x004001E0 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x00400184 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x004001A4 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x004001C4 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x004001E4 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x00400188 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x004001A8 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x004001C8 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x004001E8 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x0040018C ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x004001AC ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x004001CC ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x004001EC ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x00400190 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x004001B0 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x004001D0 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x004001F0 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x00400194 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x004001B4 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x004001D4 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x004001F4 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x00400198 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x004001B8 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x004001D8 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x004001F8 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x0040019C ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x004001BC ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x004001DC ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x004001FC ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x00400160 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x00400164 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x00400168 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x0040016C ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x00400658 ] , eax
	mov   eax , 0x01FFFFFF
	mov [ esi + 0x00400684 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x0040065C ] , eax
	mov   eax , 0x01FFFFFF
	mov [ esi + 0x00400688 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x00400660 ] , eax
	mov   eax , 0x01FFFFFF
	mov [ esi + 0x0040068C ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x00400664 ] , eax
	mov   eax , 0x01FFFFFF
	mov [ esi + 0x00400690 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x00400140 ] , eax
	mov   eax , 0xFFFFFFFF
	mov [ esi + 0x00400100 ] , eax
	mov   eax , 0x10010100
	mov [ esi + 0x00400170 ] , eax
	mov   eax , 0xFFFFFFFF
	mov [ esi + 0x00400710 ] , eax
	mov   eax , 0x00000001
	mov [ esi + 0x00400720 ] , eax
	mov   eax , 0x00000000
	mov [ esi + 0x00400810 ] , eax
	mov   eax , 0x00000001
	mov [ esi + 0x0040070C ] , eax
	mov   eax , 0x00000E02
	mov [ esi + 0x00711424 ] , eax
	mov   eax , 0x00000E02
	mov [ esi + 0x00711434 ] , eax
	mov   eax , 0x00000D02
	mov [ esi + 0x00711444 ] , eax
	mov   eax , 0x00000E02
	mov [ esi + 0x00711454 ] , eax
	mov   eax , 0x00000E02
	mov [ esi + 0x00711464 ] , eax
	mov   eax , 0x00000E02
	mov [ esi + 0x00711474 ] , eax
	mov   eax , 0x00000E02
	mov [ esi + 0x007114B4 ] , eax
	mov   eax , 0x00000E02
	mov [ esi + 0x007114B8 ] , eax
	mov   eax , 0x00000E02
	mov [ esi + 0x007114D4 ] , eax
	mov   eax , 0x00000E02
	mov [ esi + 0x007114E4 ] , eax

	mov   eax , 0x0077D777
	mov [ esi + 0x00400724 ] , eax
	mov   eax , 0x000070E5
	mov [ esi + 0x00400618 ] , eax
	mov   eax , 0x0E0D0D0D
	mov [ esi + 0x00400830 ] , eax

	mov   eax , 0x80000000
	mov [ esi + 0x00800000 ] , eax
	mov   eax , 0x80000001
	mov [ esi + 0x00802000 ] , eax
	mov   eax , 0x80000002
	mov [ esi + 0x00804000 ] , eax
	mov   eax , 0x80000010
	mov [ esi + 0x00806000 ] , eax
	mov   eax , 0x80000011
	mov [ esi + 0x00808000 ] , eax
	mov   eax , 0x80000012
	mov [ esi + 0x0080A000 ] , eax
	mov   eax , 0x80000015
	mov [ esi + 0x0080C000 ] , eax
	mov   eax , 0x80000013
	mov [ esi + 0x0080E000 ] , eax

	mov   eax , 0x80000014
	mov [ esi + 0x0080E000 ] , eax


	pop   ebp
	ret
