
/* * External Devices */ 

#define NV04_PEXTDEV            0x00101FFF:0x00101000 /* RW */ 
#define NV04_PROM               0x0030FFFF:0x00300000 /* RW */ 
#define NV04_PDAC               0x00680FFF:0x00680000 /* RW */ 

#define NV04_PEXTDEV_BOOT_0     0x00101000 /* R- */ 
#define NV04_PEXTDEV_BOOT_0_STRAP_PCI_AD 0:0 /* R- */ 
#define NV04_PEXTDEV_BOOT_0_STRAP_PCI_AD_REVERSED 0x00000000 /* R- */ 
#define NV04_PEXTDEV_BOOT_0_STRAP_PCI_AD_NORMAL 0x00000001 /* R- */ 
#define NV04_PEXTDEV_BOOT_0_STRAP_SUB_VENDOR 1:1 /* R- */ 
#define NV04_PEXTDEV_BOOT_0_STRAP_SUB_VENDOR_NO_BIOS 0x00000000 /* R- */ 
#define NV04_PEXTDEV_BOOT_0_STRAP_SUB_VENDOR_BIOS                 0x00000001 /* R- */

#define NV04_PEXTDEV_BOOT_0_STRAP_RAMCFG                     5:2 /* R- */ 
#define NV04_PEXTDEV_BOOT_0_STRAP_CRYSTAL                    6:6 /* R- */ 
#define NV04_PEXTDEV_BOOT_0_STRAP_CRYSTAL_13500K                  0x00000000 /* R- */ 
#define NV04_PEXTDEV_BOOT_0_STRAP_CRYSTAL_14318180                0x00000001 /* R- */ 
#define NV04_PEXTDEV_BOOT_0_STRAP_TVMODE                     8:7 /* R- */ 
#define NV04_PEXTDEV_BOOT_0_STRAP_TVMODE_PAL                      0x00000000 /* R- */ 
#define NV04_PEXTDEV_BOOT_0_STRAP_TVMODE_NTSC                     0x00000001 /* R- */ 
#define NV04_PEXTDEV_BOOT_0_STRAP_TVMODE_RESERVED                 0x00000002 /* R- */ 
#define NV04_PEXTDEV_BOOT_0_STRAP_TVMODE_DISABLED                 0x00000003 /* R- */ 
#define NV04_PEXTDEV_BOOT_0_STRAP_AGP_4X                     9:9 /* R- */ 
#define NV04_PEXTDEV_BOOT_0_STRAP_AGP_4X_ENABLED                  0x00000000 /* R- */ 
#define NV04_PEXTDEV_BOOT_0_STRAP_AGP_4X_DISABLED                 0x00000001 /* R- */ 
#define NV04_PEXTDEV_BOOT_0_STRAP_AGP_SBA                   10:10 /* R- */ 
#define NV04_PEXTDEV_BOOT_0_STRAP_AGP_SBA_ENABLED                 0x00000000 /* R- */ 
#define NV04_PEXTDEV_BOOT_0_STRAP_AGP_SBA_DISABLED                0x00000001 /* R- */ 
#define NV04_PEXTDEV_BOOT_0_STRAP_RESERVED_11               11:11 /* R- */ 
#define NV04_PEXTDEV_BOOT_0_STRAP_PCI_DEVID                 13:12 /* R- */ 
#define NV04_PEXTDEV_BOOT_0_STRAP_PCI_DEVID_0                     0x00000000 /* R- */ 
#define NV04_PEXTDEV_BOOT_0_STRAP_PCI_DEVID_1                     0x00000001 /* R- */ 
#define NV04_PEXTDEV_BOOT_0_STRAP_PCI_DEVID_2                     0x00000002 /* R- */ 
#define NV04_PEXTDEV_BOOT_0_STRAP_PCI_DEVID_3                     0x00000003 /* R- */ 
#define NV04_PEXTDEV_BOOT_0_STRAP_BUS_TYPE                  14:14 /* R- */ 
#define NV04_PEXTDEV_BOOT_0_STRAP_BUS_TYPE_PCI                    0x00000000 /* R- */ 
#define NV04_PEXTDEV_BOOT_0_STRAP_BUS_TYPE_AGP                    0x00000001 /* R- */ 
#define NV04_PEXTDEV_BOOT_0_STRAP_FP_IFACE                  15:15 /* R- */ 
#define NV04_PEXTDEV_BOOT_0_STRAP_FP_IFACE_24BIT                  0x00000000 /* R- */ 
#define NV04_PEXTDEV_BOOT_0_STRAP_FP_IFACE_12BIT                  0x00000001 /* R- */ 
#define NV04_PEXTDEV_BOOT_0_STRAP_OVERWRITE                 31:31 /* RW */ 
#define NV04_PEXTDEV_BOOT_0_STRAP_OVERWRITE_DISABLED              0x00000000 /* RW */ 
#define NV04_PEXTDEV_BOOT_0_STRAP_OVERWRITE_ENABLED               0x00000001 /* RW */ 

#define NV04_PEXTDEV_NEW_BOOT_0 0x00101000 /* RW */ 
#define NV04_PEXTDEV_NEW_BOOT_0_STRAP_VALUE 15:0 /* RW */ 
#define NV04_PEXTDEV_NEW_BOOT_0_STRAP_OVERWRITE 31:31 /* RW */ 
#define NV04_PEXTDEV_NEW_BOOT_0_STRAP_OVERWRITE_DISABLED 0x00000000 /* RW */ 
#define NV04_PEXTDEV_NEW_BOOT_0_STRAP_OVERWRITE_ENABLED 0x00000001 /* RW */ 

#define NV04_PDAC_DATA(i) (0x00680000+(i)*4) /* RW */ 
#define NV04_PDAC_DATA__SIZE_1 16 /* */ 
#define NV04_PDAC_DATA_VALUE 7:0 /* RW */ 
#define NV04_PROM_DATA(i) (0x00300000+(i)) /* RW */ 
#define NV04_PROM_DATA__SIZE_1 65536 /* */ 
#define NV04_PROM_DATA_VALUE 7:0 /* RW */ 

