
#define PCI_CONFIGADD  0x0cf8
#define PCI_CONFIGDATA 0x0cfc

#define PCI_BusMax      0x0a 
#define PCI_DeviceMax   0x1f 
#define PCI_FuntionMax  0x00 

#define PCI_RegVendorId 0x00
#define PCI_RegDeviceId 0x02
#define PCI_RegCommand  0x04

#define PCI_RegBase0    0x10
#define PCI_RegBase1    0x14
#define PCI_RegBase2    0x18
#define PCI_RegBase3    0x1c
#define PCI_RegBase4    0x20
#define PCI_RegBase5    0x24

typedef struct 
{
  void  *last   ;
  void  *next   ;


  unsigned long  VendorId  ;
  unsigned long  DeviceId  ;

  unsigned long  bus       ;
  unsigned long  device    ;
  unsigned long  funtion   ;
  unsigned long  reg       ;

  unsigned long  CommandReg      ;
  unsigned long  PhysAdds[6]  ;
  unsigned long *MapedAdd[6] ;
  
} PciSubDevice ;


/*
CardList 

type vendor , device , bus , device ,funtion 

*/




typedef struct
{
  unsigned long VendorId  ;
  unsigned long DeviceId  ;
  unsigned long Comment   ;
} _cardlist ;


extern void * PciFindCards(_cardlist * ) ;

