void * NewCildObj(void * parent , unsigned long size )
{
  _DefaultObj  * new ;
  _DefaultObj  * def = parent ; 

 
  new = (void *) calloc( 1 , size ) ; 

  new->obj.size   = size   ;
  new->obj.parent = def    ;

  if (def->obj.childlist) 
    {
      for ( def = def->obj.childlist ; def->obj.next ; def = def->obj.next ) ;
      def->obj.next = new ;
      new->obj.prev = def ;
    } 
  else
    def->obj.childlist = new ;

  if (0) printf("Lexos: new Obj  parent = 0x%8.8lX obj = 0x%8.8lX size = 0x%8.8lX name = %s\n",(unsigned long) new->obj.parent , (unsigned long) new , new->obj.size , new->obj.name) ;  
  return(new) ;
}

void * NewCildObjn(void * parent , unsigned long size , unsigned char * name )
{
  _DefaultObj  * new ;
  _DefaultObj  * def = parent ; 

  new = (void *) calloc( 1 , size ) ; 

  new->obj.size   = size   ;
  new->obj.parent = def    ;
  new->obj.name   = name   ;

  if (def->obj.childlist) 
    {
      for ( def = def->obj.childlist ; def->obj.next ; def = def->obj.next ) ;
      def->obj.next = new ;
      new->obj.prev = def ;
    } 
  else
    def->obj.childlist = new ;


  if (0) printf("Lexos: new Obj  parent = 0x%8.8lX obj = 0x%8.8lX size = 0x%8.8lX name = %s\n",(unsigned long) new->obj.parent , (unsigned long) new , new->obj.size , new->obj.name) ;  
  return(new) ;
}

void RemoveObj(void * obj)
{
 
  _DefaultObj * d  = obj ;
  _DefaultObj * p  = d->obj.parent ;

  if(p->obj.childlist == d)
    {
      p->obj.childlist = d->obj.next ;
      if (d->obj.next) { p = d->obj.next ; p->obj.prev = NULL ; }
      free(d) ;
      return ;
    }
  if(d->obj.next) { p = d->obj.next ; p->obj.prev = d->obj.prev ; free( d ) ; return ; }
  p = d->obj.prev ; p->obj.next = d->obj.next ;
  free(d) ;
  return  ;

}
void DoPrintObjList(void *plist , unsigned char *path )
{

  char name[0x200] ;

  _DefaultObj *list   = (_DefaultObj *) plist   ;
 
 loop1:
    
  strcpy( name , path )        ;
  strcat( name , "/"  )        ;

 
  if (list->obj.name)
    {
      strcat( name , list->obj.name ) ;
      printf("%8.8lX  ",(unsigned long) list ) ;
      printf("%s\n"    ,(char *) &name) ;
    }
  else 
    {
      printf("%8.8lX  ",(unsigned long) list ) ;
      printf("name has (null pointer)\n") ;
    }
  if (list->obj.childlist) { DoPrintObjList(list->obj.childlist,name) ; } 
  if (list->obj.next)      { list = list->obj.next ; goto loop1  ; }
 
}


  

void dumpobjlist(void * root)
{

  unsigned char path[] = "Obj list:" ;

  DoPrintObjList(root , path) ;

}
