#define NV03_MEMORY         0xFFFFFFFF:0x00000000 /* RW */ 
#define NV03_IO             0xFFFFFFFF:0x00000000 /* RW */ 
#define NV03_CONFIG         0x000000FF:0x00000000 /* RW */ 
#define NV03_EXPROM         0x003FFFFF:0x00000000 /* R- */ 
#define NV03_SPACE          0x01FFFFFF:0x00000000 /* RW */

#define NV03_RSPACE         0x00FFFFFF:0x00000000 /* RW */ 
#define NV03_MSPACE         0x00FFFFFF:0x00000000 /* RW */ 
#define NV03_RMAIO          0x000000FF:0x00000000 /* RW */ 
#define NV03_PBUS           0x00001FFF:0x00001000 /* RW */

#define NV03_PBUS_DEBUG_0                                  0x00001080 /* RW */ 
#define NV03_PBUS_DEBUG_SEL_0                              0x00001090 /* RW */ 
#define NV03_PBUS_DEBUG_SEL_1                              0x00001094 /* RW */ 
#define NV03_PBUS_DEBUG_SEL_2                              0x00001098 /* RW */

#define NV03_PBUS_DEBUG_SEL_3                              0x0000109C /* RW */ 
#define NV03_PBUS_DEBUG_HOST                               0x000010A0 /* RW */ 
#define NV03_PBUS_DEBUG_1                                  0x00001084 /* RW */ 
#define NV03_PBUS_DEBUG_2                                  0x00001088 /* RW */ 
#define NV03_PBUS_INTR_0                                   0x00001100 /* RW */ 
#define NV03_PBUS_INTR_0_PCI_BUS_ERROR                0:0             /* RW */ 
#define NV03_PBUS_INTR_0_PCI_BUS_ERROR_NOT_PENDING         0x00000000 /* R- */ 
#define NV03_PBUS_INTR_0_PCI_BUS_ERROR_PENDING             0x00000001 /* R- */ 
#define NV03_PBUS_INTR_0_PCI_BUS_ERROR_RESET               0x00000001 /* -W */ 
#define NV03_PBUS_INTR_EN_0                                0x00001140 /* RW */ 
#define NV03_PBUS_INTR_EN_0_PCI_BUS_ERROR             0:0             /* RW */ 
#define NV03_PBUS_INTR_EN_0_PCI_BUS_ERROR_DISABLED         0x00000000 /* RW */ 
#define NV03_PBUS_INTR_EN_0_PCI_BUS_ERROR_ENABLED          0x00000001 /* RW */ 

#define NV03_EXPROM_BIOS_ROM008(i)          (0x00000000+(i))          /* RW */ 
#define NV03_EXPROM_BIOS_ROM008__SIZE_1      65536                    /* */ 
#define NV03_EXPROM_BIOS_ROM008_VALUE         7:0                     /* RW */ 
#define NV03_EXPROM_BIOS_ROM016(i)          (0x00000000+(i)*2)        /* RW */ 
#define NV03_EXPROM_BIOS_ROM016__SIZE_1      32768                    /* */ 
#define NV03_EXPROM_BIOS_ROM016_VALUE        15:0                     /* RW */ 
#define NV03_EXPROM_BIOS_ROM032(i)          (0x00000000+(i)*4)        /* RW */
#define NV03_EXPROM_BIOS_ROM032__SIZE_1      16384                    /* */ 
#define NV03_EXPROM_BIOS_ROM032_VALUE        31:0                     /* RW */ 

#define NV03_RMA_ID                                        0x00000000 /* R- */ 
#define NV03_RMA_ID__ALIAS_1                          NV_PRMIO_RMA_ID /* */
#define NV03_PRMIO_RMA_ID                                  0x00007100 /* R- */ 
#define NV03_PRMIO_RMA_ID__ALIAS_1                          NV_RMA_ID /* */ 
#define NV03_RMA_ID_CODE                             31:0             /* C- */ 
#define NV03_RMA_ID_CODE_VALID                             0x2B16D065 /* C- */ 
#define NV03_RMA_PTR                                       0x00000004 /* RW */ 
#define NV03_RMA_PTR__ALIAS_1                        NV_PRMIO_RMA_PTR /* */ 
#define NV03_PRMIO_RMA_PTR                                 0x00007104 /* RW */ 
#define NV03_PRMIO_RMA_PTR__ALIAS_1                        NV_RMA_PTR /* */ 
#define NV03_RMA_PTR_ADDRESS                         24:2             /* RW */ 
#define NV03_RMA_DATA                                      0x00000008 /* RW */ 
#define NV03_RMA_DATA__ALIAS_1                      NV_PRMIO_RMA_DATA /* */ 
#define NV03_PRMIO_RMA_DATA                                0x00007108 /* RW */ 
#define NV03_PRMIO_RMA_DATA__ALIAS_1                      NV_RMA_DATA /* */ 
#define NV03_RMA_DATA_PORT                           31:0             /* RW */ 
#define NV03_RMA_DATA32                                    0x0000000C /* RW */ 
#define NV03_RMA_DATA32__ALIAS_1                  NV_PRMIO_RMA_DATA32 /* */
#define NV03_PRMIO_RMA_DATA32                              0x0000710C /* RW */ 
#define NV03_PRMIO_RMA_DATA32__ALIAS_1                  NV_RMA_DATA32 /* */ 
#define NV03_RMA_DATA32_MSW                          31:16            /* -W */ 
#define NV03_RMA_DATA32_LSW                          15:0             /* RW */
#define NV03_RMA_INCDATA                                   0x00000010 /* RW */ 
#define NV03_RMA_INCDATA__ALIAS_1                NV_PRMIO_RMA_INCDATA /* */ 
#define NV03_PRMIO_RMA_INCDATA                             0x00007110 /* RW */ 
#define NV03_PRMIO_RMA_INCDATA__ALIAS_1                NV_RMA_INCDATA /* */ 
#define NV03_RMA_INCDATA_PORT                        31:0             /* RW */ 
#define NV03_RMA_INCDATA32                                 0x00000014 /* RW */ 
#define NV03_RMA_INCDATA32__ALIAS_1            NV_PRMIO_RMA_INCDATA32 /* */ 
#define NV03_PRMIO_RMA_INCDATA32                           0x00007114 /* RW */ 
#define NV03_PRMIO_RMA_INCDATA32__ALIAS_1            NV_RMA_INCDATA32 /* */ 
#define NV03_RMA_INCDATA32_PORT                      31:0             /* RW */ 
#define NV03_PBUS_RMC_DMA_0                                0x00001E80 /* RW */ 
#define NV03_PBUS_RMC_DMA_0_ADDRESS_BYTE_0            7:0             /* RW */ 
#define NV03_PBUS_RMC_DMA_0_ADDRESS_BYTE_1           15:8             /* RW */ 
#define NV03_PBUS_RMC_DMA_0_ADDRESS_BYTE_2           23:16            /* RW */ 
#define NV03_PBUS_RMC_DMA_0_MASK_BIT                 24:24            /* RW */ 
#define NV03_PBUS_RMC_DMA_0_MASK_BIT_CLEAR                 0x00000000 /* RW */ 
#define NV03_PBUS_RMC_DMA_0_MASK_BIT_SET                   0x00000001 /* RW */ 
#define NV03_PBUS_RMC_DMA_0_AUTOINITIALIZE 25:25 /* RW */ 
#define NV03_PBUS_RMC_DMA_0_AUTOINITIALIZE_DISABLED 0x00000000 /* RW */ 
#define NV03_PBUS_RMC_DMA_0_AUTOINITIALIZE_ENABLED 0x00000001 /* RW */ 
#define NV03_PBUS_RMC_DMA_0_DIRECTION 26:26 /* RW */ 
#define NV03_PBUS_RMC_DMA_0_DIRECTION_INCREMENT 0x00000000 /* RW */ 
#define NV03_PBUS_RMC_DMA_0_DIRECTION_DECREMENT 0x00000001 /* RW */ 
#define NV03_PBUS_RMC_DMA_0_CHANNEL 29:28 /* RW */ 
#define NV03_PBUS_RMC_DMA_0_CONTROLLER 30:30 /* RW */ 
#define NV03_PBUS_RMC_DMA_0_CONTROLLER_DISABLED 0x00000000 /* RW */ 
#define NV03_PBUS_RMC_DMA_0_CONTROLLER_ENABLED 0x00000001 /* RW */ 
#define NV03_PBUS_RMC_DMA_0_FLIPFLOP 31:31 /* RW */ 
#define NV03_PBUS_RMC_DMA_0_FLIPFLOP_BYTE_0 0x00000000 /* RW */ 
#define NV03_PBUS_RMC_DMA_0_FLIPFLOP_BYTE_1 0x00000001 /* RW */ 
#define NV03_PBUS_RMC_DMA_1 0x00001E84 /* RW */ 
#define NV03_PBUS_RMC_DMA_1_COUNT_BYTE_0 7:0 /* RW */ 
#define NV03_PBUS_RMC_DMA_1_COUNT_BYTE_1 15:8 /* RW */ 
#define NV03_PBUS_RMC_DMA_1_STATE 28:28 /* RW */ 
#define NV03_PBUS_RMC_DMA_1_STATE_CLEAN 0x00000000 /* RW */ 
#define NV03_PBUS_RMC_DMA_1_STATE_DIRTY 0x00000001 /* RW */ 
#define NV03_IO_DMA_0000 0x00000000 /* -W */ 
#define NV03_IO_DMA_0000_ADDRESS 7:0 /* -W */ 
#define NV03_IO_DMA_0001 0x00000001 /* -W */ 
#define NV03_IO_DMA_0001_COUNT 7:0 /* -W */ 
#define NV03_IO_DMA_0002 0x00000002 /* -W */ 
#define NV03_IO_DMA_0002_ADDRESS 7:0 /* -W */ 
#define NV03_IO_DMA_0003 0x00000003 /* -W */
#define NV03_IO_DMA_0003_COUNT 7:0 /* -W */ 
#define NV03_IO_DMA_0004 0x00000004 /* -W */ 
#define NV03_IO_DMA_0004_ADDRESS 7:0 /* -W */ 
#define NV03_IO_DMA_0005 0x00000005 /* -W */ 
#define NV03_IO_DMA_0005_COUNT 7:0 /* -W */ 
#define NV03_IO_DMA_0006 0x00000006 /* -W */ 
#define NV03_IO_DMA_0006_ADDRESS 7:0 /* -W */ 
#define NV03_IO_DMA_0007 0x00000007 /* -W */ 
#define NV03_IO_DMA_0007_COUNT 7:0 /* -W */ 
#define NV03_IO_DMA_0008 0x00000008 /* -W */ 
#define NV03_IO_DMA_0008_CONTROLLER 2:2 /* -W */ 
#define NV03_IO_DMA_0008_CONTROLLER_DISABLED 0x00000000 /* -W */
#define NV03_IO_DMA_0008_CONTROLLER_ENABLED 0x00000001 /* -W */ 
#define NV03_IO_DMA_000A 0x0000000A /* -W */ 
#define NV03_IO_DMA_000A_CHANNEL 1:0 /* -W */ 
#define NV03_IO_DMA_000A_MASK_BIT 2:2 /* -W */ 
#define NV03_IO_DMA_000A_MASK_BIT_CLEAR 0x00000000 /* -W */ 
#define NV03_IO_DMA_000A_MASK_BIT_SET 0x00000001 /* -W */ 
#define NV03_IO_DMA_000B 0x0000000B /* -W */ 
#define NV03_IO_DMA_000B_CHANNEL 1:0 /* -W */ 
#define NV03_IO_DMA_000B_AUTOINITIALIZE 4:4 /* -W */ 
#define NV03_IO_DMA_000B_AUTOINITIALIZE_DISABLED 0x00000000 /* -W */ 
#define NV03_IO_DMA_000B_AUTOINITIALIZE_ENABLED 0x00000001 /* -W */ 
#define NV03_IO_DMA_000B_DIRECTION 5:5 /* -W */ 
#define NV03_IO_DMA_000B_DIRECTION_INCREMENT 0x00000000 /* -W */ 
#define NV03_IO_DMA_000B_DIRECTION_DECREMENT 0x00000001 /* -W */ 
#define NV03_IO_DMA_000C 0x0000000C /* -W */ 
#define NV03_IO_DMA_000C_CLEAR_FLIPFLOP 7:0 /* -W */ 
#define NV03_IO_DMA_0081 0x00000081 /* -W */ 
#define NV03_IO_DMA_0081_ADDRESS 3:0 /* -W */ 
#define NV03_IO_DMA_0082 0x00000082 /* -W */ 
#define NV03_IO_DMA_0082_ADDRESS 3:0 /* -W */ 
#define NV03_IO_DMA_0083 0x00000083 /* -W */ 
#define NV03_IO_DMA_0083_ADDRESS 3:0 /* -W */ 
#define NV03_IO_DMA_0087 0x00000087 /* -W */ 
#define NV03_IO_DMA_0087_ADDRESS 3:0 /* -W */ 
#define NV03_PBUS_PCI_NV_0 0x00001800 /* R- */ 
#define NV03_PBUS_PCI_NV_0__ALIAS_1 NV_CONFIG_PCI_NV_0 /* */ 
#define NV03_CONFIG_PCI_NV_0 0x00000000 /* R- */ 
#define NV03_CONFIG_PCI_NV_0__ALIAS_1 NV_PBUS_PCI_NV_0 /* */ 
#define NV03_CONFIG_PCI_NV_0_VENDOR_ID 15:0 /* C- */ 
#define NV03_CONFIG_PCI_NV_0_VENDOR_ID_NVIDIA_SGS 0x000012D2 /* C- */
#define NV03_CONFIG_PCI_NV_0_DEVICE_ID_FUNC 18:16 /* C- */ 
#define NV03_CONFIG_PCI_NV_0_DEVICE_ID_FUNC_VGA 0x00000000 /* C- */ 
#define NV03_CONFIG_PCI_NV_0_DEVICE_ID_CHIP 31:19 /* C- */ 
#define NV03_CONFIG_PCI_NV_0_DEVICE_ID_CHIP_NV0 0x00000000 /* -- */ 
#define NV03_CONFIG_PCI_NV_0_DEVICE_ID_CHIP_NV1 0x00000001 /* -- */ 
#define NV03_CONFIG_PCI_NV_0_DEVICE_ID_CHIP_NV2 0x00000002 /* -- */ 
#define NV03_CONFIG_PCI_NV_0_DEVICE_ID_CHIP_NV3 0x00000003 /* C- */ 
#define NV03_PBUS_PCI_NV_1 0x00001804 /* RW */ 
#define NV03_PBUS_PCI_NV_1__ALIAS_1 NV_CONFIG_PCI_NV_1 /* */ 
#define NV03_CONFIG_PCI_NV_1 0x00000004 /* RW */ 
#define NV03_CONFIG_PCI_NV_1__ALIAS_1 NV_PBUS_PCI_NV_1 /* */ 
#define NV03_CONFIG_PCI_NV_1_IO_SPACE 0:0 /* RW */ 
#define NV03_CONFIG_PCI_NV_1_IO_SPACE_DISABLED 0x00000000 /* RW */
#define NV03_CONFIG_PCI_NV_1_IO_SPACE_ENABLED 0x00000001 /* RW */ 
#define NV03_CONFIG_PCI_NV_1_MEMORY_SPACE 1:1 /* RW */ 
#define NV03_CONFIG_PCI_NV_1_MEMORY_SPACE_DISABLED 0x00000000 /* RW */
#define NV03_CONFIG_PCI_NV_1_MEMORY_SPACE_ENABLED 0x00000001 /* RW */ 
#define NV03_CONFIG_PCI_NV_1_BUS_MASTER 2:2 /* RW */ 
#define NV03_CONFIG_PCI_NV_1_BUS_MASTER_DISABLED 0x00000000 /* RW */
#define NV03_CONFIG_PCI_NV_1_BUS_MASTER_ENABLED 0x00000001 /* RW */ 
#define NV03_CONFIG_PCI_NV_1_WRITE_AND_INVAL 4:4 /* C- */ 
#define NV03_CONFIG_PCI_NV_1_WRITE_AND_INVAL_DISABLED 0x00000000 /* C- */
#define NV03_CONFIG_PCI_NV_1_WRITE_AND_INVAL_ENABLED 0x00000001 /* -- */ 
#define NV03_CONFIG_PCI_NV_1_PALETTE_SNOOP 5:5 /* RW */ 
#define NV03_CONFIG_PCI_NV_1_PALETTE_SNOOP_DISABLED 0x00000000 /* RW */ 
#define NV03_CONFIG_PCI_NV_1_PALETTE_SNOOP_ENABLED 0x00000001 /* RW */ 
#define NV03_CONFIG_PCI_NV_1_CAPLIST 20:20 /* C- */ 
#define NV03_CONFIG_PCI_NV_1_CAPLIST_NOT_PRESENT 0x00000000 /* -- */ 
#define NV03_CONFIG_PCI_NV_1_CAPLIST_PRESENT 0x00000001 /* C- */ 
#define NV03_CONFIG_PCI_NV_1_66MHZ 21:21 /* C- */ 
#define NV03_CONFIG_PCI_NV_1_66MHZ_INCAPABLE 0x00000000 /* -- */ 
#define NV03_CONFIG_PCI_NV_1_66MHZ_CAPABLE 0x00000001 /* -- */ 
#define NV03_CONFIG_PCI_NV_1_FAST_BACK2BACK 23:23 /* C- */ 
#define NV03_CONFIG_PCI_NV_1_FAST_BACK2BACK_INCAPABLE 0x00000000 /* -- */ 
#define NV03_CONFIG_PCI_NV_1_FAST_BACK2BACK_CAPABLE 0x00000001 /* C- */ 
#define NV03_CONFIG_PCI_NV_1_DEVSEL_TIMING 26:25 /* C- */ 
#define NV03_CONFIG_PCI_NV_1_DEVSEL_TIMING_FAST 0x00000000 /* -- */ 
#define NV03_CONFIG_PCI_NV_1_DEVSEL_TIMING_MEDIUM 0x00000001 /* C- */ 
#define NV03_CONFIG_PCI_NV_1_DEVSEL_TIMING_SLOW 0x00000002 /* -- */ 
#define NV03_CONFIG_PCI_NV_1_SIGNALED_TARGET 27:27 /* RW */ 
#define NV03_CONFIG_PCI_NV_1_SIGNALED_TARGET_NO_ABORT 0x00000000 /* R- */ 
#define NV03_CONFIG_PCI_NV_1_SIGNALED_TARGET_ABORT 0x00000001 /* R- */ 
#define NV03_CONFIG_PCI_NV_1_SIGNALED_TARGET_CLEAR 0x00000001 /* -W */ 
#define NV03_CONFIG_PCI_NV_1_RECEIVED_TARGET 28:28 /* RW */ 
#define NV03_CONFIG_PCI_NV_1_RECEIVED_TARGET_NO_ABORT 0x00000000 /* R- */ 
#define NV03_CONFIG_PCI_NV_1_RECEIVED_TARGET_ABORT 0x00000001 /* R- */ 
#define NV03_CONFIG_PCI_NV_1_RECEIVED_TARGET_CLEAR 0x00000001 /* -W */ 
#define NV03_CONFIG_PCI_NV_1_RECEIVED_MASTER 29:29 /* RW */
#define NV03_CONFIG_PCI_NV_1_RECEIVED_MASTER_NO_ABORT 0x00000000 /* R- */ 
#define NV03_CONFIG_PCI_NV_1_RECEIVED_MASTER_ABORT 0x00000001 /* R- */ 
#define NV03_CONFIG_PCI_NV_1_RECEIVED_MASTER_CLEAR 0x00000001 /* -W */ 
#define NV03_PBUS_PCI_NV_2 0x00001808 /* R- */ 
#define NV03_PBUS_PCI_NV_2__ALIAS_1 NV_CONFIG_PCI_NV_2 /* */ 
#define NV03_CONFIG_PCI_NV_2 0x00000008 /* R- */ 
#define NV03_CONFIG_PCI_NV_2__ALIAS_1 NV_PBUS_PCI_NV_2 /* */ 
#define NV03_CONFIG_PCI_NV_2_REVISION_ID 7:0 /* C- */ 
#define NV03_CONFIG_PCI_NV_2_REVISION_ID_A01 0x00000000 /* -- */ 
#define NV03_CONFIG_PCI_NV_2_REVISION_ID_B01 0x00000010 /* -- */ 
#define NV03_CONFIG_PCI_NV_2_REVISION_ID_C01 0x00000020 /* -- */ 
#define NV03_CONFIG_PCI_NV_2_REVISION_ID_C02 0x00000021 /* -- */ 
#define NV03_CONFIG_PCI_NV_2_REVISION_ID_C03 0x00000022 /* C- */ 
#define NV03_CONFIG_PCI_NV_2_CLASS_CODE 31:8 /* C- */ 
#define NV03_CONFIG_PCI_NV_2_CLASS_CODE_VGA 0x00030000 /* C- */ 
#define NV03_CONFIG_PCI_NV_2_CLASS_CODE_MULTIMEDIA 0x00048000 /* -- */ 
#define NV03_PBUS_PCI_NV_3 0x0000180C /* RW */ 
#define NV03_PBUS_PCI_NV_3__ALIAS_1 NV_CONFIG_PCI_NV_3 /* */ 
#define NV03_CONFIG_PCI_NV_3 0x0000000C /* RW */ 
#define NV03_CONFIG_PCI_NV_3__ALIAS_1 NV_PBUS_PCI_NV_3 /* */ 
#define NV03_CONFIG_PCI_NV_3_LATENCY_TIMER 15:11 /* RW */ 
#define NV03_CONFIG_PCI_NV_3_LATENCY_TIMER_0_CLOCKS 0x00000000 /* RW */ 
#define NV03_CONFIG_PCI_NV_3_LATENCY_TIMER_8_CLOCKS 0x00000001 /* RW */ 
#define NV03_CONFIG_PCI_NV_3_LATENCY_TIMER_240_CLOCKS 0x0000001E /* RW */ 
#define NV03_CONFIG_PCI_NV_3_LATENCY_TIMER_248_CLOCKS 0x0000001F /* RW */ 
#define NV03_CONFIG_PCI_NV_3_HEADER_TYPE 23:16 /* C- */ 
#define NV03_CONFIG_PCI_NV_3_HEADER_TYPE_SINGLEFUNC 0x00000000 /* C- */
#define NV03_CONFIG_PCI_NV_3_HEADER_TYPE_MULTIFUNC 0x00000080 /* -- */ 
#define NV03_PBUS_PCI_NV_4 0x00001810 /* RW */ 
#define NV03_PBUS_PCI_NV_4__ALIAS_1 NV_CONFIG_PCI_NV_4 /* */ 
#define NV03_CONFIG_PCI_NV_4 0x00000010 /* RW */ 
#define NV03_CONFIG_PCI_NV_4__ALIAS_1 NV_PBUS_PCI_NV_4 /* */ 
#define NV03_CONFIG_PCI_NV_4_SPACE_TYPE 0:0 /* C- */ 
#define NV03_CONFIG_PCI_NV_4_SPACE_TYPE_MEMORY 0x00000000 /* C- */ 
#define NV03_CONFIG_PCI_NV_4_SPACE_TYPE_IO 0x00000001 /* -- */ 
#define NV03_CONFIG_PCI_NV_4_ADDRESS_TYPE 2:1 /* C- */ 
#define NV03_CONFIG_PCI_NV_4_ADDRESS_TYPE_32_BIT 0x00000000 /* C- */ 
#define NV03_CONFIG_PCI_NV_4_ADDRESS_TYPE_20_BIT 0x00000001 /* -- */ 
#define NV03_CONFIG_PCI_NV_4_ADDRESS_TYPE_64_BIT 0x00000002 /* -- */
#define NV03_CONFIG_PCI_NV_4_PREFETCHABLE 3:3 /* C- */ 
#define NV03_CONFIG_PCI_NV_4_PREFETCHABLE_NOT 0x00000000 /* C- */ 
#define NV03_CONFIG_PCI_NV_4_PREFETCHABLE_MERGABLE 0x00000001 /* -- */ 
#define NV03_CONFIG_PCI_NV_4_BASE_ADDRESS 31:24 /* RW */ 
#define NV03_PBUS_PCI_NV_5 0x00001814 /* RW */ 
#define NV03_PBUS_PCI_NV_5__ALIAS_1 NV_CONFIG_PCI_NV_5 /* */ 
#define NV03_CONFIG_PCI_NV_5 0x00000014 /* RW */ 
#define NV03_CONFIG_PCI_NV_5__ALIAS_1 NV_PBUS_PCI_NV_5 /* */ 
#define NV03_CONFIG_PCI_NV_5_SPACE_TYPE 0:0 /* C- */ 
#define NV03_CONFIG_PCI_NV_5_SPACE_TYPE_MEMORY 0x00000000 /* C- */ 
#define NV03_CONFIG_PCI_NV_5_SPACE_TYPE_IO 0x00000001 /* -- */ 
#define NV03_CONFIG_PCI_NV_5_ADDRESS_TYPE 2:1 /* C- */ 
#define NV03_CONFIG_PCI_NV_5_ADDRESS_TYPE_32_BIT 0x00000000 /* C- */ 
#define NV03_CONFIG_PCI_NV_5_ADDRESS_TYPE_20_BIT 0x00000001 /* -- */ 
#define NV03_CONFIG_PCI_NV_5_ADDRESS_TYPE_64_BIT 0x00000002 /* -- */ 
#define NV03_CONFIG_PCI_NV_5_PREFETCHABLE 3:3 /* C- */ 
#define NV03_CONFIG_PCI_NV_5_PREFETCHABLE_NOT 0x00000000 /* -- */ 
#define NV03_CONFIG_PCI_NV_5_PREFETCHABLE_MERGABLE 0x00000001 /* C- */ 
#define NV03_CONFIG_PCI_NV_5_BASE_ADDRESS 31:24 /* RW */ 
#define NV03_PBUS_PCI_NV_6 0x00001818 /* RW */ 
#define NV03_PBUS_PCI_NV_6__ALIAS_1 NV_CONFIG_PCI_NV_6 /* */ 
#define NV03_CONFIG_PCI_NV_6 0x00000018 /* RW */ 
#define NV03_CONFIG_PCI_NV_6__ALIAS_1 NV_PBUS_PCI_NV_6 /* */ 
#define NV03_CONFIG_PCI_NV_6_SPACE_TYPE 0:0 /* C- */ 
#define NV03_CONFIG_PCI_NV_6_SPACE_TYPE_MEMORY 0x00000000 /* -- */ 
#define NV03_CONFIG_PCI_NV_6_SPACE_TYPE_IO 0x00000001 /* C- */ 
#define NV03_CONFIG_PCI_NV_6_BASE_ADDRESS 31:8 /* RW */ 
#define NV03_PBUS_PCI_NV_7(i) (0x0000181C+(i)*4) /* R- */ 
#define NV03_PBUS_PCI_NV_7__SIZE_1 4 /* */ 
#define NV03_PBUS_PCI_NV_7__ALIAS_1 NV_CONFIG_PCI_NV_7 /* */ 
#define NV03_CONFIG_PCI_NV_7(i) (0x0000001C+(i)*4) /* R- */ 
#define NV03_CONFIG_PCI_NV_7__SIZE_1 4 /* */ 
#define NV03_CONFIG_PCI_NV_7__ALIAS_1 NV_PBUS_PCI_NV_7 /* */ 
#define NV03_CONFIG_PCI_NV_7_RESERVED 31:0 /* C- */ 
#define NV03_CONFIG_PCI_NV_7_RESERVED_0 0x00000000 /* C- */ 
#define NV03_PBUS_PCI_NV_11 0x0000182C /* R- */ 
#define NV03_PBUS_PCI_NV_11__ALIAS_1 NV_CONFIG_PCI_NV_11 /* */ 
#define NV03_CONFIG_PCI_NV_11 0x0000002C /* R- */ 
#define NV03_CONFIG_PCI_NV_11__ALIAS_1 NV_PBUS_PCI_NV_11 /* */ 
#define NV03_CONFIG_PCI_NV_11_SUBSYSTEM_VENDOR_ID 15:0 /* R- */ 
#define NV03_CONFIG_PCI_NV_11_SUBSYSTEM_VENDOR_ID_NONE 0x00000000 /* R- */ 
#define NV03_CONFIG_PCI_NV_11_SUBSYSTEM_ID 31:16 /* R- */ 
#define NV03_CONFIG_PCI_NV_11_SUBSYSTEM_ID_NONE 0x00000000 /* R- */
#define NV03_PBUS_PCI_NV_12 0x00001830 /* RW */ 
#define NV03_PBUS_PCI_NV_12__ALIAS_1 NV_CONFIG_PCI_NV_12 /* */ 
#define NV03_CONFIG_PCI_NV_12 0x00000030 /* RW */ 
#define NV03_CONFIG_PCI_NV_12__ALIAS_1 NV_PBUS_PCI_NV_12 /* */ 
#define NV03_CONFIG_PCI_NV_12_ROM_DECODE 0:0 /* RW */ 
#define NV03_CONFIG_PCI_NV_12_ROM_DECODE_DISABLED 0x00000000 /* RW */ 
#define NV03_CONFIG_PCI_NV_12_ROM_DECODE_ENABLED 0x00000001 /* RW */ 
#define NV03_CONFIG_PCI_NV_12_ROM_BASE 31:22 /* RW */ 
#define NV03_PBUS_PCI_NV_13 0x00001834 /* RW */ 
#define NV03_PBUS_PCI_NV_13__ALIAS_1 NV_CONFIG_PCI_NV_13 /* */ 
#define NV03_CONFIG_PCI_NV_13 0x00000034 /* RW */ 
#define NV03_CONFIG_PCI_NV_13__ALIAS_1 NV_PBUS_PCI_NV_13 /* */ 
#define NV03_CONFIG_PCI_NV_13_CAP_PTR 7:0 /* C- */ 
#define NV03_CONFIG_PCI_NV_13_CAP_PTR_POWER_MGMT 0x00000060 /* C- */ 
#define NV03_PBUS_PCI_NV_14 0x00001838 /* R- */ 
#define NV03_PBUS_PCI_NV_14__ALIAS_1 NV_CONFIG_PCI_NV_14 /* */ 
#define NV03_CONFIG_PCI_NV_14 0x00000038 /* R- */ 
#define NV03_CONFIG_PCI_NV_14__ALIAS_1 NV_PBUS_PCI_NV_14 /* */ 
#define NV03_CONFIG_PCI_NV_14_RESERVED 31:0 /* C- */ 
#define NV03_CONFIG_PCI_NV_14_RESERVED_0 0x00000000 /* C- */ 
#define NV03_PBUS_PCI_NV_15 0x0000183C /* RW */ 
#define NV03_PBUS_PCI_NV_15__ALIAS_1 NV_CONFIG_PCI_NV_15 /* */ 
#define NV03_CONFIG_PCI_NV_15 0x0000003C /* RW */ 
#define NV03_CONFIG_PCI_NV_15__ALIAS_1 NV_PBUS_PCI_NV_15 /* */ 
#define NV03_CONFIG_PCI_NV_15_INTR_LINE 7:0 /* RW */ 
#define NV03_CONFIG_PCI_NV_15_INTR_LINE_IRQ0 0x00000000 /* RW */
#define NV03_CONFIG_PCI_NV_15_INTR_LINE_IRQ1 0x00000001 /* RW */ 
#define NV03_CONFIG_PCI_NV_15_INTR_LINE_IRQ15 0x0000000F /* RW */ 
#define NV03_CONFIG_PCI_NV_15_INTR_LINE_UNKNOWN 0x000000FF /* RW */
#define NV03_CONFIG_PCI_NV_15_INTR_PIN 15:8 /* C- */ 
#define NV03_CONFIG_PCI_NV_15_INTR_PIN_INTA 0x00000001 /* C- */ 
#define NV03_CONFIG_PCI_NV_15_MIN_GNT 23:16 /* C- */ 
#define NV03_CONFIG_PCI_NV_15_MIN_GNT_NO_REQUIREMENTS 0x00000000 /* -- */ 
#define NV03_CONFIG_PCI_NV_15_MIN_GNT_750NS 0x00000003 /* C- */ 
#define NV03_CONFIG_PCI_NV_15_MAX_LAT 31:24 /* C- */ 
#define NV03_CONFIG_PCI_NV_15_MAX_LAT_NO_REQUIREMENTS 0x00000000 /* -- */ 
#define NV03_CONFIG_PCI_NV_15_MAX_LAT_250NS 0x00000001 /* C- */ 
#define NV03_PBUS_PCI_NV_16 0x00001840 /* RW */ 
#define NV03_PBUS_PCI_NV_16__ALIAS_1 NV_CONFIG_PCI_NV_16 /* */ 
#define NV03_CONFIG_PCI_NV_16 0x00000040 /* RW */ 
#define NV03_CONFIG_PCI_NV_16__ALIAS_1 NV_PBUS_PCI_NV_16 /* */ 
#define NV03_CONFIG_PCI_NV_16_SUBSYSTEM_VENDOR_ID 15:0 /* RW */ 
#define NV03_CONFIG_PCI_NV_16_SUBSYSTEM_VENDOR_ID_NONE 0x00000000 /* R- */ 
#define NV03_CONFIG_PCI_NV_16_SUBSYSTEM_ID 31:16 /* RW */ 
#define NV03_CONFIG_PCI_NV_16_SUBSYSTEM_ID_NONE 0x00000000 /* R- */ 
#define NV03_PBUS_PCI_NV_17 0x00001844 /* RW */ 
#define NV03_PBUS_PCI_NV_17__ALIAS_1 NV_CONFIG_PCI_NV_17 /* */ 
#define NV03_CONFIG_PCI_NV_17 0x00000044 /* RW */ 
#define NV03_CONFIG_PCI_NV_17__ALIAS_1 NV_PBUS_PCI_NV_17 /* */ 
#define NV03_CONFIG_PCI_NV_17_AGP_REV_MAJOR 23:20 /* C- */ 
#define NV03_CONFIG_PCI_NV_17_AGP_REV_MAJOR_1 0x00000001 /* C- */ 
#define NV03_CONFIG_PCI_NV_17_AGP_REV_MINOR 19:16 /* C- */ 
#define NV03_CONFIG_PCI_NV_17_AGP_REV_MINOR_0 0x00000000 /* C- */ 
#define NV03_CONFIG_PCI_NV_17_NEXT_PTR 15:8 /* C- */ 
#define NV03_CONFIG_PCI_NV_17_NEXT_PTR_NULL 0x00000000 /* C- */ 
#define NV03_CONFIG_PCI_NV_17_CAP_ID 7:0 /* C- */ 
#define NV03_CONFIG_PCI_NV_17_CAP_ID_AGP 0x00000002 /* C- */ 
#define NV03_PBUS_PCI_NV_18 0x00001848 /* RW */ 
#define NV03_PBUS_PCI_NV_18__ALIAS_1 NV_CONFIG_PCI_NV_18 /* */ 
#define NV03_CONFIG_PCI_NV_18 0x00000048 /* RW */ 
#define NV03_CONFIG_PCI_NV_18__ALIAS_1 NV_PBUS_PCI_NV_18 /* */ 
#define NV03_CONFIG_PCI_NV_18_AGP_STATUS_RQ 31:24 /* C- */ 
#define NV03_CONFIG_PCI_NV_18_AGP_STATUS_RQ_4 0x00000004 /* C- */ 
#define NV03_CONFIG_PCI_NV_18_AGP_STATUS_SBA 9:9 /* C- */ 
#define NV03_CONFIG_PCI_NV_18_AGP_STATUS_SBA_NONE 0x00000000 /* C- */ 
#define NV03_CONFIG_PCI_NV_18_AGP_STATUS_RATE 1:0 /* C- */ 
#define NV03_CONFIG_PCI_NV_18_AGP_STATUS_RATE_1X 0x00000001 /* -- */ 
#define NV03_CONFIG_PCI_NV_18_AGP_STATUS_RATE_2X 0x00000002 /* -- */ 
#define NV03_CONFIG_PCI_NV_18_AGP_STATUS_RATE_1X_AND_2X 0x00000003 /* C- */ 
#define NV03_PBUS_PCI_NV_19 0x0000184C /* RW */ 
#define NV03_PBUS_PCI_NV_19__ALIAS_1 NV_CONFIG_PCI_NV_19 /* */ 
#define NV03_CONFIG_PCI_NV_19 0x0000004C /* RW */ 
#define NV03_CONFIG_PCI_NV_19__ALIAS_1 NV_PBUS_PCI_NV_19 /* */ 
#define NV03_CONFIG_PCI_NV_19_AGP_COMMAND_RQ_DEPTH 31:24 /* RW */ 
#define NV03_CONFIG_PCI_NV_19_AGP_COMMAND_RQ_DEPTH_0 0x00000000 /* RW */ 
#define NV03_CONFIG_PCI_NV_19_AGP_COMMAND_AGP_ENABLE 8:8 /* RW */ 
#define NV03_CONFIG_PCI_NV_19_AGP_COMMAND_AGP_ENABLE_OFF 0x00000000 /* RW */ 
#define NV03_CONFIG_PCI_NV_19_AGP_COMMAND_DATA_RATE 1:0 /* RW */ 
#define NV03_CONFIG_PCI_NV_19_AGP_COMMAND_DATA_RATE_OFF 0x00000000 /* RW */ 
#define NV03_CONFIG_PCI_NV_19_AGP_COMMAND_DATA_RATE_1X 0x00000001 /* RW */ 
#define NV03_CONFIG_PCI_NV_19_AGP_COMMAND_DATA_RATE_2X 0x00000002 /* RW */ 
#define NV03_PBUS_PCI_NV_20 0x00001850 /* R- */ 
#define NV03_PBUS_PCI_NV_20__ALIAS_1 NV_CONFIG_PCI_NV_20 /* */ 
#define NV03_CONFIG_PCI_NV_20 0x00000050 /* R- */ 
#define NV03_CONFIG_PCI_NV_20__ALIAS_1 NV_PBUS_PCI_NV_20 /* */ 
#define NV03_CONFIG_PCI_NV_20_RESERVED 31:0 /* C- */ 
#define NV03_CONFIG_PCI_NV_20_RESERVED_0 0x00000000 /* C- */ 
#define NV03_PBUS_PCI_NV_21 0x00001854 /* RW */ 
#define NV03_PBUS_PCI_NV_21__ALIAS_1 NV_CONFIG_PCI_NV_21 /* */ 
#define NV03_CONFIG_PCI_NV_21 0x00000054 /* RW */ 
#define NV03_CONFIG_PCI_NV_21__ALIAS_1 NV_PBUS_PCI_NV_21 /* */ 
#define NV03_CONFIG_PCI_NV_21_VGA 0:0 /* RW */ 
#define NV03_CONFIG_PCI_NV_21_VGA_DISABLED 0x00000000 /* RW */ 
#define NV03_CONFIG_PCI_NV_21_VGA_ENABLED 0x00000001 /* RW */ 
#define NV03_PBUS_PCI_NV_22 0x00001858 /* RW */ 
#define NV03_PBUS_PCI_NV_22__ALIAS_1 NV_CONFIG_PCI_NV_22 /* */ 
#define NV03_CONFIG_PCI_NV_22 0x00000058 /* RW */ 
#define NV03_CONFIG_PCI_NV_22__ALIAS_1 NV_PBUS_PCI_NV_22 /* */ 
#define NV03_CONFIG_PCI_NV_22_SCRATCH 23:0 /* RW */ 
#define NV03_CONFIG_PCI_NV_22_SCRATCH_DEFAULT 0x0023D6CE /* RW */
#define NV03_PBUS_PCI_NV_23 0x0000185C /* RW */ 
#define NV03_PBUS_PCI_NV_23__ALIAS_1 NV_CONFIG_PCI_NV_23 /* */ 
#define NV03_CONFIG_PCI_NV_23 0x0000005C /* RW */ 
#define NV03_CONFIG_PCI_NV_23__ALIAS_1 NV_PBUS_PCI_NV_23 /* */ 
#define NV03_CONFIG_PCI_NV_23_AGP2X_HIGHMARK 4:0 /* RW */ 
#define NV03_CONFIG_PCI_NV_23_AGP2X_HIGHMARK_8 0x00000008 /* RW */ 
#define NV03_CONFIG_PCI_NV_23_AGP2X_HIGHMARK_66MHZ 0x00000005 /* RW */ 
#define NV03_CONFIG_PCI_NV_23_AGP2X_HIGHMARK_73MHZ 0x00000006 /* RW */ 
#define NV03_CONFIG_PCI_NV_23_AGP2X_HIGHMARK_80MHZ 0x00000007 /* RW */ 
#define NV03_CONFIG_PCI_NV_23_AGP2X_HIGHMARK_87MHZ 0x00000008 /* RW */ 
#define NV03_CONFIG_PCI_NV_23_AGP2X_HIGHMARK_94MHZ 0x00000009 /* RW */ 
#define NV03_CONFIG_PCI_NV_23_AGP2X_HIGHMARK_100MHZ 0x0000000A /* RW */ 
#define NV03_PBUS_PCI_NV_24 0x00001860 /* RW */ 
#define NV03_PBUS_PCI_NV_24__ALIAS_1 NV_CONFIG_PCI_NV_24 /* */ 
#define NV03_CONFIG_PCI_NV_24 0x00000060 /* RW */ 
#define NV03_CONFIG_PCI_NV_24__ALIAS_1 NV_PBUS_PCI_NV_24 /* */ 
#define NV03_PBUS_PCI_NV_24_PME_D3_COLD 31:31 /* C- */ 
#define NV03_PBUS_PCI_NV_24_PME_D3_COLD_SUPPORTED 0x00000001 /* -- */ 
#define NV03_PBUS_PCI_NV_24_PME_D3_COLD_NOT_SUPPORTED 0x00000000 /* C- */ 
#define NV03_PBUS_PCI_NV_24_PME_D3_HOT 30:30 /* C- */ 
#define NV03_PBUS_PCI_NV_24_PME_D3_HOT_SUPPORTED 0x00000001 /* -- */ 
#define NV03_PBUS_PCI_NV_24_PME_D3_HOT_NOT_SUPPORTED 0x00000000 /* C- */ 
#define NV03_PBUS_PCI_NV_24_PME_D2 29:29 /* C- */ 
#define NV03_PBUS_PCI_NV_24_PME_D2_SUPPORTED 0x00000001 /* -- */ 
#define NV03_PBUS_PCI_NV_24_PME_D2_NOT_SUPPORTED 0x00000000 /* C- */ 
#define NV03_PBUS_PCI_NV_24_PME_D1 28:28 /* C- */ 
#define NV03_PBUS_PCI_NV_24_PME_D1_SUPPORTED 0x00000001 /* -- */ 
#define NV03_PBUS_PCI_NV_24_PME_D1_NOT_SUPPORTED 0x00000000 /* C- */ 
#define NV03_PBUS_PCI_NV_24_PME_D0 27:27 /* C- */ 
#define NV03_PBUS_PCI_NV_24_PME_D0_SUPPORTED 0x00000001 /* -- */ 
#define NV03_PBUS_PCI_NV_24_PME_D0_NOT_SUPPORTED 0x00000000 /* C- */ 
#define NV03_PBUS_PCI_NV_24_D2 26:26 /* C- */ 
#define NV03_PBUS_PCI_NV_24_D2_SUPPORTED 0x00000001 /* -- */ 
#define NV03_PBUS_PCI_NV_24_D2_NOT_SUPPORTED 0x00000000 /* C- */ 
#define NV03_PBUS_PCI_NV_24_D1 25:25 /* C- */ 
#define NV03_PBUS_PCI_NV_24_D1_SUPPORTED 0x00000001 /* -- */ 
#define NV03_PBUS_PCI_NV_24_D1_NOT_SUPPORTED 0x00000000 /* C- */ 
#define NV03_PBUS_PCI_NV_24_DSI 21:21 /* C- */ 
#define NV03_PBUS_PCI_NV_24_DSI_NOT_REQUIRED 0x00000000 /* C- */ 
#define NV03_PBUS_PCI_NV_24_PME_CLOCK 19:19 /* C- */ 
#define NV03_PBUS_PCI_NV_24_PME_CLOCK_NOT_REQUIRED 0x00000000 /* C- */ 
#define NV03_PBUS_PCI_NV_24_VERSION 18:16 /* C- */ 
#define NV03_PBUS_PCI_NV_24_VERSION_1 0x00000001 /* C- */ 
#define NV03_PBUS_PCI_NV_24_NEXT_PTR 15:8 /* R- */ 
#define NV03_PBUS_PCI_NV_24_NEXT_PTR_NULL 0x00000000 /* -- */ 
#define NV03_PBUS_PCI_NV_24_NEXT_PTR_AGP 0x00000044 /* -- */ 
#define NV03_PBUS_PCI_NV_24_CAP_ID 7:0 /* C- */ 
#define NV03_PBUS_PCI_NV_24_CAP_ID_POWER_MGMT 0x00000001 /* C- */ 
#define NV03_PBUS_PCI_NV_25 0x00001864 /* RW */ 
#define NV03_PBUS_PCI_NV_25__ALIAS_1 NV_CONFIG_PCI_NV_25 /* */ 
#define NV03_CONFIG_PCI_NV_25 0x00000064 /* RW */ 
#define NV03_CONFIG_PCI_NV_25__ALIAS_1 NV_PBUS_PCI_NV_25 /* */ 
#define NV03_PBUS_PCI_NV_25_POWER_STATE 1:0 /* RW */ 
#define NV03_PBUS_PCI_NV_25_POWER_STATE_D3_HOT 0x00000003 /* RW */ 
#define NV03_PBUS_PCI_NV_25_POWER_STATE_D2 0x00000002 /* RW */ 
#define NV03_PBUS_PCI_NV_25_POWER_STATE_D1 0x00000001 /* RW */ 
#define NV03_PBUS_PCI_NV_25_POWER_STATE_D0 0x00000000 /* RW */ 
#define NV03_PBUS_PCI_NV_26(i) (0x00001868+(i)*4) /* R- */ 
#define NV03_PBUS_PCI_NV_26__SIZE_1 38 /* */ 
#define NV03_PBUS_PCI_NV_26__ALIAS_1 NV_CONFIG_PCI_NV_25 /* */ 
#define NV03_CONFIG_PCI_NV_26(i) (0x00000068+(i)*4) /* R- */ 
#define NV03_CONFIG_PCI_NV_26__SIZE_1 38 /* */
#define NV03_CONFIG_PCI_NV_26__ALIAS_1 NV_PBUS_PCI_NV_25 /* */ 
#define NV03_PBUS_PCI_NV_26_RESERVED 31:0 /* C- */ 
#define NV03_PBUS_PCI_NV_26_RESERVED_0 0x00000000 /* C- */ /* * External Devices */ 

#define NV03_PEXTDEV 0x00101FFF:0x00101000 /* RW */ 
#define NV03_PROM 0x0011FFFF:0x00110000 /* RW */ 
#define NV03_PALT 0x0012FFFF:0x00120000 /* RW */ 
#define NV03_PDAC 0x00680FFF:0x00680000 /* RW */ 
#define NV03_PEXTDEV_BOOT_0 0x00101000 /* RW */ 
#define NV03_PEXTDEV_BOOT_0_STRAP_BUS_SPEED 0:0 /* RW */ 
#define NV03_PEXTDEV_BOOT_0_STRAP_BUS_SPEED_33MHZ 0x00000000 /* RW */ 
#define NV03_PEXTDEV_BOOT_0_STRAP_BUS_SPEED_66MHZ 0x00000001 /* RW */ 
#define NV03_PEXTDEV_BOOT_0_STRAP_SUB_VENDOR 1:1 /* RW */ 
#define NV03_PEXTDEV_BOOT_0_STRAP_SUB_VENDOR_NO_BIOS 0x00000000 /* RW */ 
#define NV03_PEXTDEV_BOOT_0_STRAP_SUB_VENDOR_BIOS 0x00000001 /* RW */ 
#define NV03_PEXTDEV_BOOT_0_STRAP_RAM_TYPE 2:2 /* RW */ 
#define NV03_PEXTDEV_BOOT_0_STRAP_RAM_TYPE_SDRAM_16MBIT 0x00000000 /* RW */ 
#define NV03_PEXTDEV_BOOT_0_STRAP_RAM_TYPE_SGRAM_16MBIT 0x00000000 /* RW */ 
#define NV03_PEXTDEV_BOOT_0_STRAP_RAM_TYPE_SGRAM_8MBIT 0x00000001 /* RW */ 
#define NV03_PEXTDEV_BOOT_0_STRAP_NEC_MODE 3:3 /* RW */ 
#define NV03_PEXTDEV_BOOT_0_STRAP_NEC_MODE_OFF 0x00000000 /* RW */ 
#define NV03_PEXTDEV_BOOT_0_STRAP_NEC_MODE_ON 0x00000001 /* RW */ 
#define NV03_PEXTDEV_BOOT_0_STRAP_RAM_WIDTH 4:4 /* RW */ 
#define NV03_PEXTDEV_BOOT_0_STRAP_RAM_WIDTH_64 0x00000000 /* RW */ 
#define NV03_PEXTDEV_BOOT_0_STRAP_RAM_WIDTH_128 0x00000001 /* RW */ 
#define NV03_PEXTDEV_BOOT_0_STRAP_BUS_TYPE 5:5 /* RW */ 
#define NV03_PEXTDEV_BOOT_0_STRAP_BUS_TYPE_PCI 0x00000000 /* RW */ 
#define NV03_PEXTDEV_BOOT_0_STRAP_BUS_TYPE_AGP 0x00000001 /* RW */ 
#define NV03_PEXTDEV_BOOT_0_STRAP_CRYSTAL 6:6 /* RW */ 
#define NV03_PEXTDEV_BOOT_0_STRAP_CRYSTAL_13500K 0x00000000 /* RW */ 
#define NV03_PEXTDEV_BOOT_0_STRAP_CRYSTAL_14318180 0x00000001 /* RW */ 
#define NV03_PEXTDEV_BOOT_0_STRAP_TVMODE 8:7 /* RW */ 
#define NV03_PEXTDEV_BOOT_0_STRAP_TVMODE_SECAM 0x00000000 /* RW */ 
#define NV03_PEXTDEV_BOOT_0_STRAP_TVMODE_NTSC 0x00000001 /* RW */ 
#define NV03_PEXTDEV_BOOT_0_STRAP_TVMODE_PAL 0x00000002 /* RW */ 
#define NV03_PEXTDEV_BOOT_0_STRAP_TVMODE_DISABLED 0x00000003 /* RW */ 
#define NV03_PEXTDEV_BOOT_0_STRAP_AGP_2X 9:9 /* RW */ 
#define NV03_PEXTDEV_BOOT_0_STRAP_AGP_2X_ENABLED 0x00000000 /* RW */ 
#define NV03_PEXTDEV_BOOT_0_STRAP_AGP_2X_DISABLED 0x00000001 /* RW */ 
#define NV03_PEXTDEV_BOOT_0_STRAP_UNUSED 10:10 /* RW */

#define NV03_PEXTDEV_BOOT_0_STRAP_OVERWRITE 11:11 /* RW */ 
#define NV03_PEXTDEV_BOOT_0_STRAP_OVERWRITE_DISABLED 0x00000000 /* RW */ 
#define NV03_PEXTDEV_BOOT_0_STRAP_OVERWRITE_ENABLED 0x00000001 /* RW */ 
#define NV03_PEXTDEV_BOOT_0_STRAP_RAM_TYPE_EDO 0x00000000 /* R- */ 
#define NV03_PEXTDEV_BOOT_0_STRAP_RAM_TYPE_SGRAM_256K 0x00000001 /* R- */ 
#define NV03_PEXTDEV_BOOT_0_STRAP_RAM_TYPE_NEC_EDO 0x00000002 /* R- */ 
#define NV03_PEXTDEV_BOOT_0_STRAP_RAM_TYPE_NEC_SGRAM 0x00000003 /* R- */ 
#define NV03_PFB_ROM_CONFIG 0x00101200 /* RW */ 
#define NV03_PFB_ROM_CONFIG_TW1 3:0 /* RW */ 
#define NV03_PFB_ROM_CONFIG_TW1_DEFAULT 0x0000000f /* RW */ 
#define NV03_PFB_ROM_CONFIG_TW0 5:4 /* RW */ 
#define NV03_PFB_ROM_CONFIG_TW0_DEFAULT 0x00000003 /* RW */ 
#define NV03_PDAC_DATA(i) (0x00500000+(i)*4) /* RW */ 
#define NV03_PDAC_DATA__SIZE_1 16 /* */ 
#define NV03_PDAC_DATA_VALUE 7:0 /* RW */ 
#define NV03_PROM_DATA(i) (0x00110000+(i)) /* RW */ 
#define NV03_PROM_DATA__SIZE_1 65536 /* */ 
#define NV03_PROM_DATA_VALUE 7:0 /* RW */ 
#define NV03_PALT_DATA(i) (0x00120000+(i)) /* RW */ 
#define NV03_PALT_DATA__SIZE_1 65536 /* */ 
#define NV03_PALT_DATA_VALUE 7:0 /* RW */ /* * Master Control */ 
#define NV03_PMC 0x00000FFF:0x00000000 /* RW */ 
#define NV03_PMC_BOOT_0 0x00000000 /* R- */ 
#define NV03_PMC_BOOT_0_FIB_REVISION 3:0 /* C- */ 
#define NV03_PMC_BOOT_0_FIB_REVISION_0 0x00000000 /* -- */ 
#define NV03_PMC_BOOT_0_FIB_REVISION_1 0x00000001 /* -- */ 
#define NV03_PMC_BOOT_0_FIB_REVISION_2 0x00000002 /* C- */ 
#define NV03_PMC_BOOT_0_MASK_REVISION 7:4 /* C- */ 
#define NV03_PMC_BOOT_0_MASK_REVISION_A 0x00000000 /* -- */ 
#define NV03_PMC_BOOT_0_MASK_REVISION_B 0x00000001 /* -- */ 
#define NV03_PMC_BOOT_0_MASK_REVISION_C 0x00000002 /* C- */ 
#define NV03_PMC_BOOT_0_IMPLEMENTATION 15:8 /* C- */ 
#define NV03_PMC_BOOT_0_IMPLEMENTATION_NV3 0x00000001 /* C- */ 
#define NV03_PMC_BOOT_0_ARCHITECTURE 23:16 /* C- */ 
#define NV03_PMC_BOOT_0_ARCHITECTURE_NV0 0x00000000 /* -- */ 
#define NV03_PMC_BOOT_0_ARCHITECTURE_NV1 0x00000001 /* -- */ 
#define NV03_PMC_BOOT_0_ARCHITECTURE_NV2 0x00000002 /* -- */ 
#define NV03_PMC_BOOT_0_ARCHITECTURE_NV3 0x00000003 /* C- */ 
#define NV03_PMC_BOOT_0_MANUFACTURER 27:24 /* C- */ 
#define NV03_PMC_BOOT_0_MANUFACTURER_NVIDIA 0x00000000 /* C- */ 
#define NV03_PMC_BOOT_0_FOUNDRY 31:28 /* C- */ 
#define NV03_PMC_BOOT_0_FOUNDRY_SGS 0x00000000 /* -- */ 
#define NV03_PMC_BOOT_0_FOUNDRY_HELIOS 0x00000001 /* -- */ 
#define NV03_PMC_BOOT_0_FOUNDRY_TSMC 0x00000002 /* C- */ 
#define NV03_PMC_INTR_0 0x00000100 /* RW */ 
#define NV03_PMC_INTR_0_PAUDIO 0:0 /* R- */
#define NV03_PMC_INTR_0_PAUDIO_NOT_PENDING 0x00000000 /* R- */ 
#define NV03_PMC_INTR_0_PAUDIO_PENDING 0x00000001 /* R- */ 
#define NV03_PMC_INTR_0_PMEDIA 4:4 /* R- */ 
#define NV03_PMC_INTR_0_PMEDIA_NOT_PENDING 0x00000000 /* R- */ 
#define NV03_PMC_INTR_0_PMEDIA_PENDING 0x00000001 /* R- */ 
#define NV03_PMC_INTR_0_PFIFO 8:8 /* R- */ 
#define NV03_PMC_INTR_0_PFIFO_NOT_PENDING 0x00000000 /* R- */ 
#define NV03_PMC_INTR_0_PFIFO_PENDING 0x00000001 /* R- */ 
#define NV03_PMC_INTR_0_PGRAPH0 12:12 /* R- */ 
#define NV03_PMC_INTR_0_PGRAPH0_NOT_PENDING 0x00000000 /* R- */ 
#define NV03_PMC_INTR_0_PGRAPH0_PENDING 0x00000001 /* R- */ 
#define NV03_PMC_INTR_0_PGRAPH1 13:13 /* R- */ 
#define NV03_PMC_INTR_0_PGRAPH1_NOT_PENDING 0x00000000 /* R- */ 
#define NV03_PMC_INTR_0_PGRAPH1_PENDING 0x00000001 /* R- */ 
#define NV03_PMC_INTR_0_PVIDEO 16:16 /* R- */ 
#define NV03_PMC_INTR_0_PVIDEO_NOT_PENDING 0x00000000 /* R- */ 
#define NV03_PMC_INTR_0_PVIDEO_PENDING 0x00000001 /* R- */ 
#define NV03_PMC_INTR_0_PTIMER 20:20 /* R- */ 
#define NV03_PMC_INTR_0_PTIMER_NOT_PENDING 0x00000000 /* R- */ 
#define NV03_PMC_INTR_0_PTIMER_PENDING 0x00000001 /* R- */ 
#define NV03_PMC_INTR_0_PFB 24:24 /* R- */ 
#define NV03_PMC_INTR_0_PFB_NOT_PENDING 0x00000000 /* R- */ 
#define NV03_PMC_INTR_0_PFB_PENDING 0x00000001 /* R- */ 
#define NV03_PMC_INTR_0_PBUS 28:28 /* R- */ 
#define NV03_PMC_INTR_0_PBUS_NOT_PENDING 0x00000000 /* R- */ 
#define NV03_PMC_INTR_0_PBUS_PENDING 0x00000001 /* R- */ 
#define NV03_PMC_INTR_0_SOFTWARE 31:31 /* RW */ 
#define NV03_PMC_INTR_0_SOFTWARE_NOT_PENDING 0x00000000 /* RW */ 
#define NV03_PMC_INTR_0_SOFTWARE_PENDING 0x00000001 /* RW */ 
#define NV03_PMC_INTR_EN_0 0x00000140 /* RW */ 
#define NV03_PMC_INTR_EN_0_INTA 1:0 /* RW */ 
#define NV03_PMC_INTR_EN_0_INTA_DISABLED 0x00000000 /* RW */ 
#define NV03_PMC_INTR_EN_0_INTA_HARDWARE 0x00000001 /* RW */ 
#define NV03_PMC_INTR_EN_0_INTA_SOFTWARE 0x00000002 /* RW */ 
#define NV03_PMC_INTR_READ_0 0x00000160 /* R- */ 
#define NV03_PMC_INTR_READ_0_INTA 0:0 /* R- */ 
#define NV03_PMC_INTR_READ_0_INTA_LOW 0x00000000 /* R- */ 
#define NV03_PMC_INTR_READ_0_INTA_HIGH 0x00000001 /* R- */ 
#define NV03_PMC_ENABLE 0x00000200 /* RW */ 
#define NV03_PMC_ENABLE_PAUDIO 0:0 /* RW */ 
#define NV03_PMC_ENABLE_PAUDIO_DISABLED 0x00000000 /* RW */ 
#define NV03_PMC_ENABLE_PAUDIO_ENABLED 0x00000001 /* RW */ 
#define NV03_PMC_ENABLE_PMEDIA 4:4 /* RW */ 
#define NV03_PMC_ENABLE_PMEDIA_DISABLED 0x00000000 /* RW */ 
#define NV03_PMC_ENABLE_PMEDIA_ENABLED 0x00000001 /* RW */ 
#define NV03_PMC_ENABLE_PFIFO 8:8 /* RW */ 
#define NV03_PMC_ENABLE_PFIFO_DISABLED 0x00000000 /* RW */ 
#define NV03_PMC_ENABLE_PFIFO_ENABLED 0x00000001 /* RW */ 
#define NV03_PMC_ENABLE_PGRAPH 12:12 /* RW */ 
#define NV03_PMC_ENABLE_PGRAPH_DISABLED 0x00000000 /* RW */ 
#define NV03_PMC_ENABLE_PGRAPH_ENABLED 0x00000001 /* RW */ 
#define NV03_PMC_ENABLE_PPMI 16:16 /* RW */ 
#define NV03_PMC_ENABLE_PPMI_DISABLED 0x00000000 /* RW */ 
#define NV03_PMC_ENABLE_PPMI_ENABLED 0x00000001 /* RW */ 
#define NV03_PMC_ENABLE_PFB 20:20 /* RW */
#define NV03_PMC_ENABLE_PFB_DISABLED 0x00000000 /* RW */ 
#define NV03_PMC_ENABLE_PFB_ENABLED 0x00000001 /* RW */ 
#define NV03_PMC_ENABLE_PCRTC 24:24 /* RW */ 
#define NV03_PMC_ENABLE_PCRTC_DISABLED 0x00000000 /* RW */ 
#define NV03_PMC_ENABLE_PCRTC_ENABLED 0x00000001 /* RW */ 
#define NV03_PMC_ENABLE_PVIDEO 28:28 /* RW */ 
#define NV03_PMC_ENABLE_PVIDEO_DISABLED 0x00000000 /* RW */ 
#define NV03_PMC_ENABLE_PVIDEO_ENABLED 0x00000001 /* RW */ /* * FIFO */ 

#define NV03_PFIFO 0x00003FFF:0x00002000 /* RW */ 
#define NV03_USER 0x00FFFFFF:0x00800000 /* RW */ 

/* * Graphics Engine */ 
#define NV03_PGRAPH 0x00401FFF:0x00400000 /* RW */ 

/* * Timer */ 
#define NV03_PTIMER 0x00009FFF:0x00009000 /* RW */ 
/* * RAMDAC */ 
#define NV03_PRAMDAC 0x00680FFF:0x00680300 /* RW */ 
#define NV03_USER_DAC 0x00681FFF:0x00681200 /* RW */ 

#define NV03_PRAMDAC_CU_START_POS 0x00680300 /* RW */ 
#define NV03_PRAMDAC_CU_START_POS_X 11:0 /* RW */ 
#define NV03_PRAMDAC_CU_START_POS_Y 27:16 /* RW */ 
#define NV03_PRAMDAC_APLL_COEFF 0x00680500 /* RW */ 
#define NV03_PRAMDAC_APLL_COEFF_MDIV 7:0 /* RW */ 
#define NV03_PRAMDAC_APLL_COEFF_NDIV 15:8 /* RW */ 
#define NV03_PRAMDAC_APLL_COEFF_PDIV 18:16 /* RW */ 
#define NV03_PRAMDAC_MPLL_COEFF 0x00680504 /* RW */ 
#define NV03_PRAMDAC_MPLL_COEFF_MDIV 7:0 /* RW */ 
#define NV03_PRAMDAC_MPLL_COEFF_NDIV 15:8 /* RW */ 
#define NV03_PRAMDAC_MPLL_COEFF_PDIV 18:16 /* RW */ 
#define NV03_PRAMDAC_VPLL_COEFF 0x00680508 /* RW */ 
#define NV03_PRAMDAC_VPLL_COEFF_MDIV 7:0 /* RW */ 
#define NV03_PRAMDAC_VPLL_COEFF_NDIV 15:8 /* RW */ 
#define NV03_PRAMDAC_VPLL_COEFF_PDIV 18:16 /* RW */ 
#define NV03_PRAMDAC_PLL_COEFF_SELECT 0x0068050C /* RW */ 
#define NV03_PRAMDAC_PLL_COEFF_SELECT_DLL_BYPASS 4:4 /* RW */ 
#define NV03_PRAMDAC_PLL_COEFF_SELECT_DLL_BYPASS_FALSE 0x00000000 /* RW */ 
#define NV03_PRAMDAC_PLL_COEFF_SELECT_DLL_BYPASS_TRUE 0x00000001 /* RW */ 
#define NV03_PRAMDAC_PLL_COEFF_SELECT_MPLL_SOURCE 8:8 /* RW */ 
#define NV03_PRAMDAC_PLL_COEFF_SELECT_MPLL_SOURCE_DEFAULT 0x00000000 /* RW */ 
#define NV03_PRAMDAC_PLL_COEFF_SELECT_MPLL_SOURCE_PROG 0x00000001 /* RW */ 
#define NV03_PRAMDAC_PLL_COEFF_SELECT_MPLL_BYPASS 12:12 /* RW */ 
#define NV03_PRAMDAC_PLL_COEFF_SELECT_MPLL_BYPASS_FALSE 0x00000000 /* RW */ 
#define NV03_PRAMDAC_PLL_COEFF_SELECT_MPLL_BYPASS_TRUE 0x00000001 /* RW */ 
#define NV03_PRAMDAC_PLL_COEFF_SELECT_VPLL_SOURCE 16:16 /* RW */ 
#define NV03_PRAMDAC_PLL_COEFF_SELECT_VPLL_SOURCE_DEFAULT 0x00000000 /* RW */ 
#define NV03_PRAMDAC_PLL_COEFF_SELECT_VPLL_SOURCE_PROG 0x00000001 /* RW */ 
#define NV03_PRAMDAC_PLL_COEFF_SELECT_VPLL_BYPASS 20:20 /* RW */ 
#define NV03_PRAMDAC_PLL_COEFF_SELECT_VPLL_BYPASS_FALSE 0x00000000 /* RW */ 
#define NV03_PRAMDAC_PLL_COEFF_SELECT_VPLL_BYPASS_TRUE 0x00000001 /* RW */ 
#define NV03_PRAMDAC_PLL_COEFF_SELECT_PCLK_SOURCE 25:24 /* RW */ 
#define NV03_PRAMDAC_PLL_COEFF_SELECT_PCLK_SOURCE_VPLL 0x00000000 /* RW */ 
#define NV03_PRAMDAC_PLL_COEFF_SELECT_PCLK_SOURCE_VIP 0x00000001 /* RW */ 
#define NV03_PRAMDAC_PLL_COEFF_SELECT_PCLK_SOURCE_XTALOSC 0x00000002 /* RW */ 
#define NV03_PRAMDAC_PLL_COEFF_SELECT_VCLK_RATIO 28:28 /* RW */ 
#define NV03_PRAMDAC_PLL_COEFF_SELECT_VCLK_RATIO_DB1 0x00000000 /* RW */ 
#define NV03_PRAMDAC_PLL_COEFF_SELECT_VCLK_RATIO_DB2 0x00000001 /* RW */ 
#define NV03_PRAMDAC_PLL_SETUP_CONTROL 0x00680510 /* RW */ 
#define NV03_PRAMDAC_PLL_SETUP_CONTROL_VALUE 10:0 /* RW */ 
#define NV03_PRAMDAC_PLL_SETUP_CONTROL_VAL 0x0000044E /* RW */ 
#define NV03_PRAMDAC_PLL_SETUP_CONTROL_PWRDWN 12:12 /* RW */ 
#define NV03_PRAMDAC_PLL_SETUP_CONTROL_PWRDWN_ON 0x00000000 /* RW */ 
#define NV03_PRAMDAC_PLL_SETUP_CONTROL_PWRDWN_OFF 0x00000001 /* RW */ 
#define NV03_PRAMDAC_PLL_TEST_COUNTER 0x00680514 /* RW */ 
#define NV03_PRAMDAC_PLL_TEST_COUNTER_NOOFIPCLKS 9:0 /* -W */ 
#define NV03_PRAMDAC_PLL_TEST_COUNTER_VALUE 15:0 /* R- */ 
#define NV03_PRAMDAC_PLL_TEST_COUNTER_ENABLE 16:16 /* RW */ 
#define NV03_PRAMDAC_PLL_TEST_COUNTER_ENABLE_DEASSERTED 0x00000000 /* RW */ 
#define NV03_PRAMDAC_PLL_TEST_COUNTER_ENABLE_ASSERTED 0x00000001 /* RW */ 
#define NV03_PRAMDAC_PLL_TEST_COUNTER_RESET 20:20 /* RW */ 
#define NV03_PRAMDAC_PLL_TEST_COUNTER_RESET_DEASSERTED 0x00000000 /* RW */ 
#define NV03_PRAMDAC_PLL_TEST_COUNTER_RESET_ASSERTED 0x00000001 /* RW */ 
#define NV03_PRAMDAC_PLL_TEST_COUNTER_SOURCE 25:24 /* RW */ 
#define NV03_PRAMDAC_PLL_TEST_COUNTER_SOURCE_MCLK 0x00000000 /* RW */ 
#define NV03_PRAMDAC_PLL_TEST_COUNTER_SOURCE_VCLK 0x00000001 /* RW */ 
#define NV03_PRAMDAC_PLL_TEST_COUNTER_SOURCE_ACLK 0x00000002 /* RW */ 
#define NV03_PRAMDAC_PLL_TEST_COUNTER_PDIV_RST 28:28 /* RW */ 
#define NV03_PRAMDAC_PLL_TEST_COUNTER_PDIVRST_DEASSERTED 0x00000000 /* RW */ 
#define NV03_PRAMDAC_PLL_TEST_COUNTER_PDIVRST_ASSERTED 0x00000001 /* RW */ 
#define NV03_PRAMDAC_PLL_TEST_COUNTER_DLL_LOCK 29:29 /* R- */ 
#define NV03_PRAMDAC_PLL_TEST_COUNTER_DLL_NOTLOCKED 0x00000000 /* R- */ 
#define NV03_PRAMDAC_PLL_TEST_COUNTER_DLL_LOCKED 0x00000001 /* R- */ 
#define NV03_PRAMDAC_PLL_TEST_COUNTER_MPLL_LOCK 30:30 /* R- */ 
#define NV03_PRAMDAC_PLL_TEST_COUNTER_MPLL_NOTLOCKED 0x00000000 /* R- */ 
#define NV03_PRAMDAC_PLL_TEST_COUNTER_MPLL_LOCKED 0x00000001 /* R- */ 
#define NV03_PRAMDAC_PLL_TEST_COUNTER_VPLL_LOCK 31:31 /* R- */ 
#define NV03_PRAMDAC_PLL_TEST_COUNTER_VPLL_NOTLOCKED 0x00000000 /* R- */ 
#define NV03_PRAMDAC_PLL_TEST_COUNTER_VPLL_LOCKED 0x00000001 /* R- */ 
#define NV03_PRAMDAC_PALETTE_TEST 0x00680518 /* RW */ 
#define NV03_PRAMDAC_PALETTE_TEST_BLUE_DATA 7:0 /* R- */ 
#define NV03_PRAMDAC_PALETTE_TEST_GREEN_DATA 15:8 /* R- */ 
#define NV03_PRAMDAC_PALETTE_TEST_RED_DATA 23:16 /* R- */ 
#define NV03_PRAMDAC_PALETTE_TEST_MODE 24:24 /* RW */ 
#define NV03_PRAMDAC_PALETTE_TEST_MODE_8BIT 0x00000000 /* RW */ 
#define NV03_PRAMDAC_PALETTE_TEST_MODE_24BIT 0x00000001 /* RW */ 
#define NV03_PRAMDAC_PALETTE_TEST_ADDRINC 28:28 /* RW */ 
#define NV03_PRAMDAC_PALETTE_TEST_ADDRINC_READWRITE 0x00000000 /* RW */ 
#define NV03_PRAMDAC_PALETTE_TEST_ADDRINC_WRITEONLY 0x00000001 /* RW */ 
#define NV03_PRAMDAC_GENERAL_CONTROL 0x00680600 /* RW */ 
#define NV03_PRAMDAC_GENERAL_CONTROL_FF_COEFF 1:0 /* RW */ 
#define NV03_PRAMDAC_GENERAL_CONTROL_FF_COEFF_DEF 0x00000000 /* RW */ 
#define NV03_PRAMDAC_GENERAL_CONTROL_IDC_MODE 4:4 /* RW */ 
#define NV03_PRAMDAC_GENERAL_CONTROL_IDC_MODE_GAMMA 0x00000000 /* RW */ 
#define NV03_PRAMDAC_GENERAL_CONTROL_IDC_MODE_INDEX 0x00000001 /* RW */ 
#define NV03_PRAMDAC_GENERAL_CONTROL_VGA_STATE 8:8 /* RW */ 
#define NV03_PRAMDAC_GENERAL_CONTROL_VGA_STATE_NOTSE 0x00000000 /* RW */ 
#define NV03_PRAMDAC_GENERAL_CONTROL_VGA_STATE_SEL 0x00000001 /* RW */ 
#define NV03_PRAMDAC_GENERAL_CONTROL_565_MODE 12:12 /* RW */ 
#define NV03_PRAMDAC_GENERAL_CONTROL_565_MODE_NOTSEL 0x00000000 /* RW */ 
#define NV03_PRAMDAC_GENERAL_CONTROL_565_MODE_SEL 0x00000001 /* RW */ 
#define NV03_PRAMDAC_GENERAL_CONTROL_BLK_PEDSTL 16:16 /* RW */ 
#define NV03_PRAMDAC_GENERAL_CONTROL_BLK_PEDSTL_OFF 0x00000000 /* RW */ 
#define NV03_PRAMDAC_GENERAL_CONTROL_BLK_PEDSTL_ON 0x00000001 /* RW */ 
#define NV03_PRAMDAC_GENERAL_CONTROL_TERMINATION 17:17 /* RW */ 
#define NV03_PRAMDAC_GENERAL_CONTROL_TERMINATION_37OHM 0x00000000 /* RW */ 
#define NV03_PRAMDAC_GENERAL_CONTROL_TERMINATION_75OHM 0x00000001 /* RW */ 
#define NV03_PRAMDAC_GENERAL_CONTROL_BPC 20:20 /* RW */ 
#define NV03_PRAMDAC_GENERAL_CONTROL_BPC_6BITS 0x00000000 /* RW */ 
#define NV03_PRAMDAC_GENERAL_CONTROL_BPC_8BITS 0x00000001 /* RW */ 
#define NV03_PRAMDAC_GENERAL_CONTROL_DAC_SLEEP 24:24 /* RW */ 
#define NV03_PRAMDAC_GENERAL_CONTROL_DAC_SLEEP_DIS 0x00000000 /* RW */ 
#define NV03_PRAMDAC_GENERAL_CONTROL_DAC_SLEEP_EN 0x00000001 /* RW */ 
#define NV03_PRAMDAC_GENERAL_CONTROL_PALETTE_CLK 28:28 /* RW */ 
#define NV03_PRAMDAC_GENERAL_CONTROL_PALETTE_CLK_EN 0x00000000 /* RW */ 
#define NV03_PRAMDAC_GENERAL_CONTROL_PALETTE_CLK_DIS 0x00000001 /* RW */ 
#define NV03_PRAMDAC_PALETTE_RECOVERY 0x00680604 /* R- */ 
#define NV03_PRAMDAC_PALETTE_RECOVERY_ACTIVE_ADDRESS 7:0 /* R- */
#define NV03_PRAMDAC_PALETTE_RECOVERY_RGB_POINTER 10:8 /* R- */ 
#define NV03_PRAMDAC_PALETTE_RECOVERY_RGB_POINTER_RED 0x00000001 /* R- */ 
#define NV03_PRAMDAC_PALETTE_RECOVERY_RGB_POINTER_GREEN 0x00000002 /* R- */ 
#define NV03_PRAMDAC_PALETTE_RECOVERY_RGB_POINTER_BLUE 0x00000004 /* R- */ 
#define NV03_PRAMDAC_PALETTE_RECOVERY_DAC_STATE 13:12 /* R- */ 
#define NV03_PRAMDAC_PALETTE_RECOVERY_DAC_STATE_WRITE 0x00000000 /* R- */ 
#define NV03_PRAMDAC_PALETTE_RECOVERY_DAC_STATE_READ 0x00000003 /* R- */ 
#define NV03_PRAMDAC_PALETTE_RECOVERY_RED_DATA 23:16 /* R- */ 
#define NV03_PRAMDAC_PALETTE_RECOVERY_GREEN_DATA 31:24 /* R- */ 
#define NV03_PRAMDAC_TEST_CONTROL 0x00680608 /* RW */ 
#define NV03_PRAMDAC_TEST_CONTROL_CRC_RESET 0:0 /* RW */ 
#define NV03_PRAMDAC_TEST_CONTROL_CRC_RESET_DEASSERTED 0x00000000 /* RW */ 
#define NV03_PRAMDAC_TEST_CONTROL_CRC_RESET_ASSERTED 0x00000001 /* RW */ 
#define NV03_PRAMDAC_TEST_CONTROL_CRC_ENABLE 4:4 /* RW */ 
#define NV03_PRAMDAC_TEST_CONTROL_CRC_ENABLE_DEASSERTED 0x00000000 /* RW */ 
#define NV03_PRAMDAC_TEST_CONTROL_CRC_ENABLE_ASSERTED 0x00000001 /* RW */ 
#define NV03_PRAMDAC_TEST_CONTROL_CRC_CHANNEL 9:8 /* RW */ 
#define NV03_PRAMDAC_TEST_CONTROL_CRC_CHANNEL_BLUE 0x00000000 /* RW */ 
#define NV03_PRAMDAC_TEST_CONTROL_CRC_CHANNEL_GREEN 0x00000001 /* RW */ 
#define NV03_PRAMDAC_TEST_CONTROL_CRC_CHANNEL_RED 0x00000002 /* RW */ 
#define NV03_PRAMDAC_TEST_CONTROL_TP_INS_EN 12:12 /* RW */ 
#define NV03_PRAMDAC_TEST_CONTROL_TP_INS_EN_DEASSERTED 0x00000000 /* RW */ 
#define NV03_PRAMDAC_TEST_CONTROL_TP_INS_EN_ASSERTED 0x00000001 /* RW */ 
#define NV03_PRAMDAC_TEST_CONTROL_PWRDWN_DAC 16:16 /* RW */ 
#define NV03_PRAMDAC_TEST_CONTROL_PWRDWN_DAC_ON 0x00000000 /* RW */ 
#define NV03_PRAMDAC_TEST_CONTROL_PWRDWN_DAC_OFF 0x00000001 /* RW */ 
#define NV03_PRAMDAC_TEST_CONTROL_DACTM 20:20 /* RW */
#define NV03_PRAMDAC_TEST_CONTROL_DACTM_NORMAL 0x00000000 /* RW */ 
#define NV03_PRAMDAC_TEST_CONTROL_DACTM_TEST 0x00000001 /* RW */ 
#define NV03_PRAMDAC_TEST_CONTROL_TPATH1 24:24 /* RW */
#define NV03_PRAMDAC_TEST_CONTROL_TPATH1_CLEAR 0x00000000 /* RW */ 
#define NV03_PRAMDAC_TEST_CONTROL_TPATH1_SET 0x00000001 /* RW */ 
#define NV03_PRAMDAC_TEST_CONTROL_TPATH31 25:25 /* RW */
#define NV03_PRAMDAC_TEST_CONTROL_TPATH31_CLEAR 0x00000000 /* RW */ 
#define NV03_PRAMDAC_TEST_CONTROL_TPATH31_SET 0x00000001 /* RW */ 
#define NV03_PRAMDAC_TEST_CONTROL_SENSEB 28:28 /* R- */
#define NV03_PRAMDAC_TEST_CONTROL_SENSEB_SOMELO 0x00000000 /* R- */ 
#define NV03_PRAMDAC_TEST_CONTROL_SENSEB_ALLHI 0x00000001 /* R- */ 
#define NV03_PRAMDAC_CHECKSUM 0x0068060C /* R- */ 
#define NV03_PRAMDAC_CHECKSUM_VALUE 23:0 /* R- */ 
#define NV03_PRAMDAC_TESTPOINT_DATA 0x00680610 /* -W */ 
#define NV03_PRAMDAC_TESTPOINT_DATA_RED 9:0 /* -W */ 
#define NV03_PRAMDAC_TESTPOINT_DATA_GREEN 19:10 /* -W */ 
#define NV03_PRAMDAC_TESTPOINT_DATA_BLUE 29:20 /* -W */ 
#define NV03_PRAMDAC_TESTPOINT_DATA_BLACK 30:30 /* -W */ 
#define NV03_PRAMDAC_TESTPOINT_DATA_NOTBLANK 31:31 /* -W */ 
#define NV03_PRAMDAC_VSERR_WIDTH 0x00680700 /* RW */ 
#define NV03_PRAMDAC_VSERR_WIDTH_VAL 10:0 /* RW */ 
#define NV03_PRAMDAC_VEQU_END 0x00680704 /* RW */ 
#define NV03_PRAMDAC_VEQU_END_VAL 10:0 /* RW */ 
#define NV03_PRAMDAC_VBBLANK_END 0x00680708 /* RW */ 
#define NV03_PRAMDAC_VBBLANK_END_VAL 10:0 /* RW */ 
#define NV03_PRAMDAC_VBLANK_END 0x0068070C /* RW */ 
#define NV03_PRAMDAC_VBLANK_END_VAL 10:0 /* RW */ 
#define NV03_PRAMDAC_VBLANK_START 0x00680710 /* RW */ 
#define NV03_PRAMDAC_VBLANK_START_VAL 10:0 /* RW */ 
#define NV03_PRAMDAC_VBBLANK_START 0x00680714 /* RW */ 
#define NV03_PRAMDAC_VBBLANK_START_VAL 10:0 /* RW */ 
#define NV03_PRAMDAC_VEQU_START 0x00680718 /* RW */ 
#define NV03_PRAMDAC_VEQU_START_VAL 10:0 /* RW */ 
#define NV03_PRAMDAC_VTOTAL 0x0068071C /* RW */ 
#define NV03_PRAMDAC_VTOTAL_VAL 10:0 /* RW */ 
#define NV03_PRAMDAC_HSYNC_WIDTH 0x00680720 /* RW */
#define NV03_PRAMDAC_HSYNC_WIDTH_VAL 10:0 /* RW */ 
#define NV03_PRAMDAC_HBURST_START 0x00680724 /* RW */ 
#define NV03_PRAMDAC_HBURST_START_VAL 10:0 /* RW */ 
#define NV03_PRAMDAC_HBURST_END 0x00680728 /* RW */ 
#define NV03_PRAMDAC_HBURST_END_VAL 10:0 /* RW */ 
#define NV03_PRAMDAC_HBLANK_START 0x0068072C /* RW */ 
#define NV03_PRAMDAC_HBLANK_START_VAL 10:0 /* RW */ 
#define NV03_PRAMDAC_HBLANK_END 0x00680730 /* RW */ 
#define NV03_PRAMDAC_HBLANK_END_VAL 10:0 /* RW */ 
#define NV03_PRAMDAC_HTOTAL 0x00680734 /* RW */ 
#define NV03_PRAMDAC_HTOTAL_VAL 10:0 /* RW */
#define NV03_PRAMDAC_HEQU_WIDTH 0x00680738 /* RW */ 
#define NV03_PRAMDAC_HEQU_WIDTH_VAL 10:0 /* RW */ 
#define NV03_PRAMDAC_HSERR_WIDTH 0x0068073C /* RW */ 
#define NV03_PRAMDAC_HSERR_WIDTH_VAL 10:0 /* RW */ 
#define NV03_USER_DAC_PIXEL_MASK 0x006813C6 /* RW */ 
#define NV03_USER_DAC_PIXEL_MASK_VALUE 7:0 /* RW */ 
#define NV03_USER_DAC_PIXEL_MASK_MASK 0x000000FF /* RW */ 
#define NV03_USER_DAC_READ_MODE_ADDRESS 0x006813C7 /* RW */ 
#define NV03_USER_DAC_READ_MODE_ADDRESS_VALUE 7:0 /* RW */ 
#define NV03_USER_DAC_READ_MODE_ADDRESS_WO_VALUE 7:0 /* -W */ 
#define NV03_USER_DAC_READ_MODE_ADDRESS_RW_STATE 1:0 /* R- */ 
#define NV03_USER_DAC_READ_MODE_ADDRESS_RW_STATE_WRITE 0x00000000 /* R- */ 
#define NV03_USER_DAC_READ_MODE_ADDRESS_RW_STATE_READ 0x00000003 /* R- */ 
#define NV03_USER_DAC_WRITE_MODE_ADDRESS 0x006813C8 /* RW */ 
#define NV03_USER_DAC_WRITE_MODE_ADDRESS_VALUE 7:0 /* RW */
#define NV03_USER_DAC_PALETTE_DATA 0x006813C9 /* RW */ 
#define NV03_USER_DAC_PALETTE_DATA_VALUE 7:0 /* RW */ /* * Framebuffer */ 
#define NV03_PFB 0x00100FFF:0x00100000 /* RW */ 
#define NV03_PDFB 0x017FFFFF:0x01000000 /* RW */ 
#define NV03_PNVM 0x017FFFFF:0x01000000 /* RW */ 
#define NV03_PRAMIN 0x01FFFFFF:0x01C00000 /* RW */ 
#define NV03_PFB_BOOT_0 0x00100000 /* RW */ 
#define NV03_PFB_BOOT_0_RAM_AMOUNT 1:0 /* RW */ 
#define NV03_PFB_BOOT_0_RAM_AMOUNT_8MB 0x00000000 /* RW */ 
#define NV03_PFB_BOOT_0_RAM_AMOUNT_2MB 0x00000001 /* RW */ 
#define NV03_PFB_BOOT_0_RAM_AMOUNT_4MB 0x00000002 /* RW */ 
#define NV03_PFB_BOOT_0_RAM_AMOUNT_UNDEFINED 0x00000003 /* RW */ 
#define NV03_PFB_BOOT_0_RAM_AMOUNT_8MB_SDRAM 0x00000003 /* RW */
#define NV03_PFB_BOOT_0_RAM_AMOUNT_DEFAULT 0x00000002 /* RW */ 
#define NV03_PFB_BOOT_0_RAM_WIDTH_128 2:2 /* RW */ 
#define NV03_PFB_BOOT_0_RAM_WIDTH_128_OFF 0x00000000 /* RW */ 
#define NV03_PFB_BOOT_0_RAM_WIDTH_128_ON 0x00000001 /* RW */ 
#define NV03_PFB_BOOT_0_RAM_BANKS 3:3 /* RW */ 
#define NV03_PFB_BOOT_0_RAM_BANKS_2BANK 0x00000000 /* RW */ 
#define NV03_PFB_BOOT_0_RAM_BANKS_4BANK 0x00000001 /* RW */ 
#define NV03_PFB_BOOT_0_RAMDATA_TWIDDLE 4:4 /* RW */ 
#define NV03_PFB_BOOT_0_RAMDATA_TWIDDLE_OFF 0x00000000 /* RW */ 
#define NV03_PFB_BOOT_0_RAMDATA_TWIDDLE_ON 0x00000001 /* RW */ 
#define NV03_PFB_BOOT_0_RAM_AMOUNT_EXTENSION 5:5 /* RW */ 
#define NV03_PFB_BOOT_0_RAM_AMOUNT_EXTENSION_OFF 0x00000000 /* RW */ 
#define NV03_PFB_BOOT_0_RAM_AMOUNT_EXTENSION_8MB 0x00000001 /* RW */ 
#define NV03_PFB_DELAY_1 0x00100044 /* RW */ 
#define NV03_PFB_DELAY_1_WRITE_ENABLE_RISE 1:0 /* RW */ 
#define NV03_PFB_DELAY_1_WRITE_ENABLE_RISE_0 0x00000000 /* RW */ 
#define NV03_PFB_DELAY_1_WRITE_ENABLE_FALL 5:4 /* RW */ 
#define NV03_PFB_DELAY_1_WRITE_ENABLE_FALL_0 0x00000000 /* RW */ 
#define NV03_PFB_DELAY_1_CAS_ENABLE_RISE 9:8 /* RW */ 
#define NV03_PFB_DELAY_1_CAS_ENABLE_RISE_0 0x00000000 /* RW */ 
#define NV03_PFB_DELAY_1_CAS_ENABLE_FALL 13:12 /* RW */ 
#define NV03_PFB_DELAY_1_CAS_ENABLE_FALL_0 0x00000000 /* RW */ 
#define NV03_PFB_DELAY_1_OUTPUT_DATA 17:16 /* RW */ 
#define NV03_PFB_DELAY_1_OUTPUT_DATA_0 0x00000000 /* RW */ 
#define NV03_PFB_DELAY_1_RAS_ENABLE 21:20 /* RW */ 
#define NV03_PFB_DELAY_1_RAS_ENABLE_0 0x00000000 /* RW */ 
#define NV03_PFB_DEBUG_0 0x00100080 /* RW */ 
#define NV03_PFB_GREEN_0 0x001000C0 /* RW */ 
#define NV03_PFB_GREEN_0_LEVEL 1:0 /* RW */ 
#define NV03_PFB_GREEN_0_LEVEL_VIDEO_ENABLED 0x00000000 /* RW */ 
#define NV03_PFB_GREEN_0_LEVEL_VIDEO_DISABLED 0x00000001 /* RW */ 
#define NV03_PFB_GREEN_0_LEVEL_TIMING_DISABLED 0x00000002 /* RW */ 
#define NV03_PFB_GREEN_0_LEVEL_MEMORY_DISABLED 0x00000003 /* RW */ 
#define NV03_PFB_CONFIG_0 0x00100200 /* RW */ 
#define NV03_PFB_CONFIG_0_TYPE 14:0 /* RW */ 
#define NV03_PFB_CONFIG_0_TYPE_OLD1024_FIXED_8BPP 0x00000120 /* RW */ 
#define NV03_PFB_CONFIG_0_TYPE_OLD1024_FIXED_16BPP 0x00000220 /* RW */ 
#define NV03_PFB_CONFIG_0_TYPE_OLD1024_FIXED_32BPP 0x00000320 /* RW */ 
#define NV03_PFB_CONFIG_0_TYPE_OLD1024_VAR_8BPP 0x00004120 /* RW */ 
#define NV03_PFB_CONFIG_0_TYPE_OLD1024_VAR_16BPP 0x00004220 /* RW */ 
#define NV03_PFB_CONFIG_0_TYPE_OLD1024_VAR_32BPP 0x00004320 /* RW */ 
#define NV03_PFB_CONFIG_0_TYPE_TETRIS 0x00002000 /* RW */ 
#define NV03_PFB_CONFIG_0_TYPE_NOTILING 0x00001114 /* RW */ 
#define NV03_PFB_CONFIG_0_TETRIS_MODE 17:15 /* RW */ 
#define NV03_PFB_CONFIG_0_TETRIS_MODE_PASS 0x00000000 /* RW */ 
#define NV03_PFB_CONFIG_0_TETRIS_MODE_1 0x00000001 /* RW */ 
#define NV03_PFB_CONFIG_0_TETRIS_MODE_2 0x00000002 /* RW */ 
#define NV03_PFB_CONFIG_0_TETRIS_MODE_3 0x00000003 /* RW */ 
#define NV03_PFB_CONFIG_0_TETRIS_MODE_4 0x00000004 /* RW */ 
#define NV03_PFB_CONFIG_0_TETRIS_MODE_5 0x00000005 /* RW */ 
#define NV03_PFB_CONFIG_0_TETRIS_MODE_6 0x00000006 /* RW */ 
#define NV03_PFB_CONFIG_0_TETRIS_MODE_7 0x00000007 /* RW */ 
#define NV03_PFB_CONFIG_0_TETRIS_SHIFT 19:18 /* RW */ 
#define NV03_PFB_CONFIG_0_TETRIS_SHIFT_0 0x00000000 /* RW */ 
#define NV03_PFB_CONFIG_0_TETRIS_SHIFT_1 0x00000001 /* RW */ 
#define NV03_PFB_CONFIG_0_TETRIS_SHIFT_2 0x00000002 /* RW */ 
#define NV03_PFB_CONFIG_0_BANK_SWAP 22:20 /* RW */ 
#define NV03_PFB_CONFIG_0_BANK_SWAP_OFF 0x00000000 /* RW */ 
#define NV03_PFB_CONFIG_0_BANK_SWAP_1M 0x00000001 /* RW */ 
#define NV03_PFB_CONFIG_0_BANK_SWAP_2M 0x00000005 /* RW */ 
#define NV03_PFB_CONFIG_0_BANK_SWAP_4M 0x00000007 /* RW */ 
#define NV03_PFB_CONFIG_0_BANK_SWAP_8M 0x00000001 /* RW */ 
#define NV03_PFB_CONFIG_0_UNUSED 23:23 /* RW */ 
#define NV03_PFB_CONFIG_1 0x00100204 /* RW */ 
#define NV03_PFB_CONFIG_1_CAS_LATENCY 2:0 /* RW */
#define NV03_PFB_CONFIG_1_CAS_LATENCY_3 0x00000003 /* RW */ 
#define NV03_PFB_CONFIG_1_NEC_MODE 3:3 /* RW */ 
#define NV03_PFB_CONFIG_1_NEC_MODE_DISABLED 0x00000000 /* RW */ 
#define NV03_PFB_CONFIG_1_NEC_MODE_ENABLED 0x00000001 /* RW */ 
#define NV03_PFB_CONFIG_1_RAS_RAS 7:4 /* RW */ 
#define NV03_PFB_CONFIG_1_RAS_RAS_DEFAULT 0x00000009 /* RW */ 
#define NV03_PFB_CONFIG_1_RAS_RAS_9CYCLES 0x00000008 /* RW */ 
#define NV03_PFB_CONFIG_1_RAS_PCHG 10:8 /* RW */ 
#define NV03_PFB_CONFIG_1_RAS_PCHG_DEFAULT 0x00000002 /* RW */ 
#define NV03_PFB_CONFIG_1_RAS_LOW 14:12 /* RW */ 
#define NV03_PFB_CONFIG_1_RAS_LOW_DEFAULT 0x00000006 /* RW */ 
#define NV03_PFB_CONFIG_1_MRS_TO_RAS 18:16 /* RW */ 
#define NV03_PFB_CONFIG_1_MRS_TO_RAS_DEFAULT 0x00000001 /* RW */ 
#define NV03_PFB_CONFIG_1_WRITE_TO_READ 22:20 /* RW */ 
#define NV03_PFB_CONFIG_1_WRITE_TO_READ_DEFAULT 0x00000000 /* RW */ 
#define NV03_PFB_CONFIG_1_RAS_TO_CAS_M1 26:24 /* RW */ 
#define NV03_PFB_CONFIG_1_RAS_TO_CAS_M1_DEFAULT 0x00000001 /* RW */ 
#define NV03_PFB_CONFIG_1_READ_TO_WRITE 30:28 /* RW */ 
#define NV03_PFB_CONFIG_1_READ_TO_WRITE_DEFAULT 0x00000004 /* RW */ 
#define NV03_PFB_CONFIG_1_READ_TO_PCHG 31:31 /* RW */ 
#define NV03_PFB_CONFIG_1_READ_TO_PCHG_ON 0x00000001 /* RW */ 
#define NV03_PFB_CONFIG_1_READ_TO_PCHG_OFF 0x00000000 /* RW */ 
#define NV03_PFB_CONFIG_1_ED_RAC1 0:0 /* RW */ 
#define NV03_PFB_CONFIG_1_ED_RAC1_DEFAULT 0x00000000 /* RW */ 
#define NV03_PFB_CONFIG_1_ED_RWT1 1:1 /* RW */ 
#define NV03_PFB_CONFIG_1_ED_RWT1_DEFAULT 0x00000001 /* RW */ 
#define NV03_PFB_CONFIG_1_ED_RPC1 2:2 /* RW */ 
#define NV03_PFB_CONFIG_1_ED_RPC1_DEFAULT 0x00000001 /* RW */ 
#define NV03_PFB_CONFIG_1_ED_PMAW 4:4 /* RW */ 
#define NV03_PFB_CONFIG_1_ED_PMAW_DEFAULT 0x00000000 /* RW */ 
#define NV03_PFB_CONFIG_1_ED_PAGE 5:5 /* RW */ 
#define NV03_PFB_CONFIG_1_ED_PAGE_DEFAULT 0x00000000 /* RW */ 
#define NV03_PFB_CONFIG_1_ED_RAC0_0 8:8 /* RW */ 
#define NV03_PFB_CONFIG_1_ED_RAC0_0_DEFAULT 0x00000000 /* RW */ 
#define NV03_PFB_CONFIG_1_ED_RAC0_1 9:9 /* RW */ 
#define NV03_PFB_CONFIG_1_ED_RAC0_1_DEFAULT 0x00000000 /* RW */ 
#define NV03_PFB_CONFIG_1_ED_RAC1_0 10:10 /* RW */ 
#define NV03_PFB_CONFIG_1_ED_RAC1_0_DEFAULT 0x00000001 /* RW */ 
#define NV03_PFB_CONFIG_1_ED_RAC1_1 12:12 /* RW */ 
#define NV03_PFB_CONFIG_1_ED_RAC1_1_DEFAULT 0x00000000 /* RW */ 
#define NV03_PFB_CONFIG_1_ED_RAD0_0 13:13 /* RW */ 
#define NV03_PFB_CONFIG_1_ED_RAD0_0_DEFAULT 0x00000001 /* RW */ 
#define NV03_PFB_CONFIG_1_ED_RAD0_1 14:14 /* RW */ 
#define NV03_PFB_CONFIG_1_ED_RAD0_1_DEFAULT 0x00000001 /* RW */ 
#define NV03_PFB_CONFIG_1_ED_RPC0_0 16:16 /* RW */ 
#define NV03_PFB_CONFIG_1_ED_RPC0_0_DEFAULT 0x00000000 /* RW */ 
#define NV03_PFB_CONFIG_1_ED_RPC0_1 17:17 /* RW */ 
#define NV03_PFB_CONFIG_1_ED_RPC0_1_DEFAULT 0x00000000 /* RW */ 
#define NV03_PFB_CONFIG_1_ED_RPC1_0 18:18 /* RW */ 
#define NV03_PFB_CONFIG_1_ED_RPC1_0_DEFAULT 0x00000001 /* RW */ 
#define NV03_PFB_CONFIG_1_ED_RPC1_1 20:20 /* RW */ 
#define NV03_PFB_CONFIG_1_ED_RPC1_1_DEFAULT 0x00000001 /* RW */ 
#define NV03_PFB_RTL 0x00100300 /* RW */ 
#define NV03_PFB_RTL_S 1:0 /* RW */ 
#define NV03_PFB_RTL_S_DEFAULT 0x00000002 /* RW */ 
#define NV03_PFB_RTL_V 5:4 /* RW */ 
#define NV03_PFB_RTL_V_DEFAULT 0x00000002 /* RW */ 
#define NV03_PFB_RTL_M 9:8 /* RW */ 
#define NV03_PFB_RTL_M_DEFAULT 0x00000002 /* RW */ 
#define NV03_PFB_RTL_H 13:12 /* RW */ 
#define NV03_PFB_RTL_H_DEFAULT 0x00000001 /* RW */ 
#define NV03_PFB_RTL_A 17:16 /* RW */ 
#define NV03_PFB_RTL_A_DEFAULT 0x00000001 /* RW */ 
#define NV03_PFB_RTL_G 21:20 /* RW */ 
#define NV03_PFB_RTL_G_DEFAULT 0x00000001 /* RW */ 
#define NV03_PFB_RTL_ARB_GR_HI_PRIOR 24:24 /* RW */
#define NV03_PFB_RTL_ARB_GR_HI_PRIOR_DEFAULT 0x00000000 /* RW */ 
#define NV03_PFB_RTL_ARB_MEDIA_HI_PRIOR 28:28 /* RW */ 
#define NV03_PFB_RTL_ARB_MEDIA_HI_PRIOR_DEFAULT 0x00000000 /* RW */ 
#define NV03_PNVM_DATA032(i) (0x01000000+(i)*4) /* RW */ 
#define NV03_PNVM_DATA032__SIZE_1 524288 /* */ 
#define NV03_PNVM_DATA032_VALUE 31:0 /* RW */ 
#define NV03_PNVM_DATA024(i) (0x01000000+((i)/2)*4+((i)%2)) /* RW */ 
#define NV03_PNVM_DATA024__SIZE_1 1048576 /* */ 
#define NV03_PNVM_DATA024_VALUE 23:0 /* RW */ 
#define NV03_PNVM_DATA016(i) (0x01000000+((i)/3)*4+((i)%3)) /* RW */ 
#define NV03_PNVM_DATA016__SIZE_1 1572864 /* */ 
#define NV03_PNVM_DATA016_VALUE 15:0 /* RW */ 
#define NV03_PNVM_DATA008(i) (0x01000000+(i)) /* RW */ 
#define NV03_PNVM_DATA008__SIZE_1 2097152 /* */ 
#define NV03_PNVM_DATA008_VALUE 7:0 /* RW */ 
#define NV03_PRAMIN_DATA032(i) (0x01C00000+(i)*4) /* RW */ 
#define NV03_PRAMIN_DATA032__SIZE_1 524288 /* */ 
#define NV03_PRAMIN_DATA032_VALUE 31:0 /* */ 
#define NV03_PRAMIN_DATA024(i) (0x01C00000+((i)/2)*4+((i)%2)) /* */ 
#define NV03_PRAMIN_DATA024__SIZE_1 1048576 /* */ 
#define NV03_PRAMIN_DATA024_VALUE 23:0 /* */ 
#define NV03_PRAMIN_DATA016(i) (0x01C00000+((i)/3)*4+((i)%3)) /* */ 
#define NV03_PRAMIN_DATA016__SIZE_1 1572864 /* */ 
#define NV03_PRAMIN_DATA016_VALUE 15:0 /* */ 
#define NV03_PRAMIN_DATA008(i) (0x01C00000+(i)) /* */ 
#define NV03_PRAMIN_DATA008__SIZE_1 2097152 /* */ 
#define NV03_PRAMIN_DATA008_VALUE 7:0 /* */ 
#define NV03_PDFB_DATA032(i) (0x01000000+(i)*4) /* RW */ 
#define NV03_PDFB_DATA032__SIZE_1 524288 /* */ 
#define NV03_PDFB_DATA032_VALUE 31:0 /* RW */ 
#define NV03_PDFB_DATA024(i) (0x01000000+((i)/2)*4+((i)%2)) /* RW */ 
#define NV03_PDFB_DATA024__SIZE_1 1048576 /* */ 
#define NV03_PDFB_DATA024_VALUE 23:0 /* RW */
#define NV03_PDFB_DATA016(i) (0x01000000+((i)/3)*4+((i)%3)) /* RW */ 
#define NV03_PDFB_DATA016__SIZE_1 1572864 /* */ 
#define NV03_PDFB_DATA016_VALUE 15:0 /* RW */ 
#define NV03_PDFB_DATA008(i) (0x01000000+(i)) /* RW */ 
#define NV03_PDFB_DATA008__SIZE_1 2097152 /* */ 
#define NV03_PDFB_DATA008_VALUE 7:0 /* RW */ /* * VGA */ 
#define NV03_PRMCIO 0x00601FFF:0x00601000 /* RW */ 
#define NV03_PRMVIO 0x000C7FFF:0x000C0000 /* RW */ 
#define NV03_PRMVGA 0x000BFFFF:0x000A0000 /* RW */ 
#define NV03_CIO 0x3DF:0x3B0 /* -- */ 
#define NV03_PRMVIO_MBEN 0x000C0094 /* RW */ 
#define NV03_IO_MBEN 0x00000094 /* RW */ 
#define NV03_PRMVIO_ADDEN 0x000C46e8 /* RW */ 
#define NV03_IO_ADDEN 0x000046e8 /* RW */ 
#define NV03_PRMVIO_VSE1 0x000C0102 /* RW */ 
#define NV03_IO_VSE1 0x00000102 /* RW */ 
#define NV03_PRMVIO_VSE2 0x000C03c3 /* RW */ 
#define NV03_IO_VSE2 0x000003c3 /* RW */ 
#define NV03_PRMVIO_MISC__READ 0x000C03cc /* R- */ 
#define NV03_IO_MISC__READ 0x000003cc /* R- */ 
#define NV03_PRMVIO_MISC__WRITE 0x000C03c2 /* -W */ 
#define NV03_IO_MISC__WRITE 0x000003c2 /* -W */ 
#define NV03_PRMCIO_INP0 0x006013c2 /* R- */ 
#define NV03_CIO_INP0 0x000003c2 /* R- */ 
#define NV03_PRMCIO_INP0__MONO 0x006013ba /* R- */ 
#define NV03_CIO_INP0__MONO 0x000003ba /* R- */ 
#define NV03_PRMCIO_INP0__COLOR 0x006013da /* R- */ 
#define NV03_CIO_INP0__COLOR 0x000003da /* R- */ 
#define NV03_PRMCIO_INP0__READ_MONO 0x006013ca /* R- */ 
#define NV03_CIO_INP0__READ_MONO 0x000003ca /* R- */ 
#define NV03_PRMCIO_INP0__WRITE_MONO 0x006013ba /* -W */ 
#define NV03_CIO_INP0__WRITE_MONO 0x000003ba /* -W */ 
#define NV03_PRMCIO_INP0__WRITE_COLOR 0x006013da /* -W */ 
#define NV03_CIO_INP0__WRITE_COLOR 0x000003da /* -W */ 
#define NV03_PRMVIO_SRX 0x000C03c4 /* RW */ 
#define NV03_VIO_SRX 0x000003c4 /* RW */ 
#define NV03_PRMVIO_SR_RESET 0x000C03c5 /* RW */ 
#define NV03_PRMVIO_SR_RESET_INDEX 0x00000000 /* */ 
#define NV03_VIO_SR_RESET 0x000003c5 /* RW */ 
#define NV03_VIO_SR_RESET_INDEX 0x00000000 /* */ 
#define NV03_PRMVIO_SR_CLOCK 0x000C03c5 /* RW */
#define NV03_PRMVIO_SR_CLOCK_INDEX 0x00000001 /* */ 
#define NV03_VIO_SR_CLOCK 0x000003c5 /* RW */ 
#define NV03_VIO_SR_CLOCK_INDEX 0x00000001 /* */ 
#define NV03_PRMVIO_SR_PLANE_MASK 0x000C03c5 /* RW */
#define NV03_PRMVIO_SR_PLANE_MASK_INDEX 0x00000002 /* */ 
#define NV03_VIO_SR_PLANE_MASK 0x000003c5 /* RW */ 
#define NV03_VIO_SR_PLANE_MASK_INDEX 0x00000002 /* */ 
#define NV03_PRMVIO_SR_CHAR_MAP 0x000C03c5 /* RW */ 
#define NV03_PRMVIO_SR_CHAR_MAP_INDEX 0x00000003 /* */ 
#define NV03_VIO_SR_CHAR_MAP 0x000003c5 /* RW */ 
#define NV03_VIO_SR_CHAR_MAP_INDEX 0x00000003 /* */ 
#define NV03_PRMVIO_SR_MEM_MODE 0x000C03c5 /* RW */ 
#define NV03_PRMVIO_SR_MEM_MODE_INDEX 0x00000004 /* */ 
#define NV03_VIO_SR_MEM_MODE 0x000003c5 /* RW */ 
#define NV03_VIO_SR_MEM_MODE_INDEX 0x00000004 /* */ 
#define NV03_PRMVIO_SR_LOCK 0x000C03c5 /* RW */ 
#define NV03_PRMVIO_SR_LOCK_INDEX 0x00000006 /* */ 
#define NV03_VIO_SR_LOCK 0x000003c5 /* RW */ 
#define NV03_VIO_SR_LOCK_INDEX 0x00000006 /* */ 
#define NV03_SR_UNLOCK_VALUE 0x00000057 /* */ 
#define NV03_SR_LOCK_VALUE 0x00000099 /* */ 
#define NV03_PRMVIO_GRX 0x000C03ce /* RW */ 
#define NV03_VIO_GRX 0x000003ce /* RW */ 
#define NV03_PRMVIO_GX_SR 0x000C03cf /* RW */ 
#define NV03_PRMVIO_GX_SR_INDEX 0x00000000 /* */ 
#define NV03_VIO_GX_SR 0x000003cf /* RW */ 
#define NV03_VIO_GX_SR_INDEX 0x00000000 /* */ 
#define NV03_PRMVIO_GX_SREN 0x000C03cf /* RW */ 
#define NV03_PRMVIO_GX_SREN_INDEX 0x00000001 /* */ 
#define NV03_VIO_GX_SREN 0x000003cf /* RW */ 
#define NV03_VIO_GX_SREN_INDEX 0x00000001 /* */ 
#define NV03_PRMVIO_GX_CCOMP 0x000C03cf /* RW */ 
#define NV03_PRMVIO_GX_CCOMP_INDEX 0x00000002 /* */ 
#define NV03_VIO_GX_CCOMP 0x000003cf /* RW */ 
#define NV03_VIO_GX_CCOMP_INDEX 0x00000002 /* */ 
#define NV03_PRMVIO_GX_ROP 0x000C03cf /* RW */ 
#define NV03_PRMVIO_GX_ROP_INDEX 0x00000003 /* */ 
#define NV03_VIO_GX_ROP 0x000003cf /* RW */ 
#define NV03_VIO_GX_ROP_INDEX 0x00000003 /* */ 
#define NV03_PRMVIO_GX_READ_MAP 0x000C03cf /* RW */ 
#define NV03_PRMVIO_GX_READ_MAP_INDEX 0x00000004 /* */ 
#define NV03_VIO_GX_READ_MAP 0x000003cf /* RW */ 
#define NV03_VIO_GX_READ_MAP_INDEX 0x00000004 /* */ 
#define NV03_PRMVIO_GX_MODE 0x000C03cf /* RW */ 
#define NV03_PRMVIO_GX_MODE_INDEX 0x00000005 /* */ 
#define NV03_VIO_GX_MODE 0x000003cf /* RW */ 
#define NV03_VIO_GX_MODE_INDEX 0x00000005 /* */

#define NV03_PRMVIO_GX_MISC 0x000C03cf /* RW */ 
#define NV03_PRMVIO_GX_MISC_INDEX 0x00000006 /* */ 
#define NV03_VIO_GX_MISC 0x000003cf /* RW */ 
#define NV03_VIO_GX_MISC_INDEX 0x00000006 /* */ 
#define NV03_PRMVIO_GX_DONT_CARE 0x000C03cf /* RW */ 
#define NV03_PRMVIO_GX_DONT_CARE_INDEX 0x00000007 /* */ 
#define NV03_VIO_GX_DONT_CARE 0x000003cf /* RW */ 
#define NV03_VIO_GX_DONT_CARE_INDEX 0x00000007 /* */ 
#define NV03_PRMVIO_GX_BIT_MASK 0x000C03cf /* RW */ 
#define NV03_PRMVIO_GX_BIT_MASK_INDEX 0x00000008 /* */ 
#define NV03_VIO_GX_BIT_MASK 0x000003cf /* RW */ 
#define NV03_VIO_GX_BIT_MASK_INDEX 0x00000008 /* */ 
#define NV03_PRMCIO_ARX 0x006013c0 /* RW */ 
#define NV03_CIO_ARX 0x000003c0 /* RW */ 
#define NV03_PRMCIO_AR_PALETTE__WRITE 0x006013c0 /* -W */ 
#define NV03_CIO_AR_PALETTE__WRITE 0x000003c0 /* -W */ 
#define NV03_PRMCIO_AR_PALETTE__READ 0x006013c1 /* R- */ 
#define NV03_CIO_AR_PALETTE__READ 0x000003c1 /* R- */ 
#define NV03_PRMCIO_AR_MODE__WRITE 0x006013c0 /* -W */ 
#define NV03_PRMCIO_AR_MODE__READ 0x006013c1 /* R- */ 
#define NV03_PRMCIO_AR_MODE_INDEX 0x00000010 /* */ 
#define NV03_CIO_AR_MODE__WRITE 0x000003c0 /* -W */ 
#define NV03_CIO_AR_MODE__READ 0x000003c1 /* R- */ 
#define NV03_CIO_AR_MODE_INDEX 0x00000010 /* */ 
#define NV03_PRMCIO_AR_OSCAN__WRITE 0x006013c0 /* -W */ 
#define NV03_PRMCIO_AR_OSCAN__READ 0x006013c1 /* R- */ 
#define NV03_PRMCIO_AR_OSCAN_INDEX 0x00000011 /* */ 
#define NV03_CIO_AR_OSCAN__WRITE 0x000003c0 /* -W */ 
#define NV03_CIO_AR_OSCAN__READ 0x000003c1 /* R- */ 
#define NV03_CIO_AR_OSCAN_INDEX 0x00000011 /* */ 
#define NV03_PRMCIO_AR_PLANE__WRITE 0x006013c0 /* -W */ 
#define NV03_PRMCIO_AR_PLANE__READ 0x006013c1 /* R- */ 
#define NV03_PRMCIO_AR_PLANE_INDEX 0x00000012 /* */ 
#define NV03_CIO_AR_PLANE__WRITE 0x000003c0 /* -W */ 
#define NV03_CIO_AR_PLANE__READ 0x000003c1 /* R- */ 
#define NV03_CIO_AR_PLANE_INDEX 0x00000012 /* */ 
#define NV03_PRMCIO_AR_HPP__WRITE 0x006013c0 /* -W */
#define NV03_PRMCIO_AR_HPP__READ 0x006013c1 /* R- */ 
#define NV03_PRMCIO_AR_HPP_INDEX 0x00000013 /* */ 
#define NV03_CIO_AR_HPP__WRITE 0x000003c0 /* -W */ 
#define NV03_CIO_AR_HPP__READ 0x000003c1 /* R- */
#define NV03_CIO_AR_HPP_INDEX 0x00000013 /* */ 
#define NV03_PRMCIO_AR_CSEL__WRITE 0x006013c0 /* -W */ 
#define NV03_PRMCIO_AR_CSEL__READ 0x006013c1 /* R- */ 
#define NV03_PRMCIO_AR_CSEL_INDEX 0x00000014 /* */ 
#define NV03_CIO_AR_CSEL__WRITE 0x000003c0 /* -W */ 
#define NV03_CIO_AR_CSEL__READ 0x000003c1 /* R- */ 
#define NV03_CIO_AR_CSEL_INDEX 0x00000014 /* */ 
#define NV03_PRMCIO_CRX__MONO 0x006013b4 /* RW */ 
#define NV03_PRMCIO_CRX__COLOR 0x006013d4 /* RW */ 
#define NV03_CIO_CRX__MONO 0x000003b4 /* RW */ 
#define NV03_CIO_CRX__COLOR 0x000003d4 /* RW */ 
#define NV03_PRMCIO_CR__MONO 0x006013b5 /* RW */
#define NV03_PRMCIO_CR__COLOR 0x006013d5 /* RW */ 
#define NV03_CIO_CR__MONO 0x000003b5 /* RW */ 
#define NV03_CIO_CR__COLOR 0x000003d5 /* RW */ 
#define NV03_CIO_CR_HDT_INDEX 0x00000000 /* */ 
#define NV03_CIO_CR_HDE_INDEX 0x00000001 /* */ 
#define NV03_CIO_CR_HBS_INDEX 0x00000002 /* */ 
#define NV03_CIO_CR_HBE_INDEX 0x00000003 /* */ 
#define NV03_CIO_CR_HBE_4_0 4:0 /* RW */ 
#define NV03_CIO_CR_HRS_INDEX 0x00000004 /* */ 
#define NV03_CIO_CR_HRE_INDEX 0x00000005 /* */ 
#define NV03_CIO_CR_HRE_HBE_5 7:7 /* RW */ 
#define NV03_CIO_CR_HRE_4_0 4:0 /* RW */ 
#define NV03_CIO_CR_VDT_INDEX 0x00000006 /* */ 
#define NV03_CIO_CR_OVL_INDEX 0x00000007 /* */ 
#define NV03_CIO_CR_OVL_VDE_8 1:1 /* RW */ 
#define NV03_CIO_CR_OVL_VDE_9 6:6 /* RW */ 
#define NV03_CIO_CR_OVL_VDT_8 0:0 /* RW */ 
#define NV03_CIO_CR_OVL_VDT_9 5:5 /* RW */ 
#define NV03_CIO_CR_OVL_VBS_8 3:3 /* RW */ 
#define NV03_CIO_CR_OVL_VRS_8 2:2 /* RW */ 
#define NV03_CIO_CR_OVL_VRS_9 7:7 /* RW */ 
#define NV03_CIO_CR_RSAL_INDEX 0x00000008 /* */ 
#define NV03_CIO_CR_RSAL_PANNING 6:5 /* RW */ 
#define NV03_CIO_CR_CELL_HT_INDEX 0x00000009 /* */ 
#define NV03_CIO_CR_CELL_HT_SCANDBL 7:7 /* RW */ 
#define NV03_CIO_CR_CELL_HT_VBS_9 5:5 /* RW */ 
#define NV03_CIO_CR_CURS_ST_INDEX 0x0000000A /* */ 
#define NV03_CIO_CR_CURS_END_INDEX 0x0000000B /* */ 
#define NV03_CIO_CR_SA_HI_INDEX 0x0000000C /* */ 
#define NV03_CIO_CR_SA_LO_INDEX 0x0000000D /* */ 
#define NV03_CIO_CR_TCOFF_HI_INDEX 0x0000000E /* */ 
#define NV03_CIO_CR_TCOFF_LO_INDEX 0x0000000F /* */ 
#define NV03_CIO_CR_VRS_INDEX 0x00000010 /* */ 
#define NV03_CIO_CR_VRE_INDEX 0x00000011 /* */ 
#define NV03_CIO_CR_VRE_3_0 3:0 /* RW */ 
#define NV03_CIO_CR_VDE_INDEX 0x00000012 /* */ 
#define NV03_CIO_CR_OFFSET_INDEX 0x00000013 /* */ 
#define NV03_CIO_CR_ULINE_INDEX 0x00000014 /* */ 
#define NV03_CIO_CR_VBS_INDEX 0x00000015 /* */ 
#define NV03_CIO_CR_VBE_INDEX 0x00000016 /* */ 
#define NV03_CIO_CR_MODE_INDEX 0x00000017 /* */ 
#define NV03_CIO_CR_LCOMP_INDEX 0x00000018 /* */ 
#define NV03_CIO_CR_GDATA_INDEX 0x00000022 /* */ 
#define NV03_CIO_CR_ARFF_INDEX 0x00000024 /* */ 
#define NV03_CIO_CR_ARX_INDEX 0x00000026 /* */ 
#define NV03_PRMCIO_CRE__MONO 0x006013b5 /* RW */ 
#define NV03_PRMCIO_CRE__COLOR 0x006013d5 /* RW */ 
#define NV03_CIO_CRE__MONO 0x000003b5 /* RW */ 
#define NV03_CIO_CRE__COLOR 0x000003d5 /* RW */ 
#define NV03_CIO_CRE_RPC0_INDEX 0x00000019 /* */ 
#define NV03_CIO_CRE_RPC0_START 4:0 /* RW */ 
#define NV03_CIO_CRE_RPC0_OFFSET_10_8 7:5 /* RW */ 
#define NV03_CIO_CRE_RPC1_INDEX 0x0000001A /* */ 
#define NV03_CIO_CRE_RPC1_LARGE 2:2 /* RW-*/ 
#define NV03_CIO_CRE_FF_INDEX 0x0000001B /* */ 
#define NV03_CIO_CRE_FF_BURST 2:0 /* RW */ 
#define NV03_CIO_CRE_FF_BURST_8 0x00000000 /* RW */ 
#define NV03_CIO_CRE_FF_BURST_32 0x00000001 /* RW */ 
#define NV03_CIO_CRE_FF_BURST_64 0x00000002 /* RW */ 
#define NV03_CIO_CRE_FF_BURST_128 0x00000003 /* RW */ 
#define NV03_CIO_CRE_FF_BURST_256 0x00000004 /* RW */ 
#define NV03_CIO_CRE_ENH_INDEX 0x0000001C /* */
#define NV03_CIO_CRE_PAGE0_INDEX 0x0000001D /* */ 
#define NV03_CIO_CRE_PAGE1_INDEX 0x0000001E /* */ 
#define NV03_CIO_CRE_FFLWM__INDEX 0x00000020 /* */ 
#define NV03_CIO_CRE_FFLWM_LWM 5:0 /* RW */ 
#define NV03_CIO_CRE_LSR_INDEX 0x00000025 /* */ 
#define NV03_CIO_CRE_LSR_FORMAT 7:6 /* RW */ 
#define NV03_CIO_CRE_LSR_FORMAT_8BIT 0x00000001 /* RW */ 
#define NV03_CIO_CRE_LSR_FORMAT_555 0x00000002 /* RW */
#define NV03_CIO_CRE_LSR_FORMAT_565 0x00000003 /* RW */ 
#define NV03_CIO_CRE_LSR_VDE_10 1:1 /* RW */ 
#define NV03_CIO_CRE_LSR_VDT_10 0:0 /* RW */ 
#define NV03_CIO_CRE_LSR_HBE_6 4:4 /* RW */ 
#define NV03_CIO_CRE_LSR_VBS_10 3:3 /* RW */ 
#define NV03_CIO_CRE_LSR_VRS_10 2:2 /* RW */ 
#define NV03_CIO_CRE_PIXEL_INDEX 0x00000028 /* */ 
#define NV03_CIO_CRE_PIXEL_FORMAT 1:0 /* RW */ 
#define NV03_CIO_CRE_PIXEL_FORMAT_VGA 0x00000000 /* RW */ 
#define NV03_CIO_CRE_PIXEL_FORMAT_8BPP 0x00000001 /* RW */ 
#define NV03_CIO_CRE_PIXEL_FORMAT_16BPP 0x00000002 /* RW */ 
#define NV03_CIO_CRE_PIXEL_FORMAT_32BPP 0x00000003 /* RW */ 
#define NV03_CIO_CRE_PIXEL_TILING 2:2 /* RW */ 
#define NV03_CIO_CRE_DEC__INDEX 0x00000029 /* */ 
#define NV03_CIO_CRE_OSCOL__INDEX 0x0000002A /* */
#define NV03_CIO_CRE_SCRATCH0__INDEX 0x0000002B /* */ 
#define NV03_CIO_CRE_SCRATCH1__INDEX 0x0000002C /* */ 
#define NV03_CIO_CRE_HEB__INDEX 0x0000002D /* */ 
#define NV03_CIO_CRE_HEB_ILC_8 4:4 /* RW */
#define NV03_CIO_CRE_HEB_HRS_8 3:3 /* RW */ 
#define NV03_CIO_CRE_HEB_HBS_8 2:2 /* RW */ 
#define NV03_CIO_CRE_HEB_HDE_8 1:1 /* RW */ 
#define NV03_CIO_CRE_HEB_HDT_8 0:0 /* RW */ 
#define NV03_CIO_CRE_HCUR_ADDR0_INDEX 0x00000030 /* */ 
#define NV03_CIO_CRE_HCUR_ADDR0_ADR 6:0 /* RW */ 
#define NV03_CIO_CRE_HCUR_ADDR1_INDEX 0x00000031 /* */ 
#define NV03_CIO_CRE_HCUR_ADDR1_ADR 7:3 /* RW */ 
#define NV03_CIO_CRE_HCUR_ADDR1_CUR_DBL 1:1 /* RW */ 
#define NV03_CIO_CRE_HCUR_ADDR1_ENABLE 0:0 /* RW */ 
#define NV03_CIO_CRE_VID_END0__INDEX 0x00000032 /* */ 
#define NV03_CIO_CRE_VID_END_7_0 7:0 /* RW */ 
#define NV03_CIO_CRE_VID_END1__INDEX 0x00000033 /* */ 
#define NV03_CIO_CRE_VID_END_ENABLE 4:4 /* RW */ 
#define NV03_CIO_CRE_VID_END_10_8 2:0 /* RW */ 
#define NV03_CIO_CRE_RL0__INDEX 0x00000034 /* */ 
#define NV03_CIO_CRE_RL1__INDEX 0x00000035 /* */ 
#define NV03_CIO_CRE_RMA__INDEX 0x00000038 /* */ 
#define NV03_CIO_CRE_ILACE__INDEX 0x00000039 /* */ 
#define NV03_CIO_CRE_TREG__INDEX 0x0000003D /* */
#define NV03_CIO_CRE_TREG_HCNT 6:6 /* RW */ 
#define NV03_CIO_CRE_TREG_VCNT 4:4 /* RW */ 
#define NV03_CIO_CRE_TREG_HCNT_INDEX 0x00000000 /* */ 
#define NV03_CIO_CRE_TREG_VCNTA_INDEX 0x00000006 /* */
#define NV03_CIO_CRE_TREG_VCNTB_INDEX 0x00000007 /* */ 
#define NV03_CIO_CRE_DDC_STATUS__INDEX 0x0000003E /* */ 
#define NV03_CIO_CRE_DDC_WR__INDEX 0x0000003F /* */ 
