
      /*  reg bit h bit l */ 

      /*

	0 - reg rang
	1 - reg
	2 - bit filed
	3 - value


       */

#define LNV04_USER_OBJECT_ID                                         2 ,0,31,00
#define LNV04_USER_CTX_POINTER                                       2 ,1,31,02

#define LNV04_CTX_SWITCH1                            1 ,0,31,00
#define LNV04_CTX_SWITCH1_GRCLASS                    2 ,0,07,00
#define LNV04_CTX_SWITCH1_CHROMA_KEY                 2 ,0,12,12
#define LNV04_CTX_SWITCH1_CHROMA_KEY_DISABLE         3 ,0,12,12,0x00000000 /* RW--V */
#define LNV04_CTX_SWITCH1_CHROMA_KEY_ENABLE          3 ,0,12,12,0x00000001 /* RW--V */
#define LNV04_CTX_SWITCH1_USER_CLIP                  2 ,0,13,13
#define LNV04_CTX_SWITCH1_USER_CLIP_DISABLE          3 ,0,13,13,0x00000000
#define LNV04_CTX_SWITCH1_USER_CLIP_ENABLE           3 ,0,13,13,0x00000001 /* RW--V */
#define LNV04_CTX_SWITCH1_SWIZZLE                    2 ,0,14,14            /* RWXUF */
#define LNV04_CTX_SWITCH1_SWIZZLE_DISABLE            3 ,0,14,14,0x00000000 /* RW--V */
#define LNV04_CTX_SWITCH1_SWIZZLE_ENABLE             3 ,0,14,14,0x00000001 /* RW--V */
#define LNV04_CTX_SWITCH1_PATCH_CONFIG               2 ,0,17,15            /* RWXUF */
#define LNV04_CTX_SWITCH1_PATCH_CONFIG_SRCCOPY_AND   3 ,0,17,15,0x00000000 /* RW--V */
#define LNV04_CTX_SWITCH1_PATCH_CONFIG_ROP_AND       3 ,0,17,15,0x00000001 /* RW--V */
#define LNV04_CTX_SWITCH1_PATCH_CONFIG_BLEND_AND     3 ,0,17,15,0x00000002 /* RW--V */
#define LNV04_CTX_SWITCH1_PATCH_CONFIG_SRCCOPY       3 ,0,17,15,0x00000003 /* RW--V */
#define LNV04_CTX_SWITCH1_PATCH_CONFIG_SRCCOPY_PRE   3 ,0,17,15,0x00000004 /* RW--V */
#define LNV04_CTX_SWITCH1_PATCH_CONFIG_BLEND_PRE     3 ,0,17,15,0x00000005 /* RW--V */
#define LNV04_CTX_SWITCH1_PATCH_STATUS               2 ,0,24,24            /* RWXUF */
#define LNV04_CTX_SWITCH1_PATCH_STATUS_INVALID       3 ,0,24,24,0x00000000 /* RW--V */
#define LNV04_CTX_SWITCH1_PATCH_STATUS_VALID         3 ,0,24,24,0x00000001 /* RW--V */
#define LNV04_CTX_SWITCH1_CONTEXT_SURFACE            2 ,0,25,25            /* RWXUF */
#define LNV04_CTX_SWITCH1_CONTEXT_SURFACE_INVALID    3 ,0,25,25,0x00000000 /* RW--V */
#define LNV04_CTX_SWITCH1_CONTEXT_SURFACE_VALID      3 ,0,25,25,0x00000001 /* RW--V */
#define LNV04_CTX_SWITCH1_VOLATILE_RESET             2 ,0,31,31            /* CWIVF */
#define LNV04_CTX_SWITCH1_VOLATILE_RESET_IGNORE      3 ,0,31,31,0x00000000 /* CWI-V */
#define LNV04_CTX_SWITCH1_VOLATILE_RESET_ENABLED     3 ,0,31,31,0x00000001 /* -W--T */

#define LNV04_CTX_SWITCH2                              1 ,1,31,00 /* RW-4R */
#define LNV04_CTX_SWITCH2_MONO_FORMAT                  2 ,1,01,00 /* RWXUF */
#define LNV04_CTX_SWITCH2_MONO_FORMAT_INVALID          3 ,1,01,00,0x00 /* RW--V */
#define LNV04_CTX_SWITCH2_MONO_FORMAT_CGA6_M1          3 ,1,01,00,0x01 /* RW--V */
#define LNV04_CTX_SWITCH2_MONO_FORMAT_LE_M1            3 ,1,01,00,0x02 /* RW--V */
#define LNV04_CTX_SWITCH2_COLOR_FORMAT                 2 ,1,13,08      /* RWXUF */
#define LNV04_CTX_SWITCH2_COLOR_FORMAT_INVALID         3 ,1,13,08,0x00 /* RW--V */
#define LNV04_CTX_SWITCH2_COLOR_FORMAT_LE_Y8           3 ,1,13,08,0x01 /* RW--V */
#define LNV04_CTX_SWITCH2_COLOR_FORMAT_LE_X16A8Y8      3 ,1,13,08,0x02 /* RW--V */
#define LNV04_CTX_SWITCH2_COLOR_FORMAT_LE_X24Y8        3 ,1,13,08,0x03 /* RW--V */
#define LNV04_CTX_SWITCH2_COLOR_FORMAT_LE_A1R5G5B5     3 ,1,13,08,0x06 /* RW--V */
#define LNV04_CTX_SWITCH2_COLOR_FORMAT_LE_X1R5G5B5     3 ,1,13,08,0x07 /* RW--V */
#define LNV04_CTX_SWITCH2_COLOR_FORMAT_LE_X16A1R5G5B5  3 ,1,13,08,0x08 /* RW--V */
#define LNV04_CTX_SWITCH2_COLOR_FORMAT_LE_X17R5G5B5    3 ,1,13,08,0x09 /* RW--V */
#define LNV04_CTX_SWITCH2_COLOR_FORMAT_LE_R5G6B5       3 ,1,13,08,0x0A /* RW--V */
#define LNV04_CTX_SWITCH2_COLOR_FORMAT_LE_A16R5G6B5    3 ,1,13,08,0x0B /* RW--V */
#define LNV04_CTX_SWITCH2_COLOR_FORMAT_LE_X16R5G6B5    3 ,1,13,08,0x0C /* RW--V */
#define LNV04_CTX_SWITCH2_COLOR_FORMAT_LE_A8R8G8B8     3 ,1,13,08,0x0D /* RW--V */
#define LNV04_CTX_SWITCH2_COLOR_FORMAT_LE_X8R8G8B8     3 ,1,13,08,0x0E /* RW--V */
#define LNV04_CTX_SWITCH2_COLOR_FORMAT_LE_Y16          3 ,1,13,08,0x0F /* RW--V */
#define LNV04_CTX_SWITCH2_COLOR_FORMAT_LE_A16Y16       3 ,1,13,08,0x10 /* RW--V */
#define LNV04_CTX_SWITCH2_COLOR_FORMAT_LE_X16Y16       3 ,1,13,08,0x11 /* RW--V */
#define LNV04_CTX_SWITCH2_COLOR_FORMAT_LE_V8YB8U8YA8   3 ,1,13,08,0x12 /* RW--V */
#define LNV04_CTX_SWITCH2_COLOR_FORMAT_LE_YB8V8YA8U8   3 ,1,13,08,0x13 /* RW--V */
#define LNV04_CTX_SWITCH2_COLOR_FORMAT_LE_Y32          3 ,1,13,08,0x14 /* RW--V */
#define LNV04_CTX_SWITCH2_NOTIFY_INSTANCE              3 ,1,31,16          /* RWXUF */
#define LNV04_CTX_SWITCH2_NOTIFY_INSTANCE_INVALID      3 ,1,31,16,0x0000   /* RW--V */

#define LNV04_CTX_SWITCH3                              1 ,2,31,00        /* RW-4R */
#define LNV04_CTX_SWITCH3_DMA_INSTANCE_0               2 ,2,15,00        /* RWXUF */
#define LNV04_CTX_SWITCH3_DMA_INSTANCE_0_INVALID       3 ,2,15,00,0x0000 /* RW--V */
#define LNV04_CTX_SWITCH3_DMA_INSTANCE_1               2 ,2,31,16        /* RWXUF */
#define LNV04_CTX_SWITCH3_DMA_INSTANCE_1_INVALID       3 ,2,31,16,0x0000 /* RW--V */

#define LNV04_CTX_SWITCH4                              1 ,3,31,00        /* RW-4R */
#define LNV04_CTX_SWITCH4_USER_INSTANCE                2 ,3,15,00        /* RWXUF */
#define LNV04_CTX_SWITCH4_USER_INSTANCE_INVALID        3 ,3,15,00,0x0000 /* RW--V */



#define LNV04_PFIFO_DMA_INSTANCE_CTL                                 1 ,0,31,00
#define LNV04_PFIFO_DMA_INSTANCE_CTL_ADJUST                          2 ,0,11,02
#define LNV04_PFIFO_DMA_INSTANCE_CTL_PAGE_TABLE                      2,0,12,12
#define LNV04_PFIFO_DMA_INSTANCE_CTL_PAGE_TABLE_NOT_PRESENT          3,0,12,12,0x00000000
#define LNV04_PFIFO_DMA_INSTANCE_CTL_PAGE_TABLE_PRESENT              3,0,12,12,0x00000001            
#define LNV04_PFIFO_DMA_INSTANCE_CTL_PAGE_ENTRY                      2 ,0,13,13
#define LNV04_PFIFO_DMA_INSTANCE_CTL_PAGE_ENTRY_NOT_LINEAR           3 ,0,13,13,0x00000000                   
#define LNV04_PFIFO_DMA_INSTANCE_CTL_PAGE_ENTRY_LINEAR               3 ,0,13,13,0x00000001
#define LNV04_PFIFO_DMA_INSTANCE_CTL_TARGET_NODE                     2 ,0,17,16
#define LNV04_PFIFO_DMA_INSTANCE_CTL_TARGET_NODE_PCI                 3 ,0,17,16,0x00000002            
#define LNV04_PFIFO_DMA_INSTANCE_CTL_TARGET_NODE_AGP                 3 ,0,17,16,0x00000003
#define LNV04_PFIFO_DMA_INSTANCE_CTL_AT_INFO                         2 ,0,31,31
#define LNV04_PFIFO_DMA_INSTANCE_CTL_AT_INFO_INVALID                 2 ,0,31,31,0x00000000
#define LNV04_PFIFO_DMA_INSTANCE_CTL_AT_INFO_VALID                   2 ,0,31,31,0x00000001

#define LNV04_PFIFO_DMA_INSTANCE_PAGE_TABLE_LIMIT                    1,1,31,00
#define LNV04_PFIFO_DMA_INSTANCE_PAGE_TABLE_LIMIT_OFFSET             2,1,28,02
     
#define LNV04_PFIFO_DMA_INSTANCE_PAGE_TABLE(i)                       1 ,(i + 2) ,31,0
#define LNV04_PFIFO_DMA_INSTANCE_PAGE_TABLE_DATA(i)                  2 ,(i + 2) ,31,12


#define LNV04_CONTEXT_DMA_INSTANCE_CONTROL                           1 ,0,31,00
#define LNV04_CONTEXT_DMA_INSTANCE_CONTROL_PAGE_TABLE                2 ,0,12,12
#define LNV04_CONTEXT_DMA_INSTANCE_CONTROL_PAGE_TABLE_NOT_PRESENT    3 ,0,12,12,0x00000000
#define LNV04_CONTEXT_DMA_INSTANCE_CONTROL_PAGE_TABLE_PRESENT        3 ,0,12,12,0x00000001
#define LNV04_CONTEXT_DMA_INSTANCE_CONTROL_PAGE_ENTRY                2 ,0,13,13
#define LNV04_CONTEXT_DMA_INSTANCE_CONTROL_PAGE_ENTRY_NOT_LINEAR     3 ,0,13,13,0x00000000
#define LNV04_CONTEXT_DMA_INSTANCE_CONTROL_PAGE_ENTRY_LINEAR         3 ,0,13,13,0x00000001
#define LNV04_CONTEXT_DMA_INSTANCE_CONTROL_TARGET_NODE               2 ,0,17,16
#define LNV04_CONTEXT_DMA_INSTANCE_CONTROL_TARGET_NODE_NVM           3 ,0,17,16,0x00000000
#define LNV04_CONTEXT_DMA_INSTANCE_CONTROL_TARGET_NODE_PCI           3 ,0,17,16,0x00000002
#define LNV04_CONTEXT_DMA_INSTANCE_CONTROL_TARGET_NODE_AGP           3 ,0,17,16,0x00000003
#define LNV04_CONTEXT_DMA_INSTANCE_CONTROL_ADJUST                    2 ,0,31,20

#define LNV04_CONTEXT_DMA_INSTANCE_LIMIT                             1 ,1,31,00
#define LNV04_CONTEXT_DMA_INSTANCE_LIMIT_OFFSET                      2 ,1,31,00
#define LNV04_CONTEXT_DMA_INSTANCE_UNKNOWEN_0                        1 ,2,31,00
#define LNV04_CONTEXT_DMA_INSTANCE_UNKNOWEN_1                        1 ,3,31,00

