extern void            SetupNv04( void *  ) ;
extern void            i386_setreg(void * base , unsigned long offset , unsigned long data ) ;
extern void            i386_setreg16(void * base , unsigned long offset , unsigned long data ) ;
extern void            i386_setreg8(void * base , unsigned long offset , unsigned long data ) ;

extern unsigned long   i386_getreg(void * base , unsigned long offset ) ;
extern unsigned long   i386_getreg16(void * base , unsigned long offset ) ;
extern unsigned long   i386_getreg8(void * base , unsigned long offset ) ;

#define makemask(mask) ((0xffffffff >> (31 - (1 ? mask))) & ((0xffffffff << (0 ? mask)) & 0xffffffff))  

#define   BitFld( mask , data ) ((data & makemask(mask)) >> (0 ? mask))
#define _GetBits( data , mask ) ((data & makemask(mask)) >> (0 ? mask))
#define   rdbits( data , mask ) ((data & makemask(mask)) >> (0 ? mask))  

#define setreg(offset , data)    i386_setreg( nv->Regs , offset , data ) 
#define getreg(offset )          i386_getreg( nv->Regs , offset ) 

#define setreg8(offset , data)    i386_setreg8( nv->Regs , offset , data ) 
#define getreg8(offset )          i386_getreg8( nv->Regs , offset ) 

#define getfld(reg , mask )  _GetBits( getreg(reg) , mask )
#define modbits( rdata , mask , val ) (( rdata & ~makemask(mask) ) | (( val << ( 0 ? mask )) & makemask( mask )))       
#define modreg( reg , mask , val ) setreg( reg , ( ( getreg(reg) | ( val << ( 0 ? mask )) )  & makemask( mask ) ))     

#define LFmakemask(hi , low ) ((0xffffffff >> (31 - hi)) & ((0xffffffff << low) & 0xffffffff))


#define LSetRegVal(base , m , offset , hi , low , val ) setreg(base + (offset << 2),(getreg( base + (offset << 2)) & ~LVmakemask(hi,low)) | (val << lo))


#define LSetRegFld(base , val , data) setreg(base + (( 2 ? val) << 2) , (getreg( base + (( 2 ? val) << 2)) & ~LFmakemask(val)) | (data << (0 ? val)))      

#define LGetRegFld(base , val) ((getreg(base + ((2 ? val) << 2)) & LFmakemask(val)) >> (0 ? val)) 
             




