/* * Master Control */ 

#define NV04_PMC              0x00000FFF:0x00000000 /* RW */ 

#define NV04_PMC_BOOT_0                  0x00000000 /* R- */ 
#define NV04_PMC_BOOT_0_MINOR_REVISION 3:0 /* C- */
#define NV04_PMC_BOOT_0_MINOR_REVISION_0 0x00000000 /* C- */ 
#define NV04_PMC_BOOT_0_MAJOR_REVISION 7:4 /* C- */ 
#define NV04_PMC_BOOT_0_MAJOR_REVISION_A 0x00000000 /* C- */ 
#define NV04_PMC_BOOT_0_MAJOR_REVISION_B 0x00000001 /* -- */ 
#define NV04_PMC_BOOT_0_IMPLEMENTATION 11:8 /* C- */ 
#define NV04_PMC_BOOT_0_IMPLEMENTATION_NV4_0 0x00000000 /* C- */ 
#define NV04_PMC_BOOT_0_ARCHITECTURE 15:12 /* C- */ 
#define NV04_PMC_BOOT_0_ARCHITECTURE_NV0 0x00000000 /* -- */ 
#define NV04_PMC_BOOT_0_ARCHITECTURE_NV1 0x00000001 /* -- */ 
#define NV04_PMC_BOOT_0_ARCHITECTURE_NV2 0x00000002 /* -- */ 
#define NV04_PMC_BOOT_0_ARCHITECTURE_NV3 0x00000003 /* -- */ 
#define NV04_PMC_BOOT_0_ARCHITECTURE_NV4 0x00000004 /* C- */ 
#define NV04_PMC_BOOT_0_FIB_REVISION 19:16 /* C- */ 
#define NV04_PMC_BOOT_0_FIB_REVISION_A01 0x00000000 /* C- */ 
#define NV04_PMC_BOOT_0_FIB_REVISION_A02 0x00000001 /* C- */ 
#define NV04_PMC_BOOT_0_FIB_REVISION_A03_P25 0x00000002 /* C- */ 
#define NV04_PMC_BOOT_0_FIB_REVISION_A03 0x00000003 /* C- */ 
#define NV04_PMC_BOOT_0_FIB_REVISION_A04 0x00000004 /* C- */ 
#define NV04_PMC_BOOT_0_FIB_REVISION_A05 0x00000005 /* C- */ 
#define NV04_PMC_BOOT_0_MASK_REVISION 23:20 /* C- */ 
#define NV04_PMC_BOOT_0_MASK_REVISION_A 0x00000000 /* -- */ 
#define NV04_PMC_BOOT_0_MASK_REVISION_B 0x00000001 /* C- */ 
#define NV04_PMC_BOOT_0_MASK_REVISION_C 0x00000002 /* -- */ 
#define NV04_PMC_BOOT_0_MANUFACTURER 27:24 /* C- */ 
#define NV04_PMC_BOOT_0_MANUFACTURER_NVIDIA 0x00000000 /* C- */ 
#define NV04_PMC_BOOT_0_FOUNDRY 31:28 /* C- */ 
#define NV04_PMC_BOOT_0_FOUNDRY_SGS 0x00000000 /* -- */ 
#define NV04_PMC_BOOT_0_FOUNDRY_HELIOS 0x00000001 /* -- */ 
#define NV04_PMC_BOOT_0_FOUNDRY_TSMC 0x00000002 /* C- */ 

#define NV04_PMC_INTR_0 0x00000100 /* RW */ 
#define NV04_PMC_INTR_0_PMEDIA 4:4 /* R- */
#define NV04_PMC_INTR_0_PMEDIA_NOT_PENDING 0x00000000 /* R- */ 
#define NV04_PMC_INTR_0_PMEDIA_PENDING 0x00000001 /* R- */ 
#define NV04_PMC_INTR_0_PFIFO 8:8 /* R- */ 
#define NV04_PMC_INTR_0_PFIFO_NOT_PENDING 0x00000000 /* R- */ 
#define NV04_PMC_INTR_0_PFIFO_PENDING 0x00000001 /* R- */ 
#define NV04_PMC_INTR_0_PGRAPH 12:12 /* R- */ 
#define NV04_PMC_INTR_0_PGRAPH_NOT_PENDING 0x00000000 /* R- */ 
#define NV04_PMC_INTR_0_PGRAPH_PENDING 0x00000001 /* R- */ 
#define NV04_PMC_INTR_0_PVIDEO 16:16 /* R- */ 
#define NV04_PMC_INTR_0_PVIDEO_NOT_PENDING 0x00000000 /* R- */ 
#define NV04_PMC_INTR_0_PVIDEO_PENDING 0x00000001 /* R- */ 
#define NV04_PMC_INTR_0_PTIMER 20:20 /* R- */ 
#define NV04_PMC_INTR_0_PTIMER_NOT_PENDING 0x00000000 /* R- */ 
#define NV04_PMC_INTR_0_PTIMER_PENDING 0x00000001 /* R- */ 
#define NV04_PMC_INTR_0_PCRTC 24:24 /* R- */ 
#define NV04_PMC_INTR_0_PCRTC_NOT_PENDING 0x00000000 /* R- */ 
#define NV04_PMC_INTR_0_PCRTC_PENDING 0x00000001 /* R- */ 
#define NV04_PMC_INTR_0_PBUS 28:28 /* R- */ 
#define NV04_PMC_INTR_0_PBUS_NOT_PENDING 0x00000000 /* R- */ 
#define NV04_PMC_INTR_0_PBUS_PENDING 0x00000001 /* R- */ 
#define NV04_PMC_INTR_0_SOFTWARE 31:31 /* RW */ 
#define NV04_PMC_INTR_0_SOFTWARE_NOT_PENDING 0x00000000 /* RW */ 
#define NV04_PMC_INTR_0_SOFTWARE_PENDING 0x00000001 /* RW */ 
#define NV04_PMC_INTR_EN_0 0x00000140 /* RW */ 
#define NV04_PMC_INTR_EN_0_INTA 1:0 /* RW */ 
#define NV04_PMC_INTR_EN_0_INTA_DISABLED 0x00000000 /* RW */ 
#define NV04_PMC_INTR_EN_0_INTA_HARDWARE 0x00000001 /* RW */ 
#define NV04_PMC_INTR_EN_0_INTA_SOFTWARE 0x00000002 /* RW */ 
#define NV04_PMC_INTR_READ_0 0x00000160 /* R- */ 
#define NV04_PMC_INTR_READ_0_INTA 0:0 /* R- */ 
#define NV04_PMC_INTR_READ_0_INTA_LOW 0x00000000 /* R- */ 
#define NV04_PMC_INTR_READ_0_INTA_HIGH 0x00000001 /* R- */ 

#define NV04_PMC_ENABLE 0x00000200 /* RW */
#define NV04_PMC_ENABLE_PMEDIA 4:4 /* RW */ 
#define NV04_PMC_ENABLE_PMEDIA_DISABLED 0x00000000 /* RW */ 
#define NV04_PMC_ENABLE_PMEDIA_ENABLED 0x00000001 /* RW */ 
#define NV04_PMC_ENABLE_PFIFO 8:8 /* RW */ 
#define NV04_PMC_ENABLE_PFIFO_DISABLED 0x00000000 /* RW */ 
#define NV04_PMC_ENABLE_PFIFO_ENABLED 0x00000001 /* RW */ 
#define NV04_PMC_ENABLE_PGRAPH 12:12 /* RW */ 
#define NV04_PMC_ENABLE_PGRAPH_DISABLED 0x00000000 /* RW */ 
#define NV04_PMC_ENABLE_PGRAPH_ENABLED 0x00000001 /* RW */ 
#define NV04_PMC_ENABLE_PPMI 16:16 /* RW */ 
#define NV04_PMC_ENABLE_PPMI_DISABLED 0x00000000 /* RW */ 
#define NV04_PMC_ENABLE_PPMI_ENABLED 0x00000001 /* RW */ 
#define NV04_PMC_ENABLE_PFB 20:20 /* RW */ 
#define NV04_PMC_ENABLE_PFB_DISABLED 0x00000000 /* RW */ 
#define NV04_PMC_ENABLE_PFB_ENABLED 0x00000001 /* RW */ 
#define NV04_PMC_ENABLE_PCRTC 24:24 /* RW */ 
#define NV04_PMC_ENABLE_PCRTC_DISABLED 0x00000000 /* RW */ 
#define NV04_PMC_ENABLE_PCRTC_ENABLED 0x00000001 /* RW */ 
#define NV04_PMC_ENABLE_PVIDEO 28:28 /* RW */ 
#define NV04_PMC_ENABLE_PVIDEO_DISABLED 0x00000000 /* RW */ 
#define NV04_PMC_ENABLE_PVIDEO_ENABLED 0x00000001 /* RW */ 
