
/* class NV01_MEMORY_LOCAL_LINEAR */
#define  NV01_MEMORY_LOCAL_LINEAR                                  (0x00000040)
#define NV0040_ALLOC_STATUS_SUCCESS                                (0x00000000)
#define NV0040_ALLOC_STATUS_ERROR_INSUFFICIENT_RESOURCES           (0x00000002)
#define NV0040_ALLOC_STATUS_ERROR_BAD_OBJECT_NEW                   (0x00000003)
#define NV0040_ALLOC_STATUS_ERROR_BAD_OBJECT_PARENT                (0x00000004)
#define NV0040_ALLOC_STATUS_ERROR_BAD_FLAGS_MEMORY_PAGES           (0x00000005)
#define NV0040_ALLOC_STATUS_ERROR_BAD_FLAGS_MAPPING_ACCESS         (0x00000006)
#define NV0040_ALLOC_STATUS_ERROR_BAD_FLAGS_MAPPING_COHERENCY      (0x00000007)
#define NV0040_ALLOC_FLAGS_MEMORY_PAGES                                     3:0
#define NV0040_ALLOC_FLAGS_MEMORY_PAGES_FIXED_CONTIGUOUS           (0x00000000)
#define NV0040_ALLOC_FLAGS_MEMORY_PAGES_FIXED_NONCONTIGUOUS        (0x00000001)
#define NV0040_ALLOC_FLAGS_MEMORY_PAGES_NONPAGABLE_NONCONTIGUOUS   (0x00000001)
#define NV0040_ALLOC_FLAGS_MEMORY_PAGES_PAGABLE_NONCONTIGUOUS      (0x00000002)
#define NV0040_ALLOC_FLAGS_MAPPING_ACCESS                                   7:4
#define NV0040_ALLOC_FLAGS_MAPPING_ACCESS_READ_WRITE_NONCOMBINED   (0x00000000)
#define NV0040_ALLOC_FLAGS_MAPPING_ACCESS_READ_WRITE_COMBINED      (0x00000001)
#define NV0040_ALLOC_FLAGS_MAPPING_ACCESS_READ_ONLY                (0x00000002)
#define NV0040_ALLOC_FLAGS_MAPPING_ACCESS_WRITE_NONCOMBINED        (0x00000003)
#define NV0040_ALLOC_FLAGS_MAPPING_ACCESS_WRITE_COMBINED           (0x00000004)
#define NV0040_ALLOC_FLAGS_MAPPING_COHERENCY                               31:8
#define NV0040_ALLOC_FLAGS_MAPPING_COHERENCY_UNCACHED              (0x00000000)
#define NV0040_ALLOC_FLAGS_MAPPING_COHERENCY_CACHED                (0x00000001)
#define NV0040_FREE_STATUS_SUCCESS                                 (0x00000000)
#define NV0040_FREE_STATUS_ERROR_OBJECT_IN_USE                     (0x00000002)
#define NV0040_CONTROL_STATUS_SUCCESS                              (0x00000000)
#define NV0040_TYPEDEF                                    nv01MemoryLocalLinear
/* deprecated stuff */
#ifdef NVDEPRECATED
#define NV0040_ALLOC_FLAGS_MAPPING_ACCESS_READ_WRITE               (0x00000000)
#define NV0040_ALLOC_FLAGS_MAPPING_ACCESS_WRITE_ONLY               (0x00000003)
#endif


/* class NV01_MAPPING_LOCAL */
#define  NV01_MAPPING_LOCAL                                        (0x00000041)
#define NV0041_ALLOC_STATUS_SUCCESS                                (0x00000000)
#define NV0041_ALLOC_STATUS_ERROR_INSUFFICIENT_RESOURCES           (0x00000002)
#define NV0041_ALLOC_STATUS_ERROR_BAD_OBJECT_NEW                   (0x00000003)
#define NV0041_ALLOC_STATUS_ERROR_BAD_OBJECT_PARENT                (0x00000004)
#define NV0041_ALLOC_STATUS_ERROR_BAD_BASE                         (0x00000005)
#define NV0041_ALLOC_STATUS_ERROR_BAD_LIMIT                        (0x00000006)
#define NV0041_ALLOC_STATUS_ERROR_PROTECTION_FAULT                 (0x00000007)
#define NV0041_FREE_STATUS_SUCCESS                                 (0x00000000)
#define NV0041_FREE_STATUS_ERROR_OBJECT_IN_USE                     (0x00000002)
#define NV0041_CONTROL_STATUS_SUCCESS                              (0x00000000)
#define  NV0041_TYPEDEF                                        nv01MappingLocal

/* class NV03_CONTEXT_ROP */
#define  NV03_CONTEXT_ROP                                          (0x00000043)
#define NV0043_NOTIFIERS_NOTIFY                                             (0)
#define NV0043_NOTIFICATION_STATUS_DONE_SUCCESS                          (0x00)
#define NV0043_NOTIFICATION_STATUS_IN_PROGRESS                           (0xFF)
#define NV0043_ALLOC_STATUS_SUCCESS                                (0x00000000)
#define NV0043_ALLOC_STATUS_ERROR_INSUFFICIENT_RESOURCES           (0x00000002)
#define NV0043_ALLOC_STATUS_ERROR_BAD_OBJECT_NEW                   (0x00000003)
#define NV0043_ALLOC_STATUS_ERROR_BAD_OBJECT_PARENT                (0x00000004)
#define NV0043_FREE_STATUS_SUCCESS                                 (0x00000000)
#define NV0043_FREE_STATUS_ERROR_OBJECT_IN_USE                     (0x00000002)
#define NV0043_CONTROL_STATUS_SUCCESS                              (0x00000000)
#define NV0043_TYPEDEF                                           nv03ContextRop
/* method offsets, fields, and values */
#define NV0043_NO_OPERATION                                        (0x00000100)
#define NV0043_NOTIFY                                              (0x00000104)
#define NV0043_NOTIFY_WRITE_LE_NOTIFY                              (0x00000000)
#define NV0043_NOTIFY_WRITE_LE_NOTIFY_AWAKEN                       (0x00000001)
#define NV0043_NOTIFY_WRITE_LE_NOTIFY_AWAKEN_2                     (0x00000002)
#define NV0043_NOTIFY_WRITE_LE_NOTIFY_AWAKEN_3                     (0x00000003)
#define NV0043_NOTIFY_WRITE_LE_NOTIFY_AWAKEN_4                     (0x00000004)
#define NV0043_NOTIFY_WRITE_LE_NOTIFY_AWAKEN_5                     (0x00000005)
#define NV0043_NOTIFY_WRITE_LE_NOTIFY_AWAKEN_6                     (0x00000006)
#define NV0043_NOTIFY_WRITE_LE_NOTIFY_AWAKEN_7                     (0x00000007)
#define NV0043_NOTIFY_WRITE_LE_NOTIFY_AWAKEN_8                     (0x00000008)
#define NV0043_NOTIFY_WRITE_LE_NOTIFY_AWAKEN_9                     (0x00000009)
#define NV0043_NOTIFY_WRITE_LE_NOTIFY_AWAKEN_A                     (0x0000000A)
#define NV0043_NOTIFY_WRITE_LE_NOTIFY_AWAKEN_B                     (0x0000000B)
#define NV0043_NOTIFY_WRITE_LE_NOTIFY_AWAKEN_C                     (0x0000000C)
#define NV0043_NOTIFY_WRITE_LE_NOTIFY_AWAKEN_D                     (0x0000000D)
#define NV0043_NOTIFY_WRITE_LE_NOTIFY_AWAKEN_E                     (0x0000000E)
#define NV0043_NOTIFY_WRITE_LE_NOTIFY_AWAKEN_F                     (0x0000000F)
#define NV0043_SET_CONTEXT_DMA_NOTIFIES                            (0x00000180)
#define NV0043_SET_ROP                                             (0x00000300)
#define NV0046_NOTIFIERS_SYNCHRONIZE                                        (0)
#define NV0046_NOTIFIERS_GET                                                (0)
#define NV0046_NOTIFIERS_SET_IMAGE(b)                                   (1+(b))
#define NV0046_NOTIFIERS_SET_CURSOR(b)                                  (3+(b))
#define NV0046_NOTIFIERS_SET_DAC(b)                                     (5+(b))
#define NV0046_NOTIFICATION_STATUS_DONE_SUCCESS                          (0x00)
#define NV0046_NOTIFICATION_STATUS_INVALID_OFFSET                        (0x01)
#define NV0046_NOTIFICATION_STATUS_VALID_OFFSET                          (0x02)
#define NV0046_NOTIFICATION_STATUS_IN_PROGRESS                           (0xFF)
#define NV0046_ALLOC_STATUS_SUCCESS                                (0x00000000)
#define NV0046_ALLOC_STATUS_ERROR_INSUFFICIENT_RESOURCES           (0x00000002)
#define NV0046_ALLOC_STATUS_ERROR_BAD_OBJECT_NEW                   (0x00000003)
#define NV0046_ALLOC_STATUS_ERROR_BAD_OBJECT_PARENT                (0x00000004)
#define NV0046_FREE_STATUS_SUCCESS                                 (0x00000000)
#define NV0046_FREE_STATUS_ERROR_OBJECT_IN_USE                     (0x00000002)
#define NV0046_CONTROL_STATUS_SUCCESS                              (0x00000000)
#define NV0046_TYPEDEF                                    nv03VideoLutCursorDac
/* method offsets, fields, and values */
#define NV0046_SYNCHRONIZE                                         (0x00000100)
#define NV0046_SYNCHRONIZE_NO_OPERATION                            (0x00000000)
#define NV0046_SYNCHRONIZE_WAIT_FOR_IDLE                           (0x00000001)
#define NV0046_SYNCHRONIZE_WAIT_FOR_IDLE_WRITE_LE_NOTIFY           (0x00000002)
#define NV0046_SYNCHRONIZE_WAIT_FOR_IDLE_WRITE_LE_NOTIFY_AWAKEN    (0x00000003)
#define NV0046_STOP_IMAGE                                          (0x00000104)
#define NV0046_STOP_IMAGE_IMMEDIATELY                              (0x00000000)
#define NV0046_STOP_IMAGE_AT_END_OF_SAMPLE                         (0x00000001)
#define NV0046_STOP_IMAGE_AT_END_OF_BUFFER                         (0x00000001)
#define NV0046_STOP_CURSOR                                         (0x00000108)
#define NV0046_STOP_CURSOR_IMMEDIATELY                             (0x00000000)
#define NV0046_STOP_CURSOR_AT_END_OF_SAMPLE                        (0x00000001)
#define NV0046_STOP_CURSOR_AT_END_OF_BUFFER                        (0x00000001)
#define NV0046_STOP_DAC                                            (0x0000010C)
#define NV0046_STOP_DAC_IMMEDIATELY                                (0x00000000)
#define NV0046_STOP_DAC_AT_END_OF_SAMPLE                           (0x00000001)
#define NV0046_SET_CONTEXT_DMA_NOTIFIES                            (0x00000180)
#define NV0046_SET_CONTEXT_DMA_IMAGE(b)                            (0x00000184\
                                                                   +(b)*0x0004)
#define NV0046_SET_CONTEXT_DMA_LUT(b)                              (0x0000018C\
                                                                   +(b)*0x0004)
#define NV0046_SET_CONTEXT_DMA_CURSOR(b)                           (0x00000194\
                                                                   +(b)*0x0004)
#define NV0046_GET                                                 (0x000002FC)
#define NV0046_GET_LE_NOTIFY_IMAGE_0                               (0x00000000)
#define NV0046_GET_LE_NOTIFY_IMAGE_1                               (0x00000001)
#define NV0046_SET_IMAGE(b)                                        (0x00000300\
                                                                   +(b)*0x0008)
#define NV0046_SET_IMAGE_OFFSET(b)                                 (0x00000300\
                                                                   +(b)*0x0008)
#define NV0046_SET_IMAGE_FORMAT(b)                                 (0x00000304\
                                                                   +(b)*0x0008)
#define NV0046_SET_IMAGE_FORMAT_PITCH                                      15:0
#define NV0046_SET_IMAGE_FORMAT_COLOR                                     27:16
#define NV0046_SET_IMAGE_FORMAT_COLOR_LUT_NE_Y8                    (0x00000000)
#define NV0046_SET_IMAGE_FORMAT_COLOR_BYPASS_LE_R5G6B5             (0x00000001)
#define NV0046_SET_IMAGE_FORMAT_COLOR_LE_BYPASS16                  (0x00000002)
#define NV0046_SET_IMAGE_FORMAT_COLOR_LE_BYPASS32                  (0x00000003)
#define NV0046_SET_IMAGE_FORMAT_NOTIFY                                    31:28
#define NV0046_SET_IMAGE_FORMAT_NOTIFY_WRITE_LE_NOTIFY             (0x00000000)
#define NV0046_SET_IMAGE_FORMAT_NOTIFY_WRITE_LE_NOTIFY_AWAKEN      (0x00000001)
#define NV0046_SET_CURSOR(b)                                       (0x00000340\
                                                                   +(b)*0x000C)
#define NV0046_SET_CURSOR_OFFSET(b)                                (0x00000340\
                                                                   +(b)*0x000C)
#define NV0046_SET_CURSOR_POINT_OUT(b)                             (0x00000344\
                                                                   +(b)*0x000C)
#define NV0046_SET_CURSOR_POINT_OUT_X                                      15:0
#define NV0046_SET_CURSOR_POINT_OUT_Y                                     31:16
#define NV0046_SET_CURSOR_FORMAT(b)                                (0x00000348\
                                                                   +(b)*0x000C)
#define NV0046_SET_CURSOR_FORMAT_NOTIFY_WRITE_LE_NOTIFY            (0x00000000)
#define NV0046_SET_CURSOR_FORMAT_NOTIFY_WRITE_LE_NOTIFY_AWAKEN     (0x00000001)
#define NV0046_SET_CURSOR_POINT_OUT_A                              (0x00000358)
#define NV0046_SET_CURSOR_POINT_OUT_A_X                                    15:0
#define NV0046_SET_CURSOR_POINT_OUT_A_Y                                   31:16
#define NV0046_SET_DAC(b)                                          (0x00000380\
                                                                   +(b)*0x0010)
#define NV0046_SET_DAC_IMAGE_SIZE(b)                               (0x00000380\
                                                                   +(b)*0x0010)
#define NV0046_SET_DAC_IMAGE_SIZE_WIDTH                                    15:0
#define NV0046_SET_DAC_IMAGE_SIZE_HEIGHT                                  31:16
#define NV0046_SET_DAC_HORIZONTAL_SYNC(b)                          (0x00000384\
                                                                   +(b)*0x0010)
#define NV0046_SET_DAC_HORIZONTAL_SYNC_START                               15:0
#define NV0046_SET_DAC_HORIZONTAL_SYNC_WIDTH                              27:16
#define NV0046_SET_DAC_HORIZONTAL_SYNC_POLARITY                           31:28
#define NV0046_SET_DAC_HORIZONTAL_SYNC_POLARITY_POSITIVE           (0x00000000)
#define NV0046_SET_DAC_HORIZONTAL_SYNC_POLARITY_NEGATIVE           (0x00000001)
#define NV0046_SET_DAC_VERTICAL_SYNC(b)                            (0x00000388\
                                                                   +(b)*0x0010)
#define NV0046_SET_DAC_VERTICAL_SYNC_START                                 15:0
#define NV0046_SET_DAC_VERTICAL_SYNC_WIDTH                                27:16
#define NV0046_SET_DAC_VERTICAL_SYNC_POLARITY                             31:28
#define NV0046_SET_DAC_VERTICAL_SYNC_POLARITY_POSITIVE             (0x00000000)
#define NV0046_SET_DAC_VERTICAL_SYNC_POLARITY_NEGATIVE             (0x00000001)
#define NV0046_SET_DAC_TOTAL_SIZE(b)                               (0x0000038C\
                                                                   +(b)*0x0010)
#define NV0046_SET_DAC_TOTAL_SIZE_WIDTH                                    15:0
#define NV0046_SET_DAC_TOTAL_SIZE_HEIGHT                                  27:16
#define NV0046_SET_DAC_TOTAL_SIZE_NOTIFY                                  31:28
#define NV0046_SET_DAC_TOTAL_SIZE_NOTIFY_WRITE_LE_NOTIFY           (0x00000000)
#define NV0046_SET_DAC_TOTAL_SIZE_NOTIFY_WRITE_LE_NOTIFY_AWAKEN    (0x00000001)
#define NV0046_SET_PIXEL_CLOCK                                     (0x000003A0)
/* obsolete stuff */
#if NVDEPRECATED
#define NV0046_STOP_IMAGE_NORMALLY                                 (0x00000001)
#define NV0046_STOP_CURSOR_NORMALLY                                (0x00000001)
#define NV0046_STOP_DAC_NORMALLY                                   (0x00000001)
#endif
/* class NV03_DX3_TEXTURED_TRIANGLE */
#define  NV03_DX3_TEXTURED_TRIANGLE                                (0x00000048)
#define NV0048_NOTIFIERS_NOTIFY                                             (0)
#define NV0048_NOTIFICATION_STATUS_DONE_SUCCESS                          (0x00)
#define NV0048_NOTIFICATION_STATUS_IN_PROGRESS                           (0xFF)
#define NV0048_ALLOC_STATUS_SUCCESS                                (0x00000000)
#define NV0048_ALLOC_STATUS_ERROR_INSUFFICIENT_RESOURCES           (0x00000002)
#define NV0048_ALLOC_STATUS_ERROR_BAD_OBJECT_NEW                   (0x00000003)
#define NV0048_ALLOC_STATUS_ERROR_BAD_OBJECT_PARENT                (0x00000004)
/* NVSW002_FREE parameters and errors */
#define NV0048_FREE_STATUS_SUCCESS                                 (0x00000000)
#define NV0048_FREE_STATUS_ERROR_OBJECT_IN_USE                     (0x00000002)
#define NV0048_CONTROL_STATUS_SUCCESS                              (0x00000000)
#define NV0048_TYPEDEF                                  nv03Dx3TexturedTriangle
/* method offsets, fields, and values */
#define NV0048_NO_OPERATION                                        (0x00000100)
#define NV0048_NOTIFY                                              (0x00000104)
#define NV0048_NOTIFY_WRITE_LE_NOTIFY                              (0x00000000)
#define NV0048_NOTIFY_WRITE_LE_NOTIFY_AWAKEN                       (0x00000001)
#define NV0048_NOTIFY_WRITE_LE_NOTIFY_AWAKEN_2                     (0x00000002)
#define NV0048_NOTIFY_WRITE_LE_NOTIFY_AWAKEN_3                     (0x00000003)
#define NV0048_NOTIFY_WRITE_LE_NOTIFY_AWAKEN_4                     (0x00000004)
#define NV0048_NOTIFY_WRITE_LE_NOTIFY_AWAKEN_5                     (0x00000005)
#define NV0048_NOTIFY_WRITE_LE_NOTIFY_AWAKEN_6                     (0x00000006)
#define NV0048_NOTIFY_WRITE_LE_NOTIFY_AWAKEN_7                     (0x00000007)
#define NV0048_NOTIFY_WRITE_LE_NOTIFY_AWAKEN_8                     (0x00000008)
#define NV0048_NOTIFY_WRITE_LE_NOTIFY_AWAKEN_9                     (0x00000009)
#define NV0048_NOTIFY_WRITE_LE_NOTIFY_AWAKEN_A                     (0x0000000A)
#define NV0048_NOTIFY_WRITE_LE_NOTIFY_AWAKEN_B                     (0x0000000B)
#define NV0048_NOTIFY_WRITE_LE_NOTIFY_AWAKEN_C                     (0x0000000C)
#define NV0048_NOTIFY_WRITE_LE_NOTIFY_AWAKEN_D                     (0x0000000D)
#define NV0048_NOTIFY_WRITE_LE_NOTIFY_AWAKEN_E                     (0x0000000E)
#define NV0048_NOTIFY_WRITE_LE_NOTIFY_AWAKEN_F                     (0x0000000F)
#define NV0048_SET_CONTEXT_DMA_NOTIFIES                            (0x00000180)
#define NV0048_SET_CONTEXT_DMA_TEXTURE                             (0x00000184)
#define NV0048_SET_CONTEXT_CLIP_RECTANGLE                          (0x00000188)
#define NV0048_SET_CONTEXT_SURFACES                                (0x0000018C)
#define NV0048_TEXTURE_OFFSET                                      (0x00000304)
#define NV0048_TEXTURE_FORMAT                                      (0x00000308)
#define NV0048_TEXTURE_FORMAT_COLOR_KEY_VALUE                              15:0
#define NV0048_TEXTURE_FORMAT_COLOR_KEY_MATCH                             19:16
#define NV0048_TEXTURE_FORMAT_COLOR_KEY_MATCH_SRCCOPY              (0x00000000)
#define NV0048_TEXTURE_FORMAT_COLOR_KEY_MATCH_ZERO_ALPHA           (0x00000001)
#define NV0048_TEXTURE_FORMAT_COLOR                                       23:20
#define NV0048_TEXTURE_FORMAT_COLOR_LE_A1R5G5B5                    (0x00000000)
#define NV0048_TEXTURE_FORMAT_COLOR_LE_X1R5G5B5                    (0x00000001)
#define NV0048_TEXTURE_FORMAT_COLOR_LE_A4R4G4B4                    (0x00000002)
#define NV0048_TEXTURE_FORMAT_COLOR_LE_R5G6B5                      (0x00000003)
#define NV0048_TEXTURE_FORMAT_SIZE_MIN                                    27:24
#define NV0048_TEXTURE_FORMAT_SIZE_MIN_1X1                         (0x00000000)
#define NV0048_TEXTURE_FORMAT_SIZE_MIN_2X2                         (0x00000001)
#define NV0048_TEXTURE_FORMAT_SIZE_MIN_4X4                         (0x00000002)
#define NV0048_TEXTURE_FORMAT_SIZE_MIN_8X8                         (0x00000003)
#define NV0048_TEXTURE_FORMAT_SIZE_MIN_16X16                       (0x00000004)
#define NV0048_TEXTURE_FORMAT_SIZE_MIN_32X32                       (0x00000005)
#define NV0048_TEXTURE_FORMAT_SIZE_MIN_64X64                       (0x00000006)
#define NV0048_TEXTURE_FORMAT_SIZE_MIN_128X128                     (0x00000007)
#define NV0048_TEXTURE_FORMAT_SIZE_MIN_256X256                     (0x00000008)
#define NV0048_TEXTURE_FORMAT_SIZE_MIN_512X512                     (0x00000009)
#define NV0048_TEXTURE_FORMAT_SIZE_MIN_1024X1024                   (0x0000000A)
#define NV0048_TEXTURE_FORMAT_SIZE_MIN_2048X2048                   (0x0000000B)
#define NV0048_TEXTURE_FORMAT_SIZE_MAX                                    31:28
#define NV0048_TEXTURE_FORMAT_SIZE_MAX_1X1                         (0x00000000)
#define NV0048_TEXTURE_FORMAT_SIZE_MAX_2X2                         (0x00000001)
#define NV0048_TEXTURE_FORMAT_SIZE_MAX_4X4                         (0x00000002)
#define NV0048_TEXTURE_FORMAT_SIZE_MAX_8X8                         (0x00000003)
#define NV0048_TEXTURE_FORMAT_SIZE_MAX_16X16                       (0x00000004)
#define NV0048_TEXTURE_FORMAT_SIZE_MAX_32X32                       (0x00000005)
#define NV0048_TEXTURE_FORMAT_SIZE_MAX_64X64                       (0x00000006)
#define NV0048_TEXTURE_FORMAT_SIZE_MAX_128X128                     (0x00000007)
#define NV0048_TEXTURE_FORMAT_SIZE_MAX_256X256                     (0x00000008)
#define NV0048_TEXTURE_FORMAT_SIZE_MAX_512X512                     (0x00000009)
#define NV0048_TEXTURE_FORMAT_SIZE_MAX_1024X1024                   (0x0000000A)
#define NV0048_TEXTURE_FORMAT_SIZE_MAX_2048X2048                   (0x0000000B)
#define NV0048_TEXTURE_FILTER                                      (0x0000030C)
#define NV0048_TEXTURE_FILTER_SPREAD_X                                      4:0
#define NV0048_TEXTURE_FILTER_IGNORE0                                       7:5
#define NV0048_TEXTURE_FILTER_SPREAD_Y                                     12:8
#define NV0048_TEXTURE_FILTER_IGNORE1                                     15:13
#define NV0048_TEXTURE_FILTER_SIZE_ADJUST                                 23:16
#define NV0048_TEXTURE_FILTER_IGNORE2                                     31:24
#define NV0048_FOG_COLOR                                           (0x00000310)
#define NV0048_CONTROL0                                            (0x00000314)
#define NV0048_CONTROL0_INTERPOLATOR                                        3:0
#define NV0048_CONTROL0_INTERPOLATOR_ZOH_CORNER                    (0x00000000)
#define NV0048_CONTROL0_INTERPOLATOR_ZOH_CENTER                    (0x00000001)
#define NV0048_CONTROL0_INTERPOLATOR_FOH_CENTER                    (0x00000002)
#define NV0048_CONTROL0_WRAP_U                                              5:4
#define NV0048_CONTROL0_WRAP_U_CYLINDRICAL                         (0x00000000)
#define NV0048_CONTROL0_WRAP_U_WRAP                                (0x00000001)
#define NV0048_CONTROL0_WRAP_U_MIRROR                              (0x00000002)
#define NV0048_CONTROL0_WRAP_U_CLAMP                               (0x00000003)
#define NV0048_CONTROL0_WRAP_V                                              7:6
#define NV0048_CONTROL0_WRAP_V_CYLINDRICAL                         (0x00000000)
#define NV0048_CONTROL0_WRAP_V_WRAP                                (0x00000001)
#define NV0048_CONTROL0_WRAP_V_MIRROR                              (0x00000002)
#define NV0048_CONTROL0_WRAP_V_CLAMP                               (0x00000003)
#define NV0048_CONTROL0_SOURCE_COLOR                                       11:8
#define NV0048_CONTROL0_SOURCE_COLOR_NORMAL                        (0x00000001)
#define NV0048_CONTROL0_SOURCE_COLOR_COLOR_INVERSE                 (0x00000002)
#define NV0048_CONTROL0_SOURCE_COLOR_ALPHA_INVERSE                 (0x00000003)
#define NV0048_CONTROL0_SOURCE_COLOR_ALPHA_ONE                     (0x00000006)
#define NV0048_CONTROL0_CULLING                                           14:12
#define NV0048_CONTROL0_CULLING_NONE                               (0x00000001)
#define NV0048_CONTROL0_CULLING_COUNTERCLOCKWISE                   (0x00000002)
#define NV0048_CONTROL0_CULLING_CLOCKWISE                          (0x00000003)
#define NV0048_CONTROL0_Z_PERSPECTIVE_ENABLE                              15:15
#define NV0048_CONTROL0_Z_PERSPECTIVE_ENABLE_FALSE                 (0x00000000)
#define NV0048_CONTROL0_Z_PERSPECTIVE_ENABLE_TRUE                  (0x00000001)
#define NV0048_CONTROL0_ZFUNC                                             19:16
#define NV0048_CONTROL0_ZFUNC_NEVER                                (0x00000001)
#define NV0048_CONTROL0_ZFUNC_LESS                                 (0x00000002)
#define NV0048_CONTROL0_ZFUNC_EQUAL                                (0x00000003)
#define NV0048_CONTROL0_ZFUNC_LESSEQUAL                            (0x00000004)
#define NV0048_CONTROL0_ZFUNC_GREATER                              (0x00000005)
#define NV0048_CONTROL0_ZFUNC_NOTEQUAL                             (0x00000006)
#define NV0048_CONTROL0_ZFUNC_GREATEREQUAL                         (0x00000007)
#define NV0048_CONTROL0_ZFUNC_ALWAYS                               (0x00000008)
#define NV0048_CONTROL0_Z_WRITE_ENABLE                                    23:20
#define NV0048_CONTROL0_Z_WRITE_ENABLE_TRUE                        (0x00000003)
#define NV0048_CONTROL0_Z_WRITE_ENABLE_FALSE                       (0x00000005)
#define NV0048_CONTROL0_COLOR_WRITE_ENABLE                                26:24
#define NV0048_CONTROL0_COLOR_WRITE_ENABLE_FALSE                   (0x00000000)
#define NV0048_CONTROL0_COLOR_WRITE_ENABLE_TRUE                    (0x00000003)
#define NV0048_CONTROL0_ROP                                               28:27
#define NV0048_CONTROL0_ROP_BLEND                                  (0x00000000)
#define NV0048_CONTROL0_ROP_ADD                                    (0x00000001)
#define NV0048_CONTROL0_BETA                                              29:29
#define NV0048_CONTROL0_BETA_SRCALPHA                              (0x00000000)
#define NV0048_CONTROL0_BETA_DESTCOLOR                             (0x00000001)
#define NV0048_CONTROL0_DEST_BLEND                                        30:30
#define NV0048_CONTROL0_DEST_BLEND_INVBETA                         (0x00000000)
#define NV0048_CONTROL0_DEST_BLEND_ZERO                            (0x00000001)
#define NV0048_CONTROL0_SRC_BLEND                                         31:31
#define NV0048_CONTROL0_SRC_BLEND_BETA                             (0x00000000)
#define NV0048_CONTROL0_SRC_BLEND_ZERO                             (0x00000001)
#define NV0048_CONTROL1                                            (0x00000318)
#define NV0048_CONTROL1_ALPHAREF                                            7:0
#define NV0048_CONTROL1_ALPHAFUNC                                          31:8
#define NV0048_CONTROL1_ALPHAFUNC_NEVER                            (0x00000001)
#define NV0048_CONTROL1_ALPHAFUNC_LESS                             (0x00000002)
#define NV0048_CONTROL1_ALPHAFUNC_EQUAL                            (0x00000003)
#define NV0048_CONTROL1_ALPHAFUNC_LESSEQUAL                        (0x00000004)
#define NV0048_CONTROL1_ALPHAFUNC_GREATER                          (0x00000005)
#define NV0048_CONTROL1_ALPHAFUNC_NOTEQUAL                         (0x00000006)
#define NV0048_CONTROL1_ALPHAFUNC_GREATEREQUAL                     (0x00000007)
#define NV0048_CONTROL1_ALPHAFUNC_ALWAYS                           (0x00000008)
#define NV0048_TLVERTEX(a)                                         (0x00001000\
                                                                   +(a)*0x0020)
#define NV0048_TLVERTEX_SPECULAR(a)                                (0x00001000\
                                                                   +(a)*0x0020)
#define NV0048_TLVERTEX_SPECULAR_I0                                         3:0
#define NV0048_TLVERTEX_SPECULAR_I1                                         7:4
#define NV0048_TLVERTEX_SPECULAR_I2                                        11:8
#define NV0048_TLVERTEX_SPECULAR_I3                                       15:12
#define NV0048_TLVERTEX_SPECULAR_I4                                       19:16
#define NV0048_TLVERTEX_SPECULAR_I5                                       23:20
#define NV0048_TLVERTEX_SPECULAR_FOG                                      31:24
#define NV0048_TLVERTEX_COLOR(a)                                   (0x00001004\
                                                                   +(a)*0x0020)
#define NV0048_TLVERTEX_SX(a)                                      (0x00001008\
                                                                   +(a)*0x0020)
#define NV0048_TLVERTEX_SY(a)                                      (0x0000100C\
                                                                   +(a)*0x0020)
#define NV0048_TLVERTEX_SZ(a)                                      (0x00001010\
                                                                   +(a)*0x0020)
#define NV0048_TLVERTEX_RHW(a)                                     (0x00001014\
                                                                   +(a)*0x0020)
#define NV0048_TLVERTEX_TU(a)                                      (0x00001018\
                                                                   +(a)*0x0020)
#define NV0048_TLVERTEX_TV(a)                                      (0x0000101C\

/* class NV03_GDI_RECTANGLE_TEXT */
#define  NV03_GDI_RECTANGLE_TEXT                                   (0x0000004B)
#define NV004B_NOTIFIERS_NOTIFY                                             (0)
#define NV004B_NOTIFICATION_STATUS_DONE_SUCCESS                          (0x00)
#define NV004B_NOTIFICATION_STATUS_IN_PROGRESS                           (0xFF)
#define NV004B_ALLOC_STATUS_SUCCESS                                (0x00000000)
#define NV004B_ALLOC_STATUS_ERROR_INSUFFICIENT_RESOURCES           (0x00000002)
#define NV004B_ALLOC_STATUS_ERROR_BAD_OBJECT_NEW                   (0x00000003)
#define NV004B_ALLOC_STATUS_ERROR_BAD_OBJECT_PARENT                (0x00000004)
#define NV004B_TYPEDEF                                     nv03GdiRectangleText
/* method offsets, fields, and values */
#define NV004B_NO_OPERATION                                        (0x00000100)
#define NV004B_NOTIFY                                              (0x00000104)
#define NV004B_NOTIFY_WRITE_LE_NOTIFY                              (0x00000000)
#define NV004B_NOTIFY_WRITE_LE_NOTIFY_AWAKEN                       (0x00000001)
#define NV004B_NOTIFY_WRITE_LE_NOTIFY_AWAKEN_2                     (0x00000002)
#define NV004B_NOTIFY_WRITE_LE_NOTIFY_AWAKEN_3                     (0x00000003)
#define NV004B_NOTIFY_WRITE_LE_NOTIFY_AWAKEN_4                     (0x00000004)
#define NV004B_NOTIFY_WRITE_LE_NOTIFY_AWAKEN_5                     (0x00000005)
#define NV004B_NOTIFY_WRITE_LE_NOTIFY_AWAKEN_6                     (0x00000006)
#define NV004B_NOTIFY_WRITE_LE_NOTIFY_AWAKEN_7                     (0x00000007)
#define NV004B_NOTIFY_WRITE_LE_NOTIFY_AWAKEN_8                     (0x00000008)
#define NV004B_NOTIFY_WRITE_LE_NOTIFY_AWAKEN_9                     (0x00000009)
#define NV004B_NOTIFY_WRITE_LE_NOTIFY_AWAKEN_A                     (0x0000000A)
#define NV004B_NOTIFY_WRITE_LE_NOTIFY_AWAKEN_B                     (0x0000000B)
#define NV004B_NOTIFY_WRITE_LE_NOTIFY_AWAKEN_C                     (0x0000000C)
#define NV004B_NOTIFY_WRITE_LE_NOTIFY_AWAKEN_D                     (0x0000000D)
#define NV004B_NOTIFY_WRITE_LE_NOTIFY_AWAKEN_E                     (0x0000000E)
#define NV004B_NOTIFY_WRITE_LE_NOTIFY_AWAKEN_F                     (0x0000000F)
#define NV004B_SET_CONTEXT_DMA_NOTIFIES                            (0x00000180)
#define NV004B_SET_CONTEXT_PATTERN                                 (0x00000184)
#define NV004B_SET_CONTEXT_ROP                                     (0x00000188)
#define NV004B_SET_CONTEXT_BETA1                                   (0x0000018C)
#define NV004B_SET_CONTEXT_SURFACE                                 (0x00000190)
#define NV004B_SET_OPERATION                                       (0x000002FC)
#define NV004B_SET_OPERATION_SRCCOPY_AND                           (0x00000000)
#define NV004B_SET_OPERATION_ROP_AND                               (0x00000001)
#define NV004B_SET_OPERATION_BLEND_AND                             (0x00000002)
#define NV004B_SET_COLOR_FORMAT                                    (0x00000300)
#define NV004B_SET_COLOR_FORMAT_NE32_X24Y8                         (0x00000001)
#define NV004B_SET_COLOR_FORMAT_NE32_X17R5G5B5                     (0x00000002)
#define NV004B_SET_COLOR_FORMAT_NE32_X8R8G8B8                      (0x00000003)
#define NV004B_SET_MONOCHROME_FORMAT                               (0x00000304)
#define NV004B_SET_MONOCHROME_FORMAT_BEI1                          (0x00000001)
#define NV004B_SET_MONOCHROME_FORMAT_LEI1                          (0x00000002)
#define NV004B_COLOR1_A                                            (0x000003FC)
#define NV004B_UNCLIPPED_RECTANGLE(a)                              (0x00000400\
                                                                   +(a)*0x0008)
#define NV004B_UNCLIPPED_RECTANGLE_POINT(a)                        (0x00000400\
                                                                   +(a)*0x0008)
#define NV004B_UNCLIPPED_RECTANGLE_POINT_Y                                 15:0
#define NV004B_UNCLIPPED_RECTANGLE_POINT_X                                31:16
#define NV004B_UNCLIPPED_RECTANGLE_SIZE(a)                         (0x00000404\
                                                                   +(a)*0x0008)
#define NV004B_UNCLIPPED_RECTANGLE_SIZE_HEIGHT                             15:0
#define NV004B_UNCLIPPED_RECTANGLE_SIZE_WIDTH                             31:16
#define NV004B_CLIP_POINT0_B                                       (0x000007F4)
#define NV004B_CLIP_POINT0_B_LEFT                                          15:0
#define NV004B_CLIP_POINT0_B_TOP                                          31:16
#define NV004B_CLIP_POINT1_B                                       (0x000007F8)
#define NV004B_CLIP_POINT1_B_RIGHT                                         15:0
#define NV004B_CLIP_POINT1_B_BOTTOM                                       31:16
#define NV004B_COLOR1_B                                            (0x000007FC)
#define NV004B_CLIPPED_RECTANGLE(a)                                (0x00000800\
                                                                   +(a)*0x0008)
#define NV004B_CLIPPED_RECTANGLE_POINT0(a)                         (0x00000800\
                                                                   +(a)*0x0008)
#define NV004B_CLIPPED_RECTANGLE_POINT0_LEFT                               15:0
#define NV004B_CLIPPED_RECTANGLE_POINT0_TOP                               31:16
#define NV004B_CLIPPED_RECTANGLE_POINT1(a)                         (0x00000804\
                                                                   +(a)*0x0008)
#define NV004B_CLIPPED_RECTANGLE_POINT1_RIGHT                              15:0
#define NV004B_CLIPPED_RECTANGLE_POINT1_BOTTOM                            31:16
#define NV004B_CLIP_POINT0_C                                       (0x00000BEC)
#define NV004B_CLIP_POINT0_C_LEFT                                          15:0
#define NV004B_CLIP_POINT0_C_TOP                                          31:16
#define NV004B_CLIP_POINT1_C                                       (0x00000BF0)
#define NV004B_CLIP_POINT1_C_RIGHT                                         15:0
#define NV004B_CLIP_POINT1_C_BOTTOM                                       31:16
#define NV004B_COLOR1_C                                            (0x00000BF4)
#define NV004B_SIZE_C                                              (0x00000BF8)
#define NV004B_SIZE_C_WIDTH                                                15:0
#define NV004B_SIZE_C_HEIGHT                                              31:16
#define NV004B_POINT_C                                             (0x00000BFC)
#define NV004B_POINT_C_X                                                   15:0
#define NV004B_POINT_C_Y                                                  31:16
#define NV004B_MONOCHROME_COLOR1_C(a)                              (0x00000C00\
                                                                   +(a)*0x0004)
#define NV004B_CLIP_POINT0_D                                       (0x00000FE8)
#define NV004B_CLIP_POINT0_D_LEFT                                          15:0
#define NV004B_CLIP_POINT0_D_TOP                                          31:16
#define NV004B_CLIP_POINT1_D                                       (0x00000FEC)
#define NV004B_CLIP_POINT1_D_RIGHT                                         15:0
#define NV004B_CLIP_POINT1_D_BOTTOM                                       31:16
#define NV004B_COLOR1_D                                            (0x00000FF0)
#define NV004B_SIZE_IN_D                                           (0x00000FF4)
#define NV004B_SIZE_IN_D_WIDTH                                             15:0
#define NV004B_SIZE_IN_D_HEIGHT                                           31:16
#define NV004B_SIZE_OUT_D                                          (0x00000FF8)
#define NV004B_SIZE_OUT_D_WIDTH                                            15:0
#define NV004B_SIZE_OUT_D_HEIGHT                                          31:16
#define NV004B_POINT_D                                             (0x00000FFC)
#define NV004B_POINT_D_X                                                   15:0
#define NV004B_POINT_D_Y                                                  31:16
#define NV004B_MONOCHROME_COLOR1_D(a)                              (0x00001000\
                                                                   +(a)*0x0004)
#define NV004B_CLIP_POINT0_E                                       (0x000013E4)
#define NV004B_CLIP_POINT0_E_LEFT                                          15:0
#define NV004B_CLIP_POINT0_E_TOP                                          31:16
#define NV004B_CLIP_POINT1_E                                       (0x000013E8)
#define NV004B_CLIP_POINT1_E_RIGHT                                         15:0
#define NV004B_CLIP_POINT1_E_BOTTOM                                       31:16
#define NV004B_COLOR0_E                                            (0x000013EC)
#define NV004B_COLOR1_E                                            (0x000013F0)
#define NV004B_SIZE_IN_E                                           (0x000013F4)
#define NV004B_SIZE_IN_E_WIDTH                                             15:0
#define NV004B_SIZE_IN_E_HEIGHT                                           31:16
#define NV004B_SIZE_OUT_E                                          (0x000013F8)
#define NV004B_SIZE_OUT_E_WIDTH                                            15:0
#define NV004B_SIZE_OUT_E_HEIGHT                                          31:16
#define NV004B_POINT_E                                             (0x000013FC)
#define NV004B_POINT_E_X                                                   15:0
#define NV004B_POINT_E_Y                                                  31:16
#define NV004B_MONOCHROME_COLOR01_E(a)                             (0x00001400\
                                                                   +(a)*0x0004)
/* class NV04_CONTEXT_SURFACES_3D */
#define  NV04_CONTEXT_SURFACES_3D                                  (0x00000053)
#define NV0053_NOTIFIERS_NOTIFY                                             (0)
#define NV0053_NOTIFICATION_STATUS_DONE_SUCCESS                          (0x00)
#define NV0053_NOTIFICATION_STATUS_IN_PROGRESS                           (0xFF)
#define NV0053_ALLOC_STATUS_SUCCESS                                (0x00000000)
#define NV0053_ALLOC_STATUS_ERROR_INSUFFICIENT_RESOURCES           (0x00000002)
#define NV0053_ALLOC_STATUS_ERROR_BAD_OBJECT_NEW                   (0x00000003)
#define NV0053_ALLOC_STATUS_ERROR_BAD_OBJECT_PARENT                (0x00000004)
#define NV0053_FREE_STATUS_SUCCESS                                 (0x00000000)
#define NV0053_FREE_STATUS_ERROR_OBJECT_IN_USE                     (0x00000002)
#define NV0053_CONTROL_STATUS_SUCCESS                              (0x00000000)
#define NV0053_TYPEDEF                                    nv04ContextSurfaces3d
/* method offsets, fields, and values */
#define NV0053_NO_OPERATION                                        (0x00000100)
#define NV0053_NOTIFY                                              (0x00000104)
#define NV0053_NOTIFY_WRITE_LE_NOTIFY                              (0x00000000)
#define NV0053_NOTIFY_WRITE_LE_NOTIFY_AWAKEN                       (0x00000001)
#define NV0053_SET_CONTEXT_DMA_NOTIFIES                            (0x00000180)
#define NV0053_SET_CONTEXT_DMA_COLOR                               (0x00000184)
#define NV0053_SET_CONTEXT_DMA_ZETA                                (0x00000188)
#define NV0053_SET_CLIP_HORIZONTAL                                 (0x000002F8)
#define NV0053_SET_CLIP_HORIZONTAL_X                                       15:0
#define NV0053_SET_CLIP_HORIZONTAL_WIDTH                                  31:16
#define NV0053_SET_CLIP_VERTICAL                                   (0x000002FC)
#define NV0053_SET_CLIP_VERTICAL_Y                                         15:0
#define NV0053_SET_CLIP_VERTICAL_HEIGHT                                   31:16
#define NV0053_SET_FORMAT                                          (0x00000300)
#define NV0053_SET_FORMAT_COLOR                                             7:0
#define NV0053_SET_FORMAT_COLOR_X1R5G5B5_Z1R5G5B5                  (0x00000001)
#define NV0053_SET_FORMAT_COLOR_X1R5G5B5_O1R5G5B5                  (0x00000002)
#define NV0053_SET_FORMAT_COLOR_R5G6B5                             (0x00000003)
#define NV0053_SET_FORMAT_COLOR_X8R8G8B8_Z8R8G8B8                  (0x00000004)
#define NV0053_SET_FORMAT_COLOR_X8R8G8B8_O8R8G8B8                  (0x00000005)
#define NV0053_SET_FORMAT_COLOR_X1A7R8G8B8_Z1A7R8G8B8              (0x00000006)
#define NV0053_SET_FORMAT_COLOR_X1A7R8G8B8_O1A7R8G8B8              (0x00000007)
#define NV0053_SET_FORMAT_COLOR_A8R8G8B8                           (0x00000008)
#define NV0053_SET_FORMAT_TYPE                                             15:8
#define NV0053_SET_FORMAT_TYPE_PITCH                               (0x00000001)
#define NV0053_SET_FORMAT_TYPE_SWIZZLE                             (0x00000002)
#define NV0053_SET_FORMAT_WIDTH                                           23:16
#define NV0053_SET_FORMAT_HEIGHT                                          31:24
#define NV0053_SET_CLIP_SIZE                                       (0x00000304)
#define NV0053_SET_CLIP_SIZE_WIDTH                                         15:0
#define NV0053_SET_CLIP_SIZE_HEIGHT                                       31:16
#define NV0053_SET_PITCH                                           (0x00000308)
#define NV0053_SET_PITCH_COLOR                                             15:0
#define NV0053_SET_PITCH_ZETA                                             31:16
#define NV0053_SET_OFFSET_COLOR                                    (0x0000030C)
#define NV0053_SET_OFFSET_ZETA                                     (0x00000310)


/* class NV04_DX5_TEXTURED_TRIANGLE */
#define  NV04_DX5_TEXTURED_TRIANGLE                                (0x00000054)
#define NV0054_NOTIFIERS_NOTIFY                                             (0)
#define NV0054_NOTIFICATION_STATUS_DONE_SUCCESS                          (0x00)
#define NV0054_NOTIFICATION_STATUS_IN_PROGRESS                           (0xFF)
#define NV0054_ALLOC_STATUS_SUCCESS                                (0x00000000)
#define NV0054_ALLOC_STATUS_ERROR_INSUFFICIENT_RESOURCES           (0x00000002)
#define NV0054_ALLOC_STATUS_ERROR_BAD_OBJECT_NEW                   (0x00000003)
#define NV0054_ALLOC_STATUS_ERROR_BAD_OBJECT_PARENT                (0x00000004)
#define NV0054_FREE_STATUS_SUCCESS                                 (0x00000000)
#define NV0054_FREE_STATUS_ERROR_OBJECT_IN_USE                     (0x00000002)
#define NV0054_TYPEDEF                                  nv04Dx5TexturedTriangle
/* method offsets, fields, and values */
#define NV0054_NO_OPERATION                                        (0x00000100)
#define NV0054_NOTIFY                                              (0x00000104)
#define NV0054_NOTIFY_WRITE_LE_NOTIFY                              (0x00000000)
#define NV0054_NOTIFY_WRITE_LE_NOTIFY_AWAKEN                       (0x00000001)
#define NV0054_SET_CONTEXT_DMA_NOTIFIES                            (0x00000180)
#define NV0054_SET_CONTEXT_DMA_A                                   (0x00000184)
#define NV0054_SET_CONTEXT_DMA_B                                   (0x00000188)
#define NV0054_SET_CONTEXT_SURFACES                                (0x0000018C)
#define NV0054_COLOR_KEY_VALUE                                     (0x00000300)
#define NV0054_TEXTURE_OFFSET                                      (0x00000304)
#define NV0054_TEXTURE_FORMAT                                      (0x00000308)
#define NV0054_TEXTURE_FORMAT_CONTEXT_DMA                                   1:0
#define NV0054_TEXTURE_FORMAT_CONTEXT_DMA_A                        (0x00000001)
#define NV0054_TEXTURE_FORMAT_CONTEXT_DMA_B                        (0x00000002)
#define NV0054_TEXTURE_FORMAT_COLOR_KEY_MATCH                               3:2
#define NV0054_TEXTURE_FORMAT_COLOR_KEY_MATCH_SRCCOPY              (0x00000000)
#define NV0054_TEXTURE_FORMAT_COLOR_KEY_MATCH_ZERO_ALPHA           (0x00000001)
#define NV0054_TEXTURE_FORMAT_ORIGIN_ZOH                                    5:4
#define NV0054_TEXTURE_FORMAT_ORIGIN_ZOH_CENTER                    (0x00000001)
#define NV0054_TEXTURE_FORMAT_ORIGIN_ZOH_CORNER                    (0x00000002)
#define NV0054_TEXTURE_FORMAT_ORIGIN_FOH                                    7:6
#define NV0054_TEXTURE_FORMAT_ORIGIN_FOH_CENTER                    (0x00000001)
#define NV0054_TEXTURE_FORMAT_ORIGIN_FOH_CORNER                    (0x00000002)
#define NV0054_TEXTURE_FORMAT_COLOR                                        11:8
#define NV0054_TEXTURE_FORMAT_COLOR_NE_Y8                          (0x00000001)
#define NV0054_TEXTURE_FORMAT_COLOR_LE_A1R5G5B5                    (0x00000002)
#define NV0054_TEXTURE_FORMAT_COLOR_LE_X1R5G5B5                    (0x00000003)
#define NV0054_TEXTURE_FORMAT_COLOR_LE_A4R4G4B4                    (0x00000004)
#define NV0054_TEXTURE_FORMAT_COLOR_LE_R5G6B5                      (0x00000005)
#define NV0054_TEXTURE_FORMAT_COLOR_LE_A8R8G8B8                    (0x00000006)
#define NV0054_TEXTURE_FORMAT_COLOR_LE_X8R8G8B8                    (0x00000007)
#define NV0054_TEXTURE_FORMAT_MIPMAP_LEVELS                               15:12
#define NV0054_TEXTURE_FORMAT_BASE_SIZE_U                                 19:16
#define NV0054_TEXTURE_FORMAT_BASE_SIZE_U_1                        (0x00000000)
#define NV0054_TEXTURE_FORMAT_BASE_SIZE_U_2                        (0x00000001)
#define NV0054_TEXTURE_FORMAT_BASE_SIZE_U_4                        (0x00000002)
#define NV0054_TEXTURE_FORMAT_BASE_SIZE_U_8                        (0x00000003)
#define NV0054_TEXTURE_FORMAT_BASE_SIZE_U_16                       (0x00000004)
#define NV0054_TEXTURE_FORMAT_BASE_SIZE_U_32                       (0x00000005)
#define NV0054_TEXTURE_FORMAT_BASE_SIZE_U_64                       (0x00000006)
#define NV0054_TEXTURE_FORMAT_BASE_SIZE_U_128                      (0x00000007)
#define NV0054_TEXTURE_FORMAT_BASE_SIZE_U_256                      (0x00000008)
#define NV0054_TEXTURE_FORMAT_BASE_SIZE_U_512                      (0x00000009)
#define NV0054_TEXTURE_FORMAT_BASE_SIZE_U_1024                     (0x0000000A)
#define NV0054_TEXTURE_FORMAT_BASE_SIZE_U_2048                     (0x0000000B)
#define NV0054_TEXTURE_FORMAT_BASE_SIZE_V                                 23:20
#define NV0054_TEXTURE_FORMAT_BASE_SIZE_V_1                        (0x00000000)
#define NV0054_TEXTURE_FORMAT_BASE_SIZE_V_2                        (0x00000001)
#define NV0054_TEXTURE_FORMAT_BASE_SIZE_V_4                        (0x00000002)
#define NV0054_TEXTURE_FORMAT_BASE_SIZE_V_8                        (0x00000003)
#define NV0054_TEXTURE_FORMAT_BASE_SIZE_V_16                       (0x00000004)
#define NV0054_TEXTURE_FORMAT_BASE_SIZE_V_32                       (0x00000005)
#define NV0054_TEXTURE_FORMAT_BASE_SIZE_V_64                       (0x00000006)
#define NV0054_TEXTURE_FORMAT_BASE_SIZE_V_128                      (0x00000007)
#define NV0054_TEXTURE_FORMAT_BASE_SIZE_V_256                      (0x00000008)
#define NV0054_TEXTURE_FORMAT_BASE_SIZE_V_512                      (0x00000009)
#define NV0054_TEXTURE_FORMAT_BASE_SIZE_V_1024                     (0x0000000A)
#define NV0054_TEXTURE_FORMAT_BASE_SIZE_V_2048                     (0x0000000B)
#define NV0054_TEXTURE_FORMAT_TEXTUREADDRESSU                             26:24
#define NV0054_TEXTURE_FORMAT_TEXTUREADDRESSU_WRAP                 (0x00000001)
#define NV0054_TEXTURE_FORMAT_TEXTUREADDRESSU_MIRROR               (0x00000002)
#define NV0054_TEXTURE_FORMAT_TEXTUREADDRESSU_CLAMP                (0x00000003)
#define NV0054_TEXTURE_FORMAT_TEXTUREADDRESSU_CLAMP_4              (0x00000004)
#define NV0054_TEXTURE_FORMAT_WRAPU                                       27:27
#define NV0054_TEXTURE_FORMAT_WRAPU_FALSE                          (0x00000000)
#define NV0054_TEXTURE_FORMAT_WRAPU_TRUE                           (0x00000001)
#define NV0054_TEXTURE_FORMAT_TEXTUREADDRESSV                             30:28
#define NV0054_TEXTURE_FORMAT_TEXTUREADDRESSV_WRAP                 (0x00000001)
#define NV0054_TEXTURE_FORMAT_TEXTUREADDRESSV_MIRROR               (0x00000002)
#define NV0054_TEXTURE_FORMAT_TEXTUREADDRESSV_CLAMP                (0x00000003)
#define NV0054_TEXTURE_FORMAT_TEXTUREADDRESSV_CLAMP_4              (0x00000004)
#define NV0054_TEXTURE_FORMAT_WRAPV                                       31:31
#define NV0054_TEXTURE_FORMAT_WRAPV_FALSE                          (0x00000000)
#define NV0054_TEXTURE_FORMAT_WRAPV_TRUE                           (0x00000001)
#define NV0054_TEXTURE_FILTER                                      (0x0000030C)
#define NV0054_TEXTURE_FILTER_KERNEL_SIZE_X                                 7:0
#define NV0054_TEXTURE_FILTER_KERNEL_SIZE_Y                                14:8
#define NV0054_TEXTURE_FILTER_MIPMAP_DITHER_ENABLE                        15:15
#define NV0054_TEXTURE_FILTER_MIPMAP_DITHER_ENABLE_FALSE           (0x00000000)
#define NV0054_TEXTURE_FILTER_MIPMAP_DITHER_ENABLE_TRUE            (0x00000001)
#define NV0054_TEXTURE_FILTER_MIPMAPLODBIAS                               23:16
#define NV0054_TEXTURE_FILTER_TEXTUREMIN                                  26:24
#define NV0054_TEXTURE_FILTER_TEXTUREMIN_NEAREST                   (0x00000001)
#define NV0054_TEXTURE_FILTER_TEXTUREMIN_LINEAR                    (0x00000002)
#define NV0054_TEXTURE_FILTER_TEXTUREMIN_MIPNEAREST                (0x00000003)
#define NV0054_TEXTURE_FILTER_TEXTUREMIN_MIPLINEAR                 (0x00000004)
#define NV0054_TEXTURE_FILTER_TEXTUREMIN_LINEARMIPNEAREST          (0x00000005)
#define NV0054_TEXTURE_FILTER_TEXTUREMIN_LINEARMIPLINEAR           (0x00000006)
#define NV0054_TEXTURE_FILTER_ANISOTROPIC_MINIFY_ENABLE                   27:27
#define NV0054_TEXTURE_FILTER_ANISOTROPIC_MINIFY_ENABLE_FALSE      (0x00000000)
#define NV0054_TEXTURE_FILTER_ANISOTROPIC_MINIFY_ENABLE_TRUE       (0x00000001)
#define NV0054_TEXTURE_FILTER_TEXTUREMAG                                  30:28
#define NV0054_TEXTURE_FILTER_TEXTUREMAG_NEAREST                   (0x00000001)
#define NV0054_TEXTURE_FILTER_TEXTUREMAG_LINEAR                    (0x00000002)
#define NV0054_TEXTURE_FILTER_TEXTUREMAG_NEAREST_3                 (0x00000003)
#define NV0054_TEXTURE_FILTER_TEXTUREMAG_LINEAR_4                  (0x00000004)
#define NV0054_TEXTURE_FILTER_TEXTUREMAG_NEAREST_5                 (0x00000005)
#define NV0054_TEXTURE_FILTER_TEXTUREMAG_LINEAR_6                  (0x00000006)
#define NV0054_TEXTURE_FILTER_TEXTUREMAG_MIPNEAREST                (0x00000003)
#define NV0054_TEXTURE_FILTER_TEXTUREMAG_MIPLINEAR                 (0x00000004)
#define NV0054_TEXTURE_FILTER_TEXTUREMAG_LINEARMIPNEAREST          (0x00000005)
#define NV0054_TEXTURE_FILTER_TEXTUREMAG_LINEARMIPLINEAR           (0x00000006)
#define NV0054_TEXTURE_FILTER_ANISOTROPIC_MAGNIFY_ENABLE                  31:31
#define NV0054_TEXTURE_FILTER_ANISOTROPIC_MAGNIFY_ENABLE_FALSE     (0x00000000)
#define NV0054_TEXTURE_FILTER_ANISOTROPIC_MAGNIFY_ENABLE_TRUE      (0x00000001)
#define NV0054_BLEND                                               (0x00000310)
#define NV0054_BLEND_TEXTUREMAPBLEND                                        3:0
#define NV0054_BLEND_TEXTUREMAPBLEND_DECAL                         (0x00000001)
#define NV0054_BLEND_TEXTUREMAPBLEND_MODULATE                      (0x00000002)
#define NV0054_BLEND_TEXTUREMAPBLEND_DECALALPHA                    (0x00000003)
#define NV0054_BLEND_TEXTUREMAPBLEND_MODULATEALPHA                 (0x00000004)
#define NV0054_BLEND_TEXTUREMAPBLEND_DECALMASK                     (0x00000005)
#define NV0054_BLEND_TEXTUREMAPBLEND_MODULATEMASK                  (0x00000006)
#define NV0054_BLEND_TEXTUREMAPBLEND_COPY                          (0x00000007)
#define NV0054_BLEND_TEXTUREMAPBLEND_ADD                           (0x00000008)
#define NV0054_BLEND_MASK_BIT                                               5:4
#define NV0054_BLEND_MASK_BIT_LSB                                  (0x00000001)
#define NV0054_BLEND_MASK_BIT_MSB                                  (0x00000002)
#define NV0054_BLEND_SHADEMODE                                              7:6
#define NV0054_BLEND_SHADEMODE_FLAT                                (0x00000001)
#define NV0054_BLEND_SHADEMODE_GOURAUD                             (0x00000002)
#define NV0054_BLEND_SHADEMODE_GOURAUD_3                           (0x00000003)
#define NV0054_BLEND_TEXTUREPERSPECTIVE                                    11:8
#define NV0054_BLEND_TEXTUREPERSPECTIVE_FALSE                      (0x00000000)
#define NV0054_BLEND_TEXTUREPERSPECTIVE_TRUE                       (0x00000001)
#define NV0054_BLEND_SPECULARENABLE                                       15:12
#define NV0054_BLEND_SPECULARENABLE_FALSE                          (0x00000000)
#define NV0054_BLEND_SPECULARENABLE_TRUE                           (0x00000001)
#define NV0054_BLEND_FOGENABLE                                            19:16
#define NV0054_BLEND_FOGENABLE_FALSE                               (0x00000000)
#define NV0054_BLEND_FOGENABLE_TRUE                                (0x00000001)
#define NV0054_BLEND_ALPHABLENDENABLE                                     23:20
#define NV0054_BLEND_ALPHABLENDENABLE_FALSE                        (0x00000000)
#define NV0054_BLEND_ALPHABLENDENABLE_TRUE                         (0x00000001)
#define NV0054_BLEND_SRCBLEND                                             27:24
#define NV0054_BLEND_SRCBLEND_ZERO                                 (0x00000001)
#define NV0054_BLEND_SRCBLEND_ONE                                  (0x00000002)
#define NV0054_BLEND_SRCBLEND_SRCCOLOR                             (0x00000003)
#define NV0054_BLEND_SRCBLEND_INVSRCCOLOR                          (0x00000004)
#define NV0054_BLEND_SRCBLEND_SRCALPHA                             (0x00000005)
#define NV0054_BLEND_SRCBLEND_INVSRCALPHA                          (0x00000006)
#define NV0054_BLEND_SRCBLEND_DESTALPHA                            (0x00000007)
#define NV0054_BLEND_SRCBLEND_INVDESTALPHA                         (0x00000008)
#define NV0054_BLEND_SRCBLEND_DESTCOLOR                            (0x00000009)
#define NV0054_BLEND_SRCBLEND_INVDESTCOLOR                         (0x0000000A)
#define NV0054_BLEND_SRCBLEND_SRCALPHASAT                          (0x0000000B)
#define NV0054_BLEND_DESTBLEND                                            31:28
#define NV0054_BLEND_DESTBLEND_ZERO                                (0x00000001)
#define NV0054_BLEND_DESTBLEND_ONE                                 (0x00000002)
#define NV0054_BLEND_DESTBLEND_SRCCOLOR                            (0x00000003)
#define NV0054_BLEND_DESTBLEND_INVSRCCOLOR                         (0x00000004)
#define NV0054_BLEND_DESTBLEND_SRCALPHA                            (0x00000005)
#define NV0054_BLEND_DESTBLEND_INVSRCALPHA                         (0x00000006)
#define NV0054_BLEND_DESTBLEND_DESTALPHA                           (0x00000007)
#define NV0054_BLEND_DESTBLEND_INVDESTALPHA                        (0x00000008)
#define NV0054_BLEND_DESTBLEND_DESTCOLOR                           (0x00000009)
#define NV0054_BLEND_DESTBLEND_INVDESTCOLOR                        (0x0000000A)
#define NV0054_BLEND_DESTBLEND_SRCALPHASAT                         (0x0000000B)
#define NV0054_CONTROL                                             (0x00000314)
#define NV0054_CONTROL_ALPHAREF                                             7:0
#define NV0054_CONTROL_ALPHAFUNC                                           11:8
#define NV0054_CONTROL_ALPHAFUNC_NEVER                             (0x00000001)
#define NV0054_CONTROL_ALPHAFUNC_LESS                              (0x00000002)
#define NV0054_CONTROL_ALPHAFUNC_EQUAL                             (0x00000003)
#define NV0054_CONTROL_ALPHAFUNC_LESSEQUAL                         (0x00000004)
#define NV0054_CONTROL_ALPHAFUNC_GREATER                           (0x00000005)
#define NV0054_CONTROL_ALPHAFUNC_NOTEQUAL                          (0x00000006)
#define NV0054_CONTROL_ALPHAFUNC_GREATEREQUAL                      (0x00000007)
#define NV0054_CONTROL_ALPHAFUNC_ALWAYS                            (0x00000008)
#define NV0054_CONTROL_ALPHATESTENABLE                                    12:12
#define NV0054_CONTROL_ALPHATESTENABLE_FALSE                       (0x00000000)
#define NV0054_CONTROL_ALPHATESTENABLE_TRUE                        (0x00000001)
#define NV0054_CONTROL_ORIGIN                                             13:13
#define NV0054_CONTROL_ORIGIN_CENTER                               (0x00000000)
#define NV0054_CONTROL_ORIGIN_CORNER                               (0x00000001)
#define NV0054_CONTROL_ZENABLE                                            15:14
#define NV0054_CONTROL_ZENABLE_FALSE                               (0x00000000)
#define NV0054_CONTROL_ZENABLE_TRUE                                (0x00000001)
#define NV0054_CONTROL_ZFUNC                                              19:16
#define NV0054_CONTROL_ZFUNC_NEVER                                 (0x00000001)
#define NV0054_CONTROL_ZFUNC_LESS                                  (0x00000002)
#define NV0054_CONTROL_ZFUNC_EQUAL                                 (0x00000003)
#define NV0054_CONTROL_ZFUNC_LESSEQUAL                             (0x00000004)
#define NV0054_CONTROL_ZFUNC_GREATER                               (0x00000005)
#define NV0054_CONTROL_ZFUNC_NOTEQUAL                              (0x00000006)
#define NV0054_CONTROL_ZFUNC_GREATEREQUAL                          (0x00000007)
#define NV0054_CONTROL_ZFUNC_ALWAYS                                (0x00000008)
#define NV0054_CONTROL_CULLMODE                                           21:20
#define NV0054_CONTROL_CULLMODE_NONE                               (0x00000001)
#define NV0054_CONTROL_CULLMODE_CW                                 (0x00000002)
#define NV0054_CONTROL_CULLMODE_CCW                                (0x00000003)
#define NV0054_CONTROL_DITHERENABLE                                       22:22
#define NV0054_CONTROL_DITHERENABLE_FALSE                          (0x00000000)
#define NV0054_CONTROL_DITHERENABLE_TRUE                           (0x00000001)
#define NV0054_CONTROL_Z_PERSPECTIVE_ENABLE                               23:23
#define NV0054_CONTROL_Z_PERSPECTIVE_ENABLE_FALSE                  (0x00000000)
#define NV0054_CONTROL_Z_PERSPECTIVE_ENABLE_TRUE                   (0x00000001)
#define NV0054_CONTROL_ZWRITEENABLE                                       29:24
#define NV0054_CONTROL_ZWRITEENABLE_FALSE                          (0x00000000)
#define NV0054_CONTROL_ZWRITEENABLE_TRUE                           (0x00000001)
#define NV0054_CONTROL_Z_FORMAT                                           31:30
#define NV0054_CONTROL_Z_FORMAT_FIXED                              (0x00000001)
#define NV0054_CONTROL_Z_FORMAT_FLOAT                              (0x00000002)
#define NV0054_FOG_COLOR                                           (0x00000318)
#define NV0054_TLVERTEX(i)                                         (0x00000400\
                                                                   +(i)*0x0020)
#define NV0054_TLVERTEX_SX(i)                                      (0x00000400\
                                                                   +(i)*0x0020)
#define NV0054_TLVERTEX_SY(i)                                      (0x00000404\
                                                                   +(i)*0x0020)
#define NV0054_TLVERTEX_SZ(i)                                      (0x00000408\
                                                                   +(i)*0x0020)
#define NV0054_TLVERTEX_RHW(i)                                     (0x0000040C\
                                                                   +(i)*0x0020)
#define NV0054_TLVERTEX_COLOR(i)                                   (0x00000410\
                                                                   +(i)*0x0020)
#define NV0054_TLVERTEX_SPECULAR(i)                                (0x00000414\
                                                                   +(i)*0x0020)
#define NV0054_TLVERTEX_SPECULAR_BLUE                                       7:0
#define NV0054_TLVERTEX_SPECULAR_GREEN                                     15:8
#define NV0054_TLVERTEX_SPECULAR_RED                                      23:16
#define NV0054_TLVERTEX_SPECULAR_FOG                                      31:24
#define NV0054_TLVERTEX_TU(i)                                      (0x00000418\
                                                                   +(i)*0x0020)
#define NV0054_TLVERTEX_TV(i)                                      (0x0000041C\
                                                                   +(i)*0x0020)
#define NV0054_DRAW_PRIMITIVE(a)                                   (0x00000600\
                                                                   +(a)*0x0004)
#define NV0054_DRAW_PRIMITIVE_I0                                            3:0
#define NV0054_DRAW_PRIMITIVE_I1                                            7:4
#define NV0054_DRAW_PRIMITIVE_I2                                           11:8
#define NV0054_DRAW_PRIMITIVE_I3                                          15:12
#define NV0054_DRAW_PRIMITIVE_I4                                          19:16
#define NV0054_DRAW_PRIMITIVE_I5                                          31:20

/* class NV03_CONTEXT_SURFACES_2D */
#define  NV03_CONTEXT_SURFACES_2D                                  (0x00000058)
#define NV0058_NOTIFIERS_SYNCHRONIZE                                        (0)
#define NV0058_NOTIFICATION_STATUS_DONE_SUCCESS                          (0x00)
#define NV0058_NOTIFICATION_STATUS_IN_PROGRESS                           (0xFF)
#define NV0058_ALLOC_STATUS_SUCCESS                                (0x00000000)
#define NV0058_ALLOC_STATUS_ERROR_INSUFFICIENT_RESOURCES           (0x00000002)
#define NV0058_ALLOC_STATUS_ERROR_BAD_OBJECT_NEW                   (0x00000003)
#define NV0058_ALLOC_STATUS_ERROR_BAD_OBJECT_PARENT                (0x00000004)
#define NV0058_FREE_STATUS_SUCCESS                                 (0x00000000)
#define NV0058_FREE_STATUS_ERROR_OBJECT_IN_USE                     (0x00000002)
#define NV0058_CONTROL_STATUS_SUCCESS                              (0x00000000)
#define NV0058_TYPEDEF                                    nv03ContextSurfaces2d
/* method offsets, fields, and values */
#define NV0058_SYNCHRONIZE                                         (0x00000100)
#define NV0058_SYNCHRONIZE_NO_OPERATION                            (0x00000000)
#define NV0058_SYNCHRONIZE_WAIT_FOR_IDLE                           (0x00000001)
#define NV0058_SYNCHRONIZE_WAIT_FOR_IDLE_WRITE_LE_NOTIFY           (0x00000002)
#define NV0058_SYNCHRONIZE_WAIT_FOR_IDLE_WRITE_LE_NOTIFY_AWAKEN    (0x00000003)
#define NV0058_SET_CONTEXT_DMA_NOTIFIES                            (0x00000180)
#define NV0058_SET_CONTEXT_DMA_SOURCE                              (0x00000184)
#define NV0058_SET_CONTEXT_DMA_DESTIN                              (0x00000188)
#define NV0058_SET_FORMAT                                          (0x00000300)
#define NV0058_SET_FORMAT_COLOR                                            28:0
#define NV0058_SET_FORMAT_COLOR_Y8                                 (0x00000001)
#define NV0058_SET_FORMAT_COLOR_X1R5G5B5_Z1R5G5B5                  (0x00000002)
#define NV0058_SET_FORMAT_COLOR_Y16                                (0x00000005)
#define NV0058_SET_FORMAT_COLOR_X8R8G8B8_Z8R8G8B8                  (0x00000006)
#define NV0058_SET_PITCH                                           (0x00000304)
#define NV0058_SET_PITCH_SOURCE                                            15:0
#define NV0058_SET_PITCH_DESTIN                                           31:16
#define NV0058_SET_OFFSET_SOURCE                                   (0x00000308)
#define NV0058_SET_OFFSET_DESTIN                                   (0x0000030C)


/* class NV03_CONTEXT_SURFACES_3D */
#define  NV03_CONTEXT_SURFACES_3D                                  (0x0000005A)
#define NV005A_NOTIFIERS_SYNCHRONIZE                                        (0)
#define NV005A_NOTIFICATION_STATUS_DONE_SUCCESS                          (0x00)
#define NV005A_NOTIFICATION_STATUS_IN_PROGRESS                           (0xFF)
#define NV005A_ALLOC_STATUS_SUCCESS                                (0x00000000)
#define NV005A_ALLOC_STATUS_ERROR_INSUFFICIENT_RESOURCES           (0x00000002)
#define NV005A_ALLOC_STATUS_ERROR_BAD_OBJECT_NEW                   (0x00000003)
#define NV005A_ALLOC_STATUS_ERROR_BAD_OBJECT_PARENT                (0x00000004)
#define NV005A_FREE_STATUS_SUCCESS                                 (0x00000000)
#define NV005A_FREE_STATUS_ERROR_OBJECT_IN_USE                     (0x00000002)
#define NV005A_CONTROL_STATUS_SUCCESS                              (0x00000000)
#define NV005A_TYPEDEF                                    nv03ContextSurfaces3d
/* method offsets, fields, and values */
#define NV005A_SYNCHRONIZE                                         (0x00000100)
#define NV005A_SYNCHRONIZE_NO_OPERATION                            (0x00000000)
#define NV005A_SYNCHRONIZE_WAIT_FOR_IDLE                           (0x00000001)
#define NV005A_SYNCHRONIZE_WAIT_FOR_IDLE_WRITE_LE_NOTIFY           (0x00000002)
#define NV005A_SYNCHRONIZE_WAIT_FOR_IDLE_WRITE_LE_NOTIFY_AWAKEN    (0x00000003)
#define NV005A_SET_CONTEXT_DMA_NOTIFIES                            (0x00000180)
#define NV005A_SET_CONTEXT_DMA_SURFACES                            (0x00000184)
#define NV005A_SET_PITCH                                           (0x00000300)
#define NV005A_SET_OFFSET_COLOR                                    (0x00000304)
#define NV005A_SET_OFFSET_ZETA                                     (0x00000308)

#define NV03_CHANNEL_DMA                                           (0x0000006B)
#define NV006B_ALLOC_STATUS_SUCCESS                                (0x00000000)
#define NV006B_ALLOC_STATUS_ERROR_INSUFFICIENT_RESOURCES           (0x00000002)
#define NV006B_ALLOC_STATUS_ERROR_BAD_OBJECT_NEW                   (0x00000003)
#define NV006B_ALLOC_STATUS_ERROR_BAD_OBJECT_PARENT                (0x00000004)
#define NV006B_ALLOC_STATUS_ERROR_BAD_OBJECT_BUFFER                (0x00000005)
#define NV006B_ALLOC_STATUS_ERROR_BAD_OFFSET                       (0x00000006)
#define NV006B_FREE_STATUS_SUCCESS                                 (0x00000000)
#define NV006B_FREE_STATUS_ERROR_OBJECT_IN_USE                     (0x00000002)
#define NV006B_CONTROL_STATUS_SUCCESS                              (0x00000000)
#define NV006B_CONTROL_STATUS_ERROR_BAD_FLAGS_PUT                  (0x00000002)
#define NV006B_CONTROL_STATUS_ERROR_BAD_FLAGS_JUMP                 (0x00000003)
#define NV006B_CONTROL_STATUS_ERROR_BAD_PUT                        (0x00000004)
#define NV006B_CONTROL_STATUS_ERROR_BAD_JUMP                       (0x00000005)
#define NV006B_CONTROL_INFO_EMPTY_AND_IDLE                         (0x00000000)
#define NV006B_CONTROL_INFO_BUSY                                   (0x00000001)
#define NV006B_CONTROL_FLAGS_PUT                                            3:0
#define NV006B_CONTROL_FLAGS_PUT_IGNORE                            (0x00000000)
#define NV006B_CONTROL_FLAGS_PUT_UPDATE                            (0x00000001)
#define NV006B_CONTROL_FLAGS_JUMP                                          31:4
#define NV006B_CONTROL_FLAGS_JUMP_IGNORE                           (0x00000000)
#define NV006B_CONTROL_FLAGS_JUMP_REGISTER                         (0x00000001)
#define  NV006B_TYPEDEF                                          nv03ChannelDma
/* method offsets, fields, and values */
#define NV006B_NUMBER_OF_SUBCHANNELS                                        (8)
#define NV006B_SET_OBJECT                                          (0x00000000)
#define NV006B_U                                                   (0x00000100)


 /***************************************************************************\
|*                               PIO Channels                                *|
 \***************************************************************************/


/* class NV03_CHANNEL_PIO */
#define  NV03_CHANNEL_PIO                                          (0x0000006A)
#define NV006A_ALLOC_STATUS_SUCCESS                                (0x00000000)
#define NV006A_ALLOC_STATUS_ERROR_INSUFFICIENT_RESOURCES           (0x00000002)
#define NV006A_ALLOC_STATUS_ERROR_BAD_OBJECT_NEW                   (0x00000003)
#define NV006A_ALLOC_STATUS_ERROR_BAD_OBJECT_PARENT                (0x00000004)
#define NV006A_ALLOC_STATUS_ERROR_BAD_LIMIT                        (0x00000005)
#define NV006A_FREE_STATUS_SUCCESS                                 (0x00000000)
#define NV006A_FREE_STATUS_ERROR_OBJECT_IN_USE                     (0x00000002)
#define NV006A_CONTROL_STATUS_SUCCESS                              (0x00000000)
#define NV006A_CONTROL_INFO_EMPTY_AND_IDLE                         (0x00000000)
#define NV006A_CONTROL_INFO_BUSY                                   (0x00000001)
/* Nv0001Error[].status values */
#define NV006A_ERROR_STATUS_FIFO_OVERRUN                           (0x00000001)
#define NV006A_ERROR_STATUS_ILLEGAL_WRITE                          (0x00000002)
#define NV006A_ERROR_STATUS_ILLEGAL_READ                           (0x00000004)
#define NV006A_ERROR_STATUS_BAD_SIZE                               (0x00000008)
#define NV006A_ERROR_STATUS_BAD_ALIGNMENT                          (0x00000010)

#define NV006A_TYPEDEF                                           nv03ChannelPio


 /***************************************************************************\
|*                            Well Known Objects                             *|
 \***************************************************************************/


/* object NV01_NULL_OBJECT */
#define   NV01_NULL_OBJECT                                         (0x00000000)


 /***************************************************************************\
|*                                   Ports                                   *|
 \***************************************************************************/


/* NV01_DEVICE (PCI) */
#define NV0003_ALLOC_PORT_ID_PCI_INSTANCE                                   2:0
#define NV0003_ALLOC_PORT_ID_PCI_SLOT                                       7:3
#define NV0003_ALLOC_PORT_ID_PCI_BUS                                       15:8
#define NV0003_ALLOC_PORT_ID_PCI_IGNORE                                   31:16

