#include <stdarg.h>

extern long long GetCpuTime() ;

extern unsigned  char InPB(unsigned long) ;
extern unsigned short InPW(unsigned long) ;
extern unsigned  long InPL(unsigned long) ;
extern unsigned char InIPB(unsigned long , unsigned char) ;

extern void  OutPB(unsigned long , unsigned  char) ;
extern void  OutPW(unsigned long , unsigned short) ;
extern void  OutPL(unsigned long , unsigned  long) ;
extern void OutIPB(unsigned long , unsigned char , unsigned  char) ;
 
extern void SerialInit(void) ;
extern void SerialTxString(void *) ;

extern void DebugPrint(const char * ,...) ;

typedef struct 
{
  unsigned long portadd   ; 
  unsigned long IrqHW     ;
  unsigned long IrqVector ;
  unsigned long BaurdRate ;
  unsigned long RefClk    ;
} _Serial16550 ;

extern unsigned long FPU_test(unsigned long) ;

extern   long double FPU_round(long double) ;
extern   long double FPU_add(long double , long double ) ;
extern   long double FPU_sub(long double , long double ) ;
extern   long double FPU_mul(long double , long double ) ;
extern   long double FPU_sub(long double , long double ) ;
extern   long double FPU_fsqrt(long double , long double ) ;
extern   long double FPU_sin(long double) ;
extern   long double FPU_cos(long double) ;
extern   long double FPU_tan(long double) ;
extern   long double FPU_atan(long double) ;
extern   long double FPU_pi() ;

extern long double testre() ;
